package com.hamaf.hikyaku.dataobject;

import java.lang.reflect.Field;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * <p>^CgFDetailItemsBase is DetailItemsInterface implementation base class.</p>
 * <p>Ff[^擾p̊{ۃNX</p>
 * <br>pNXł̗p@
 * <ol>
 *   <li>ږ̍ڔԍ`<code>public final static int</code>Œ`
 *   <li><code>pkeys</code>ɃvC}L[̍ڔԍintzŒ`
 * </ol>
 * <code>String constCond</code>ɏݒ肷ƁAꂪt܂Bi<code>AND</code>j
 * i"AND"͕svłj
 * <br><code>String group</code>ɏWvږ','Ōqݒ肷<b>Group By</b>傪܂B
 * <br>Tv
 * <pre>
 * public class XxxxxDetailItemsInstance extends DetailItemsBase {
 *
 *    // DBږ̂ŃtB[h` (l 0 珇Ԃɐݒ肷邱)
 *    public final static int USER_ID = 0;
 *    public final static int USER_NAME = 1;
 *    public final static int MAIL_ADDR = 2;
 *    public final static int Sample = 3;
 *    // DBږƈقȂꍇ iL Samplejȉ̂悤ɂāAږw肷
 *    // pkeysŎw肳ꂽڈȊOł̓ꍀڂ̂Qd`͕słB
 *    public final static String Sample_FIELD = "ۂ̍ږ";
 *
 *    public XxxxxDetailItemsInstance() {
 *      // PrimaryKeyڂڔԍŎw肷iȗj
 *      // ȗ̓e[u`PrimaryKeygp܂
 *      pkeys = new int[]{0};         // new int[]{USER_ID}; ł
 *    }
 * }
 * </pre>
 *
 * <p>쌠: Copyright (c) 2004/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class DetailItemsBase implements DetailItemsInterface {

  protected int[] pkeys = null;

  private Map<Integer, String> _items = new HashMap<Integer, String>();
  private Map<Integer, String> _itemVal = new HashMap<Integer, String>();
  private Map<String, Integer> _itemNo = new HashMap<String, Integer>();
  private Map<COMMFLD, String> _comtbl = new HashMap<COMMFLD, String>();
  private String _group = null;
  private String _constCond = "";
  private String _sysId = null;
  private boolean _notFound = false;

  public DetailItemsBase() {
    init();
  }

  private void init() {
    Field[] flds = this.getClass().getFields();
    for (Field fld : flds) {
      if (fld.getType().getName().equals("int")) {
        try {
          int p = fld.getInt(this);
          if (!_items.containsKey(p)) {
            _itemNo.put(fld.getName().toUpperCase(), p);
            _items.put(p, fld.getName());
          }
        } catch (Exception xe) { }
      }
    }
    for (Field fld : flds) {
      if (fld.getType().getName().endsWith("String")) {
        StringBuilder nm = new StringBuilder(fld.getName());
        if (nm.toString().toUpperCase().endsWith("_FIELD")) {
          nm.setLength(nm.length() - 6);
          String nmu = nm.toString().toUpperCase();
          if (_itemNo.containsKey(nmu)) {
            try {
              String fldnm = (String)fld.get(this);
              _items.put(_itemNo.get(nmu), fldnm);
              _itemNo.put(fldnm.toUpperCase(), _itemNo.get(nmu));
            } catch (Exception xe) { }
          }
        }
      }
    }
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.DetailItemsInterface#setRequestItem(int)
   */
  public final void setRequestItem(int item) throws IllegalArgumentException {
    checkParam(item);
    if (!_itemVal.containsKey(item)) {
      _itemVal.put(item, "");
    }
  }

  /**
   * Describe <code>checkParam</code> method : check item_no parameter.
   * <br>p[^œn鍀ڔԍ̑Ó`FbNB
   * <br>G[̏ꍇAO(<code>IllegalArgumentException</code>)𓊂܂B
   * @param no an <code>int</code> : ڔԍ
   * @throws IllegalArgumentException
   */
  private final void checkParam(int no) throws IllegalArgumentException {
    if (!_items.containsKey(no)) {
      throw new IllegalArgumentException("itemNo is " + no);
    }
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.DetailItemsInterface#getItemCount()
   */
  public final int getItemCount() {
    return _items.size();
  }

  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#geFieldNameList()
	 */
	@Override
	public Collection<String> getFieldNameList() {
		return _items.values();
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getItemNoList()
	 */
	@Override
	public Set<Integer> getItemNoList() {
		return _items.keySet();
	}

	/* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.DetailItemsInterface#isRequestItem(int)
   */
  public final boolean isRequestItem(int no) {
    return _itemVal.containsKey(no);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#isKeyFld(int)
   */
  public boolean isKeyFld(int no) {
    if (pkeys == null) {
      return false;
    }
    for (int kint : pkeys) {
      if (kint == no) return true;
    }
    return false;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#clearRequest(int)
   */
  public final void clearRequest(int item) throws IllegalArgumentException {
    _itemVal.remove(item);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setAllRequest()
   */
  public final void setAllRequest() {
    for (int i : _items.keySet()) {
      if (!_itemVal.containsKey(i)) {
        _itemVal.put(i, "");
      }
    }
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.DetailItemsInterface#setItemValue(int, java.lang.String)
   */
  public final void setItemValue(int item, String val) throws IllegalArgumentException {
    checkParam(item);
    _itemVal.put(item, val);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setFldValue(java.lang.String, java.lang.String)
   */
  public final void setFldValue(String fld, String val) {
    String fldu = fld.toUpperCase();
    if (_itemNo.containsKey(fldu)) {
      _itemVal.put(_itemNo.get(fldu), val);
    }
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.DetailItemsInterface#getItemValue(int)
   */
  public final String getItemValue(int item) throws IllegalArgumentException {
    checkParam(item);
    String ret = _itemVal.get(item);
    if (ret == null) {
      ret = "";
    }
    return ret;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getFldValue(java.lang.String)
   */
  public String getFldValue(String fld) {
    String fldu = fld.toUpperCase();
    if (!_itemNo.containsKey(fldu)) {
      return "";
    }
    return _itemVal.get(_itemNo.get(fldu));
  }

  /* ( Javadoc)
   * @see jp.co.mori.housing.mbuss.dataobj.InstanceAccessInf#isNotFound()
   */
  public final boolean isNotFound() {
    return _notFound;
  }

  /* ( Javadoc)
   * @see jp.co.mori.housing.mbuss.dataobj.InstanceAccessInf#setNotFound()
   */
  public final void setNotFound() {
    _notFound = true;
  }

  /* ( Javadoc)
   * @see jp.co.mori.housing.mbuss.dataobj.InstanceAccessInf#clearNotFound()
   */
  public final void clearNotFound() {
    _notFound = false;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setCommFld(com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD, java.lang.String)
   */
  public final void setCommFld(COMMFLD fld, String val) {
    if (fld == COMMFLD.DEL) {
      if (!USE_FLG.USE.getVal().equals(val) && !USE_FLG.DEL.getVal().equals(val)) {
        val = USE_FLG.DEL.getVal();
      }
    }
    _comtbl.put(fld, val);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getCommFld(com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD)
   */
  public final String getCommFld(COMMFLD fld) {
    String val = _comtbl.get(fld);
    if (val == null) val = "";
    return val;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getFields()
   */
  public final String getField(int pos) {
    return _items.get(pos);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getKeyFlds()
   */
  public final int[] getKeyFlds() {
    return pkeys;
  }


  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getSysId()
   */
  public final String getSysId() {
    return _sysId;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setSysId()
   */
  public final void setSysId(String sysId) {
    _sysId = sysId;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getConstCond()
   */
  public final String getConstCond() {
    return _constCond;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setConstCond()
   */
  public final void setConstCond(String constCond) {
    _constCond = constCond;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#getGroup()
   */
  public final String getGroup() {
    return _group;
  }
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.DetailItemsInterface#setGroup()
   */
  public final void setGroup(String group) {
    _group = group;
  }

	/* ( Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(this.getClass().getName());
		sb.append("\n----- set Items -----\n");
		sb.append(_items.toString());
		sb.append(_itemVal.toString());
		sb.append("\n----- common fields -----\n");
		sb.append(_comtbl.toString());
		sb.append("\n----- expansion fields -----");
		sb.append("\n  group : ");
		sb.append(_group);
		sb.append("\n  sysId : ");
		sb.append(_sysId);
		sb.append("\n  Cond  : ");
		sb.append(_constCond);
		sb.append("\n  notFound : ");
		sb.append(_notFound);
		return sb.toString();
	}

}
