package com.hamaf.hikyaku.dataobject;

import java.lang.instrument.IllegalClassFormatException;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.hamaf.hikyaku.containar.DiContainer;
import com.hamaf.hikyaku.containar.DiFactory;


/**
 * <p>^CgFDtoMapping is Dtoʒ`̃x[XNX.</p>
 * <p>FDetailItemsInterface,RetriveKeyInterface̕ʒ`sȂB</p>
 * <br>abstractNXȂ̂<b>extends(p)</b>ėpB
 * <br>pNX́AsetClass(),addMapping()pă}bsO`܂B
 * <pre>
 * Tv
 *   public class XxxDtoMap extends DtoMapping {
 *     public XxxDtoMap() {
 *       setClass(DetailItems1.class, DetailItems2.class);
 *       addMapping(DetailItems1.ITEM1, DetailItems2.ITEMA);
 *         E
 *          E
 *          E
 *     }
 *   }
 *   
 * p@
 *   DetailItems1 di1 = new DetailItems1();
 *     E
 *      E
 *   DetailItems2 di2 = (DetailItems2)CopyDtoUtil.newDto(XxxDtoMap, di1);
 * </pre>
 * 
 * <p>쌠: Copyright (c) 2007/06/05</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class DtoMapping {
  
  private Class<?> _cls1 = null;
  private Class<?> _cls2 = null;
  
  private Map<Integer, Integer> _dtmap1 = new HashMap<Integer, Integer>();
  private Map<Integer, Integer> _dtmap2 = new HashMap<Integer, Integer>();
  
  /**
   * Describe <code>setClass</code> method : define mapping class.
   * <br>}bsONXۑB
   * @param class1 a <code>String</code> : Class1 ̃NX
   * @param class2 a <code>String</code> : Class2 ̃NX
   */
  protected final void setClass(String class1, String class2) {
    _cls1 = cnvClass(class1);
    _cls2 = cnvClass(class2);
  }
  private Class<?> cnvClass(String name) {
    try {
      return Class.forName(name);
    } catch (ClassNotFoundException xe) {
      xe.printStackTrace();
    }
    return null;
  }
  
  /**
   * Describe <code>setClass</code> method : define mapping class.
   * <br>}bsONXۑB
   * <br><b>defineMap()</b>ł̂ݎgp܂B
   * @param cls1 a <code>Class</code>
   * @param cls2 a <code>Class</code>
   */
  protected final void setClass(Class<?> class1, Class<?> class2) {
    _cls1 = class1;
    _cls2 = class2;    
  }

  /**
   * Describe <code>addMapping</code> method : define mapping items.
   * <br>Ήt鍀ڔԍۑB
   * <br><b>defineMap()</b>ł̂ݎgp܂B
   * @param pos1 an <code>int</code> : cls1Dto Class ̍ڔԍ
   * @param pos2 an <code>int</code> : cls2Dto Class ̍ڔԍ
   */
  protected final void addMapping(int pos1, int pos2) {
    _dtmap1.put(pos1, pos2);
    _dtmap2.put(pos2, pos1);
  }

  /**
   * Describe <code>createCorrespondingClass</code> method : create new corresponding class.
   * <br>ΉNX̃CX^X𐶐Ė߂B
   *
   * @param cls a <code>Class</code> : ʌ̃NX
   * @return an <code>Object</code> : ΉNX
   * @exception Exception if an error occurs
   */
  public final Object createCorrespondingClass(Class<?> cls)
    throws Exception {
    if (cls == null) {
      throw new IllegalArgumentException("class is null!");
    }
    checkClass();
    if (cls.equals(_cls1)) {
      return _cls2.newInstance();
    }
    if (cls.equals(_cls2)) {
      return _cls1.newInstance();
    }
    throw new IllegalArgumentException(cls.getName() + " is not setting class!!");
  }
  
  /**
   * Describe <code>createCorrespondingClass</code> method : create new corresponding class.
   * <br>DiCOntainerɂΉNX̃CX^X𐶐Ė߂B
   *
   * @param sysId a <code>String</code> : VXeID
   * @param cls a <code>Class</code> : ʌ̃NX
   * @return an <code>Object</code> : ΉNX
   * @exception Exception if an error occurs
   */
  public final Object createCorrespondingClass(String sysId, Class<?> cls)
  throws Exception {
    if (cls == null) {
      throw new IllegalArgumentException("class is null!");
    }
    checkClass();
    DiContainer di = DiFactory.getInstance().getContainer(sysId);
    if (cls.equals(_cls1)) {
      return di.getComponent(_cls2);
    }
    if (cls.equals(_cls2)) {
      return di.getComponent(_cls1);
    }
    throw new IllegalArgumentException(cls.getName() + " is not setting class!!");
  }
  
  /**
   * Describe <code>checkClass</code> method : check superclass class1,class2.
   * <br>class1class2̃X[p[NXꉻ`FbNB
   * <br>ŖꍇAO𓊂
   * 
   * @throws IllegalClassFormatException : class1class2̃X[p[NXsv 
   */
  public final void checkClass() throws IllegalClassFormatException {
    if (_cls1 == null) {
      throw new IllegalClassFormatException("class1 is null!");
    }
    if (_cls2 == null) {
      throw new IllegalClassFormatException("class2 is null!");
    }
    if (!_cls1.getSuperclass().equals(_cls2.getSuperclass())) {
      throw new IllegalClassFormatException("class1.superclass is " + _cls1.getSuperclass().getName() +
          ", class2.superclass is " + _cls2.getSuperclass().getName());
    }
  }

  /**
   * Describe <code>getItemNoList</code> method : return items No List.
   * <br>w肳ꂽNXœo^ĂAڔԍ̃Xg߂B
   * @param cls a <code>Class</code> : ʌ̃NX
   * @return an <code>IntBuffer</code> : ڔԍ(<code>int</code>)̃Xg
   * @exception IllegalArgumentException if an error occurs
   */
  public final Set<Integer> getItemNoList(Object cls) throws IllegalArgumentException {
    return getMapping(cls).keySet();
  }
  private Map<Integer, Integer> getMapping(Object cls) throws IllegalArgumentException {
    if (cls.getClass().equals(_cls1)) {
      return _dtmap1;
    }
    if (cls.getClass().equals(_cls2)) {
      return _dtmap2;
    }
    throw new IllegalArgumentException(cls.getClass().getName() + " is not setting class!!");
  }

  /**
   * Describe <code>getCorrespondingPos</code> method : return collesponding item No.
   * <br>Ή鍀ڔԍ߂B
   *
   * @param cls a <code>Object</code> : ʌ̃NX
   * @param pos an <code>int</code> : ʂ鍀ڔԍ
   * @return an <code>int</code> : Ή鍀ڔԍ
   */
  public final int getCorrespondingPos(Object cls, int pos) {
    return getMapping(cls).get(pos);
  }

}
