package com.hamaf.hikyaku.dataobject;

import java.io.ByteArrayInputStream;
import com.hamaf.hikyaku.util.ComUtils;


/**
 * <p>^CgFMultiCommonMessage is MultipartpCommonMessage.</p>
 * <p>F<code>multipart/form-data</code>postꂽꍇɎgpAʃbZ[W</p>
 * <br>ȉ̗̈ǉĂ܂B
 * <ul>
 *   <li>fileName - Mꂽt@C̃pX
 *   <li>contentType - Mt@CContent-Type
 *   <li>fileSize - Mt@C̃TCY
 *   <li>input - Mꂽt@C (t@Cւ̏osȂꍇj
 *   <li>isFile - t@C֏oꂽꍇ <b>true</b>
 *   <li>tempFileUrl - ot@C̃pX
 *   <li>maxSize - w肳Ăt@C̍őTCY
 * </ul>
 * <br>݂̂ƂPt@C̑MɂΉĂ܂B
 * 
 * <p>쌠: Copyright (c) 2004/03/02</p>
 * @author Hamanaka
 * @version 1.0
 */
public class MultiCommonMessage extends CommonMessage {
  
  private String _fileName = null;
  private String _contentType = null;
  private long _fileSize = 0;
  private ByteArrayInputStream _input = null;
  private boolean _isFile = false;
  private String _tempFileUrl = null;
  private String _maxSize = null;

  /**
   *  Creates a new <code>MultiCommonMessage.java</code> instance.
   * <br>Default Constructor
   * 
   */
  public MultiCommonMessage() {
    super();
  }
  
  /**
   * Describe <code>getFileName</code> method : return request file name.
   * <br>Mꂽt@C߂B
   * @return a <code>String</code> : request file name 
   */
  public final String getFileName() {
    return _fileName;
  }

  /**
   * Describe <code>getInput</code> method : return send file inputstream.
   * <br>Mt@CByteArrayInputStreamɕϊ̂߂B
   * @return a <code>ByteArrayInputStream</code> : Mt@C
   */
  public final ByteArrayInputStream getInput() {
    return _input;
  }

  /**
   * Describe <code>isFile</code> method : return is ave file.
   * <br>Mt@Ct@Cɏoꍇ<code>true</code>߂B
   * @return a <code>boolean</code> : true - TempFIleɕۑ
   */
  public final boolean isFile() {
    return _isFile;
  }

  /**
   * Describe <code>getTempFileUrl</code> method : return temp file path.
   * <br>ۑtempt@C̃pX߂B
   * @return a <code>String</code> : ۑt@C̃pX
   */
  public final String getTempFileUrl() {
    return _tempFileUrl;
  }

  /**
   * Describe <code>setFileName</code> method : setting request filename.
   * <br>Mꂽt@Cݒ肷B
   * @param argString a <code>String</code> : Mꂽt@C
   */
  public final void setFileName(String argString) {
    _fileName = argString;
  }

  /**
   * Describe <code>setInput</code> method : setting inputStream.
   * <br>Mt@CByteArrayInputStreamɕϊ̂ݒ肷B
   * @param argStream a <code>ByteArrayInputStream</code> : Mt@CinputStream
   */
  public final void setInput(ByteArrayInputStream argStream) {
    _input = argStream;
  }

  /**
   * Describe <code>setFile</code> method : setting write temp file.
   * <br>Mꂽt@Ctemp file ɏoꍇ<code>true</code>ɐݒ肷
   * @param argB a <code>boolean</code> : true - TempFIleɕۑ
   */
  public final void setFile(boolean argB) {
    _isFile = argB;
  }

  /**
   * Describe <code>setTempFileUrl</code> method : setting temp file path.
   * <br>ۑtemp FilẽpXݒ肷B
   * @param argString a <code>String</code> : Temp FilẽpX
   */
  public final void setTempFileUrl(String argString) {
    _tempFileUrl = argString;
  }

  /**
   * Describe <code>getFileSize</code> method : return FIle size.
   * <br>Mt@C̃oCg߂B
   * @return a <code>long</code> : Mt@C̃oCg
   */
  public final long getFileSize() {
    return _fileSize;
  }

  /**
   * Describe <code>setFileSize</code> method : setting File size.
   * <br>Mt@C̃oCgݒ肷B
   * @param argL a <code>long</code> : t@C̃oCg
   */
  public final void setFileSize(long argL) {
    _fileSize = argL;
  }

  /**
   * Describe <code>getMaxSize</code> method : return Max file size.
   * <br>w肳Ăőt@CTCY߂B
   * @return a <code>String</code> : őTCY
   */
  public final String getMaxSize() {
    return _maxSize;
  }

  /**
   * Describe <code>setMaxSize</code> method : setting Max File Size.
   * <br>őt@CTCYݒ肷B
   * @param argString a <code>String</code> : őt@CTCY
   */
  public final void setMaxSize(String argString) {
  	if (ComUtils.checkFIleSize(argString)) {
			_maxSize = "1M";
  	}
  	else {
			_maxSize = argString;
  	}
  }

  /**
   * Describe <code>getContentType</code> method : return Content Type.
   * <br>Mt@CContent-Type߂B
   * @return a <code>String</code> : Mt@CContent-Type
   */
  public final String getContentType() {
    return _contentType;
  }

  /**
   * Describe <code>setContentType</code> method : setting Content Type.
   * <br>Mt@CContent-Typeݒ肷B
   * @param argString a <code>void</code> : Mt@CContent-Type
   */
  public final void setContentType(String argString) {
    _contentType = argString;
  }
  
  /**
   * Describe <code>isSizeOver</code> method : check file size less max size.
   * <br>t@CTCYőTCY𒴂Ă邩`FbNB
   * @return a <code>boolean</code> : őTCŶƂA^itruej
   */
  public final boolean isSizeOver() {
  	return _fileSize > ComUtils.convertFileSize(_maxSize);
  }

}
