package com.hamaf.hikyaku.dataobject;

import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;

/**
 * <p>^CgFRetrieveKeysInterface is DB retrieve information and saved key items.</p>
 * <p>FvC}L[ꗗ擾p̃C^[tF[XB</p>
 * <br>ݒ肳ꂽŁAYKeÿꗗ擾ƂɎgpB
 * <br>˗NXł̎gp@
 * <ol>
 *   <li>ڂƂ̒l<code>setRetrieveValue()</code>Őݒ肷B
 *   <li>ڂƂ̌i=,>,<,in,like,between etc.)<code>setCondition()</code>Ŏw肷B
 *   <li>בւKvȏꍇ́A<code>setOrderItem()</code>ōڂƏԂݒ肷B
 *   <li>ʂ̔z(<code>List</code>)<code>getKeys()</code>Ŏ擾B
 *   <li>擾zAL[ڒl̔z(<code>List</code>)擾B
 * </ol>
 * Tv
 * <pre>
 *     XxxxxRetrieveKeysInstance xinst = new XxxxxRetrieveKeysInstance();
 *     xinst.setRetrieveValue(ڔԍ, "l");
 *     xinst.setCondition(ڔԍ, "LIKE");
 *     xinst.setOrderItem(ڔԍ,1);
 *     xinst = X____Get.xxx(xinst);
 *     List keys = xinst.getKeys();
 *     for (Iterator iter = keys.iterator(); iter.hasNext();) {
 *       List keysValue = (List) iter.next();
 *       // Lq
 *     }
 * </pre>
 * sNXł̎gp@
 * <ul>
 *   <li>pSQLWhere啶<code>getWhereString()</code>Ŏ擾B
 *   <li>擾ڂSelect啶<code>getSelectString()</code>Ŏ擾B
 *   <li>擾ڒl̍ڏɔz(<code>List</code>)𐶐B
 *   <li>z(<code>List</code>)<code>addKey()</code>ňꌏo^邩A
 *       <br><code>setKeys()</code>ł܂Ƃ߂ēo^B
 * </ul>
 * <br>ӁFL[ڒlƂĔz(<code>List</code>)ł͖A
 * (<code>String</code>)gpĂǂB
 * <br>Tv
 * <pre>
 *    StringBuffer sb = new StringBuffer();
 *    sb.append(Dto2SqlUtils.getSelectItemsWithExclusion(xinst));
 *    sb.append(" FROM UserInfTbl ");
 *    sb.append(Dto2SqlUtils.getWhereString(xinst));
 *    result = statment.executeQuery(sb.toString());
 *    while (result.next()) {
 *      List ls = new ArrayList();
 *      ls.add(result.getString(result, 1));
 *      ls.add(result.getString(result, 2));
 *      xinst.addKey(ls);
 *    }
 *    rs.close();
 * </pre>
 *
 * <p>쌠: Copyright (c) 2004/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public interface RetrieveKeysInterface extends Iterable<List<String>> {
  
  /**
   * Method setRetrieveValue is set retrieve item value.
   * <br>ڂƂ̒lݒ肷B
   * <br>"<b>IN</b>"̏ꍇ́A'l','l',EEEݒ肵A
   * "<b>BETWEEN</b>̏ꍇ́A'l' AND 'l' ݒ肷B
   * @param item an <code>int</code> : ڔԍ
   * @param val a <code>String</code> : l
   * @throws IllegalArgumentException
   */
  public void setRetrieveValue(int item, String val) throws IllegalArgumentException;

  /**
   * Method getRetriveValues is return retrive item value.
   * <br>ݒ肳Ă錟lnB
   * <br>lMap&lt;ڔԍ(Integer),l(String)&ge;Őݒ肳B
   * @return a <code>Map&lt;Integer, String&gt;</code> : lݒ肳ĂMap
   * @exception IllegalArgumentException
   */
  public Map<Integer, String> getRetriveValues();
  
  /**
   * Method setRetriveCondition is set retrieve condition.
   * <br>i"=","<","IN","LIKE","BETWEEN","IS" etc.jݒ肷B
   * <br>KĺA("=")ƂB
   * @param item an <code>int</code> : ڔԍ
   * @param cond a <code>String</code> : 
   * @throws IllegalArgumentException
   */
  public void setCondition(int item, String cond) throws IllegalArgumentException;

  /**
   * Method getConditions is return retrieve condition.
   * <br>ݒ肳Ă錟nB
   * <br>Map&lt;ڔԍ(Integer),(String)&ge;Őݒ肳B
   * @return a <code>Map&lt;Integer, String&gt;</code> : ݒ肳ĂMap
   * @throws IllegalArgumentException
   */
  public Map<Integer, String> getConditions();

  /**
   * Method setOrderItem is set order.
   * <br>\̐ݒsB
   * <br>\́Aёւڏɏlݒ肷B
   * <br>̕\ݒ肳ꂽꍇ͕̓sB
   * <br>Kl͏ƂA~Ƃꍇ́A\Ƀ}CiXlŎw肷B
   * <br>}CiXlw肵ꍇ́AΒlƂB
   * @param item an <code>int</code> : ڔԍ
   * @param seq an <code>int</code> : \
   * @throws IllegalArgumentException
   */
  public void setOrderItem(int item, int seq) throws IllegalArgumentException;

  /**
   * Method getOrderItems is return order information.
   * <br>ݒ肳Ă\nB
   * <br>ёւMap&lt;\(Integer),ږ+я(String)&ge;Őݒ肳B
   *
   * @return an <code>Map&lt;Integer, String&gt;</code> : \
   */
  public Map<Integer, String> getOrderItems();
  
  /**
   * Describe <code>getOrderPos</code> method : setting orderinf.
   * <br>\̎wl̂܂ܕԂB
   * 
   * @return a <code>Map<Integer,Integer></code> : w肳ꂽ\
   */
  public Map<Integer, Integer> getOrderPos();
  
  /**
   * Describe <code>ItemCount</code> method : return items count.
   * <br>ڐ߂B
   * <br>
   * @return an <code>int</code> : L[ڐ 
   */
  public int itemCount();

  /**
   * Describe <code>keyCount</code> method : return key items count.
   * <br>L[ڐ߂B
   * <br>
   * @return an <code>int</code> : L[ڐ 
   */
  public int keyCount();

  /**
   * Describe <code>getItem</code> method : return item value.
   * <br>w肳ꂽʒu̍ړe߂B
   * 
   * @param pos : ڔԍ
   * @return a <code>String</code> : tB[h
   * @throws IllegalArgumentException
   */
  public String getItem(int pos) throws IllegalArgumentException;

  /**
   * Describe <code>getKeyItem</code> method : return item value.
   * <br>w肳ꂽʒuKeyږ߂B
   * 
   * @param pos an <code>int</code> : Keyڂ̔ԍ
   * @return a <code>String</code> : tB[h
   * @throws IllegalArgumentException
   */
  public String getKeyItem(int pos) throws IllegalArgumentException;
  
  /**
   * Method clearKeys is clear key item value.
   * <br>Keyڒl̕ۑ̈B
   */
  public void clearKeys();
  
  /**
   * Method addKey is add key item value.
   * <br>Ŏ擾ꂽR[hKeyڒlo^B
   * @param key an <code>Object</code> : L[l
   */
  public void addKey(List<String> key);

  /**
   * Method setKeys is set all key item value.
   * <br>Ŏ擾R[h̃L[lꊇēo^B
   * <br>L[l͈̃XgłׂĒu܂B
   * @param keys a <code>List</code> : L[lݒ肳ꂽXg
   */
  public void setKeys(List<List<String>> keys);

  /**
   * Method getKeys is return key item list.
   * <br>L[ڒl̃Xg߂B
   * @return List
   */
  public List<List<String>> getKeys();
  
  /**
   * @return VXeID
   */
  public String getSysId();
  /**
   * @param del : VXeID ݒ肵܂B
   */
  public void setSysId(String del);

  /**
   * @return 폜tO
   */
  public USE_FLG getDel();
  /**
   * @param del : 폜tO ݒ肵܂B
   */
  public void setDel(USE_FLG del);

  /**
   * Describe <code>setConstCond</code> method : set Additional Condition.
   * <br>ǉ̌ݒ肷B
   * 
   * @param constCond@a <code>String</code> : ǉ̌
   */
  public void setConstCond(String constCond);
  /**
   * Describe <code>getAddCondition</code> method : return Additional Condition.
   * <br>ǉ̌߂B
   * 
   * @return a <code>String</code> : ǉ̌
   */
  public String getConstCond();
  
  /**
   * Describe <code>setPkeyFld</code> method : set PrimaryKey Fields Name.
   * <br>L[ږ̃Xgݒ肷B
   * 
   * @param keys a <code></code> : L[ڂ̃tB[h
   */
  public void setPkeyFld(List<String> keys);
  /**
   * Describe <code>getPkeyFld</code> method : return PrimaryKeu Fields Name.
   * <br>L[ږ̃Xg߂B
   *
   * @return a <code>List</code> : L[ڂ̃tB[h 
   */
  public List<String> getPkeyFld();
}
