package com.hamaf.hikyaku.dataobject;

import java.text.DateFormat;
import java.text.MessageFormat;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFUnitItemCheck is Item Check Class.</p>
 * <p>FPꍀڃ`FbNpNX</p>
 * <br>`FbNe
 * <ul>
 *   <li>K{`FbN
 *   <li>K\ɂp^[`FbN
 *   <li>͈̓`FbN
 *   <li>lXgɂ`FbN
 *   <li>ő啶ɂ`FbN
 * </ul>
 * <br>ȉ̃vpeB̒lݒ肵A<code>check()</code>\bhĂяo܂B
 * <ul>
 *   <li>name a <code>String</code> : `FbN鍀ږ
 *   <li>required a <code></code> : K{̏ꍇ<code>true</code>
 *   <li>pattern a <code>String</code> : ͌`𐳋K\Ŏw肷
 *   <li>rangeFrom a <code>String</code> : ͈͂̍ŏl
 *   <li>rangeTo a <code>String</code> : ͈͂̍ől
 *   <li>values a <code>String</code> : l̃Xgi","ŋ؂Ďwj
 *   <li>length a <code>String</code> : ő啶
 *   <li>reqmsg a <code>String</code> : K{G[̏ꍇ̃bZ[Wiw莞AWŕ\j
 *   <li>patmsg a <code>String</code> : `G[̏ꍇ̃bZ[Wiw莞AWŕ\j
 *   <li>rngmsg a <code>String</code> : ͈̓G[̏ꍇ̃bZ[Wiw莞AWŕ\j
 *   <li>valmsg a <code>String</code> : lXgG[̏ꍇ̃bZ[Wiw莞AWŕ\j
 *   <li>lenmsg a <code>String</code> : G[̏ꍇ̃bZ[Wiw莞AWŕ\j
 *   <li>numeric a <code>boolean</code> : lڂ̂Ƃ true
 * </ul>
 * <br>Lp[^ݒ肵XmlEncoderC[Wō쐬ꂽXml
 * <br>XMLDecoderɂ藘p邱Ƃz肵Ă܂B
 *
 * <p>쌠: Copyright (c) 2008/09/02</p>
 * @author hamanaka
 * @version 1.0
 */
public class UnitItemCheck {

  private String _name = null;
  private boolean _required = false;
  private String _pattern = null;
  private boolean _numeric = false;
  private String _rangeFrom = null;
  private String _rangeTo = null;
  private String _values = null;
  private String _length = null;

  private String _reqmsg = null;
  private String _patmsg = null;
  private String _rngmsg = null;
  private String _valmsg = null;
  private String _lenmsg = null;

  private boolean _gaiji = true;

  ResourceBundle _res = ResourceBundle.getBundle(FLNM);

  /**
   *  Creates a new <code>UnitItemCheck.java</code> instance.
   * <br>Default Constructor
   *
   */
  public UnitItemCheck() {
  }

  private static final String FLNM = "ItemErrorMessage";
  /**
   * Describe <code>check</code> method : item check for propeaties.
   * <br>vpeBɂčڃ`FbNs
   * <br>G[̏ꍇ<b>CommonMessage</b>ErrorStatusWARNINGyуG[bZ[Wݒ肳܂B
   * @param msg a <code>CommonMessage</code> : `FbN鍀ڐݒ肳ĂCommonMessage
   * @return a <code>CommonMessage</code> : ݒ肵CommonMessage
   */
  public CommonMessage check(CommonMessage msg) {


    String _item = msg.getReqStr(_name);
    if (_item.length() == 0) {
      if (_required) {
        msg.setErrorStatus(STATUS.WARNING);
        if (_reqmsg == null || _reqmsg.length() == 0) _reqmsg = _res.getString("ERR01");
        msg.setResMsg(_name, _reqmsg);
      }
      return msg;
    }

    try {
      if (checkLength(_item)) {
        msg.setErrorStatus(STATUS.WARNING);
        if (_lenmsg == null || _lenmsg.length() == 0) _lenmsg = _res.getString("ERR07");
        Object[] mparm = {String.valueOf(_item.length()), _length};
        msg.setResMsg(_name, MessageFormat.format(_lenmsg, mparm));
        return msg;
      }
    } catch (Exception e) {
      msg.setErrorStatus(STATUS.WARNING);
      Object[] mparm = {_name, "Length", _length, e.getMessage()};
      msg.setResMsg(_name, MessageFormat.format(_res.getString("ERR99"), mparm));
      return msg;
    }

    try {
      if (checkPattern(_item)) {
        msg.setErrorStatus(STATUS.WARNING);
        if (_patmsg == null || _patmsg.length() == 0) {
          if (_numeric) {
            _patmsg = _res.getString("ERR03");
          }
          else {
            _patmsg = _res.getString("ERR02");
          }
        }
        msg.setResMsg(_name, _patmsg);
        return msg;
      }
    }
    catch (Exception e) {
      msg.setErrorStatus(STATUS.WARNING);
      Object[] mparm = {_name, "pattern", _pattern, e.getMessage()};
      msg.setResMsg(_name, MessageFormat.format(_res.getString("ERR99"), mparm));
      return msg;
    }

    try {
      if (checkRange(_item)) {
        msg.setErrorStatus(STATUS.WARNING);
        if (_rngmsg == null || _rngmsg.length() == 0) _rngmsg = _res.getString("ERR04");
        Object[] mparm = {_rangeFrom, _rangeTo};
        msg.setResMsg(_name, MessageFormat.format(_rngmsg, mparm));
        return msg;
      }
    }
    catch (Exception e) {
      msg.setErrorStatus(STATUS.WARNING);
      Object[] mparm = {_name, "rangeFrom,rangeTo", _rangeFrom + "," + _rangeTo, e.getMessage()};
      msg.setResMsg(_name, MessageFormat.format(_res.getString("ERR99"), mparm));
      return msg;
    }

    try {
      if (checkValus(_item)) {
        msg.setErrorStatus(STATUS.WARNING);
        if (_valmsg == null || _valmsg.length() == 0) _valmsg = _res.getString("ERR05");
        Object[] mparm = {_values};
        msg.setResMsg(_name, MessageFormat.format(_valmsg, mparm));
      }
    }
    catch (Exception e) {
      msg.setErrorStatus(STATUS.WARNING);
      Object[] mparm = {_name, "values", _values, e.getMessage()};
      msg.setResMsg(_name, MessageFormat.format(_res.getString("ERR99"), mparm));
    }

    if (_gaiji) {
      if (!_numeric) {
        int pos = _item.indexOf("\uFFFD");
        if (pos < 0) {
          try {
            String chkSt = new String(_item.getBytes("MS932"), "Shift_JIS");
            pos = chkSt.indexOf("\uFFFD");
          } catch (Exception ex) {
          }
        }
        if (pos >= 0) {
          msg.setErrorStatus(STATUS.WARNING);
          Object[] mparm = {Integer.toString(pos+1)};
          msg.setResMsg(_name, MessageFormat.format(_res.getString("ERR06"), mparm));
        }
      }
    }
    return msg;
  }

  private boolean checkPattern(String item) throws Exception {
    if (_pattern == null || _pattern.length() == 0) {
      return false;
    }
    if (_pattern.toLowerCase().equals("date")) {
      return checkDate(item);
    }
    Pattern _pt = Pattern.compile(_pattern);
    Matcher _mt = _pt.matcher(item);
    if (!_mt.matches()) {
      return true;
    }
    return false;
  }
  private boolean checkDate(String item) throws Exception {
    Pattern _pt = Pattern.compile("[0-9]{4}/[0-9]{2}/[0-9]{2}");
    Matcher _mt = _pt.matcher(item);
    if (!_mt.matches()) {
      return true;
    }
    DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.JAPAN);
    df.setLenient(false);
    try {
      df.parse(item);
    } catch (Exception xe) {
      return true;
    }
    return false;
  }

  private boolean checkRange(String item) throws Exception {
    if (_rangeFrom == null || _rangeFrom.length() == 0) {
      if (_rangeTo != null && _rangeTo.length() > 0) {
        throw new IllegalArgumentException(_res.getString("ERR81"));
      }
      return false;
    }
    if ((_rangeTo == null || _rangeTo.length() == 0)) {
      throw new IllegalArgumentException(_res.getString("ERR81"));
    }

    if (!_numeric) {
      if (_rangeFrom.compareTo(_rangeTo) > 0) {
        throw new IllegalArgumentException(_res.getString("ERR82"));
      }
      if (item.compareTo(_rangeFrom) < 0 || item.compareTo(_rangeTo) > 0) {
        return true;
      }
      return false;
    }
    double itemL = Double.parseDouble(item);
    double rfL = Double.parseDouble(_rangeFrom);
    double rtL = Double.parseDouble(_rangeTo);
    if (rfL > rtL) {
      throw new IllegalArgumentException(_res.getString("ERR82"));
    }
    if (itemL < rfL || itemL > rtL) {
      return true;
    }
    return false;
  }

  private boolean checkValus(String item) throws Exception {
    if (_values == null || _values.length() == 0) {
      return false;
    }
    StringTokenizer stk = new StringTokenizer(_values, ",");
    double itemL = 0;
    if (_numeric) {
      itemL = Double.parseDouble(item);
    }
    while (stk.hasMoreTokens()) {
      String val = stk.nextToken();
      if (_numeric) {
        if (itemL == Double.parseDouble(val)) {
          return false;
        }
      }
      else {
        if (item.equals(val)) {
          return false;
        }
      }
    }
    return true;
  }

  private boolean checkLength(String item) throws Exception {
    if (_length == null || _length.length() == 0) {
      return false;
    }
    int cl = Integer.parseInt(_length);
    if (cl < item.length()) {
      return true;
    }
    return false;
  }

  //----- getter,setter definition

  public final boolean isRequired() {
    return _required;
  }

  public final String getPattern() {
    return _pattern;
  }

  public final String getRangeFrom() {
    return _rangeFrom;
  }

  public final String getRangeTo() {
    return _rangeTo;
  }

  public final String getValues() {
    return _values;
  }

  public final void setRequired(boolean argB) {
    _required = argB;
  }

  public final void setPattern(String argString) {
    _pattern = argString;
  }

  public final void setRangeFrom(String argString) {
    _rangeFrom = argString;
  }

  public final void setRangeTo(String argString) {
    _rangeTo = argString;
  }

  public final void setValues(String argString) {
    _values = argString;
  }

  public final String getName() {
    return _name;
  }

  public final void setName(String argString) {
    _name = argString;
  }

  public final boolean isNumeric() {
    return _numeric;
  }

  public final void setNumeric(boolean argB) {
    _numeric = argB;
  }

  public final String getLength() {
    return _length;
  }


  public final void setLength(String length) {
    _length = length;
  }


  /**
   * Describe <code>setGaiji</code> method : .
   * <br>B
   * <br>
   * @param b a <code>void</code> :
   */
  public final void setGaiji(boolean b) {
    _gaiji = b;
  }

  public final String getLenmsg() {
    return _lenmsg;
  }
  public final void setLenmsg(String lenmsg) {
    _lenmsg = lenmsg;
  }

  public final String getPatmsg() {
    return _patmsg;
  }
  public final void setPatmsg(String patmsg) {
    _patmsg = patmsg;
  }

  public final String getReqmsg() {
    return _reqmsg;
  }
  public final void setReqmsg(String reqmsg) {
    _reqmsg = reqmsg;
  }

  public final String getRngmsg() {
    return _rngmsg;
  }
  public final void setRngmsg(String rngmsg) {
    _rngmsg = rngmsg;
  }

  public final String getValmsg() {
    return _valmsg;
  }
  public final void setValmsg(String valmsg) {
    _valmsg = valmsg;
  }

}
