package com.hamaf.hikyaku.dataobject.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.util.ComUtils;


/**
 * <p>^CgFPreparedSqlUtil is Prepared SQL Utility.</p>
 * <p>FPrepared SQLp̃[eBeB</p>
 * <ul>
 *   <li>getResource :  ClassAMethodSQL̃\[X擾
 *       <br>Ώۃt@C:Class_Method.sql
 *   <li>getSQL : w肳ꂽ\[X(inputStreame)ǂݍ݁ASQLϊĖ߂
 *       <br>SQL͈ȉ̂悤ɋLq
 *       <br>/*n&#042;/  ږ = /*?L[l&#042;/'eXgl'
 *       <br>n:delLineŎw肷镶
 * </ul>
 * 
 * <p>쌠: Copyright (c) 2008/06/16</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PreparedSqlUtil {
  
  /**
   * Describe <code>getResource</code> method : get SQL File in classes.
   * <br>classesjarFileclassƓtH_[SQL`File擾B
   * <br>擾t@C class_Method.sql
   * 
   * @return a <code>InputStream</code> : 
   */
  public static final InputStream getResource() {
    Throwable t = new Throwable();
    StackTraceElement[] elem = t.getStackTrace();
    ClassLoader cl = Thread.currentThread().getContextClassLoader();
    String fl = cnvFilePath(elem);
    InputStream is = cl.getResourceAsStream(fl);
    if (is == null) {
    	try {
    		Class<?> c = Class.forName(elem[2].getClassName());
    		URL u = c.getResource(c.getSimpleName() + ".class");
    		String s = u.toExternalForm();
    		String jar = s.substring(0, s.lastIndexOf(c.getPackage().getName().replace(".", "/")));
				URL ul = new URL(jar + fl.replace(File.separatorChar, '/'));
				is = ul.openStream();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
    }
    return is;
  }
  /**
   * Describe <code>getResource</code> method : get SQL File at path.
   * <br>pXŎw肳ꂽtH_[SQL`File擾B
   * <br>擾t@C class_Method.sql
   * 
   * @param path a <code>String</code> : x[XƂȂpX
   * @return a <code>InputStream</code> : 
   */
  public static final InputStream getResource(String path) {
    Throwable t = new Throwable();
    StackTraceElement[] elem = t.getStackTrace();
    StringBuilder sb = new StringBuilder();
    sb.append(ComUtils.convPath(path, true));
    String fp = cnvFilePath(elem);
    int k = fp.lastIndexOf(File.separator);
    sb.append(fp.substring(k+1));
    File fl = new File(sb.toString());
    if (!fl.exists()) return null;
    try {
      return new FileInputStream(fl);
    } catch (Exception xe) { }
    return null;
  }
  private static String cnvFilePath(StackTraceElement[] elemnrbt) {
    StringBuilder sb = new StringBuilder();
    sb.append(elemnrbt[2].getClassName().replace('.', File.separatorChar));
    sb.append("_");
    sb.append(elemnrbt[2].getMethodName());
    sb.append(".sql");
    return sb.toString();
  }
  
  /**
   * Describe <code>getSql</code> method : creat SQL from stream.
   * <br>SQLLqꂽt@CSQL擾B
   * <br>̍ہA1ڂ/*n&#042;/Ŏw肳ꂽnAdelLineɑ݂ꍇA폜
   * @param del a <code>List</code> : 
   * @throws IOException a <code></code> : 
   * @return a <code>String</code> : 
   */
  public static final String getSql(InputStream is, List<String> del) throws IOException {
    BufferedReader br = new BufferedReader(
        new InputStreamReader(is));
    StringBuilder sb = new StringBuilder();
    String buf = br.readLine();
    while (buf != null) {
      if (sb.length() > 0) {
        sb.append("\n");
      }
      sb.append(delLine(buf, del));
      buf = br.readLine();
    }
    return sb.toString();
  }
  private static String delLine(String buf, List<String> del) {
    String chk = buf.trim().toUpperCase();
    if (!chk.startsWith("/*")) return buf;

    String cv = chk.substring(2, chk.indexOf("*/"));
    if (del.contains(cv)) return "";

    return buf.replaceFirst("/\\*\\S*?\\*/", " ");
  }

  /**
   * Describe <code>getKeyName</code> method : get IN Parameter name.
   * <br>/*?L[l&#042;/'eXgl'̃L[lԂɎ擾B
   * 
   * @param buf a <code>String</code> : ̕
   * @return a <code>List<String></code> : L[l̕
   */
  public static final List<String> getKeyName(String buf) {
    List<String> knm = new ArrayList<String>();
    int k = buf.indexOf("/*?");
    while (k >= 0) {
      int e = buf.indexOf("*/", k);
      knm.add(buf.substring(k+3, e).toUpperCase());
      k = buf.indexOf("/*?", e);
    }
    return knm;
  }
  
  /**
   * Describe <code>cnvINParm</code> method : conversion IN Paramater.
   * <br>/*?L[l&#042;/'eXgl' ? ɕϊB
   * 
   * @param buf a <code>String</code> : ϊΏۂ̕
   * @return a <code>String</code> : ϊ̕
   */
  public static final String cnvINParm(String buf) {
    String ret = buf.replaceAll("/\\*\\?.*?\\*/'.*?'", "?");
    return ret.replaceAll("'.*?'/\\*\\?.*?\\*/", "?");
  }
  
  /**
   * Describe <code>setKeys</code> method : set key value in RetrieveKeysInterface.
   * <br>PreparedItems ̌ʏ RetrieveKeysInterface keylɐݒ肷B
   * 
   * @param rki a <code>RetrieveKeysInterface</code> :
   * @param pi a <code>PreparedItems</code> :
   * @return a <code>RetrieveKeysInterface</code> : 
   */
  public static final RetrieveKeysInterface setKeys(RetrieveKeysInterface rki, PreparedItems pi) {
    rki.setPkeyFld(pi.getRetFld());
    for (Map<String, String> mval : pi.getRetVal()) {
      List<String> val = new ArrayList<String>();
      for (String fld : pi.getRetFld()) {
        val.add(mval.get(fld));
      }
      rki.addKey(val);
    }
    return rki;
  }
  
  /**
   * Describe <code>setVals</code> method : set values in DetailItemsInterface.
   * <br>PreparedItems ̍ŏ̌ʏ DetailItemsInterface ɐݒ肷B
   * 
   * @param dii a <code>DetailItemsInterface</code> :
   * @param pi a <code>PreparedItems</code> :
   * @return a <code>DetailItemsInterface</code> : 
   */
  public static final DetailItemsInterface setVals(DetailItemsInterface dii, PreparedItems pi) {
    Map<String, String> mval = pi.getRetVal().get(0);
    for (String fld : pi.getRetFld()) {
      dii.setFldValue(fld, mval.get(fld));
    }

    for (COMMFLD fld : COMMFLD.values()) {
      if (mval.containsKey(fld.getVal())) {
        dii.setCommFld(fld, mval.get(fld.getVal()));
      }
    }
    return dii;
  }
}
