package com.hamaf.hikyaku.distribute;

import java.io.InputStream;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;


import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.XmlUtil;

/**
 * <p>^CgFControlXml is hikyakuxml saved.</p>
 * <p>Frp̃Rg[`t@C hikyaku.xml ێNXłB</p>
 * <br>Singlton pattern Ŏ܂B
 * 
 * <p>쌠: Copyright (c) 2003/11/27</p>
 * @author Hamanaka
 * @version 1.0
 */
public final class ControlXml {

  public enum ROOTCONT 
    {SysErrorPage, UnitCheckXml, MasterXml, GAIJICHECK, MaxFileSize, KeySave};
  public enum PROCCONT {PageLine, SaveNotDel};
  public enum ACTCONT {ExecClass, NextPage, CautionPage, WarningPage, ErrorPage};
  public enum CLS_ATR {
    UseDi ("Process[@pid=''{0}'']/Action[@name=''{1}'']/ExecClass/@di"),
    keyVal ("Process[@pid=''{0}'']/Action[@name=''{1}'']/ExecClass/@key");
    private final String val;
    CLS_ATR(String v) { val = v; }
    public String getVal() { return val; }
  }
  
  private static ControlXml myObj = new ControlXml();

  private Map<String,Document>  _cxSave = new HashMap<String,Document>();
  private Map<String, ResourceBundle> _msgRb = new HashMap<String, ResourceBundle>();
  
  private final static String CONT_FILE = "hikyakucms.xml";
  private final static String PID = "Process[@pid=''{0}'']";
  private final static String ACT = "Action[@name=''{0}'']";

  /**
   *  Creates a new <code>ControlXml.java</code> instance.
   * <br>Singleton Ƃ private Œ`B
   * 
   */
  private ControlXml() {
  }

  /**
   * Describe <code>newIncetance</code> method : rerutn mySelf.
   * <br>Singleton ƂĎg߂B
   * @return a <code>ControlXml</code> : MySelf
   */
  public static ControlXml newInstance() {
    return myObj;
  }

  /**
   * Describe <code>refresh</code> method : set hikyaku control File.
   * <br>rpRg[`t@C̍ĐݒsB
   * @param sysId a <code>String</code> : VXeID
   * @param fname a <code>String</code> : Rg[t@C̃tpX
   */
  public void setControl(String sysId, String fname, ResourceBundle rb) {
    if (fname == null || fname.length() == 0) {
      fname = CONT_FILE;
    }
    setControlDocument(sysId, fname);
    _msgRb.put(sysId, rb);
  }

  /**
   * Describe <code>getDoc</code> method : get ControlXml Document.
   * <br>w肳ꂽVXeID̐XML߂B
   * <br>
   * @param sysId a <code>String</code> : VXeID
   * @return a <code>Document</code>
   */
  public Document getDoc(String sysId) {
    if (sysId == null) {
      return null;
    }
    return _cxSave.get(sysId);
  }
  
  //---------- private methods definition
  /**
   * Describe <code>setControlDocument</code> method : Cleate hikyaku.xml Document.
   * <br>rRg[`t@Ccnl𐶐VXeIDKeyɂĕۑB
   * @param sysId a <code>String</code> : VXeID
   * @param fname a <code>String</code> : Rg[t@C̃tpX
   */
  private void setControlDocument(String sysId, String fname) {
    if (sysId == null || fname == null) {
      return;
    }

    try {
      InputStream is = ComUtils.getResource(fname);
      if (is != null) {
        _cxSave.put(sysId, XmlUtil.createDocument(is));
      }
    } catch (Exception xe) {
      xe.printStackTrace();
    }
  }

  /**
   * Describe <code>searchValue</code> method : search Element and return Value.
   * <br>w肳ꂽvZXhcAANVA^OŊYGgA̒l߂܂B
   * @param pid a <code>String</code> : vZXhc
   * @param act a <code>String</code> : ANV
   * @param tagName a <code>String</code> : ^O
   * @param  sysId a <code>String</code> : VXeID
   * @return a <code>String</code> : w肵^O̒l
   * @throws DOMException : ^O݂ȂꍇA͒l݂ȂꍇO𓊂܂B
   */
  private String searchValue(String pid, String act, String tagName, String sysId)
    throws DOMException, XPathExpressionException  {
    String val = getValue(pid, act, tagName, sysId);
    if (val == null) {
      throw new DOMException(DOMException.NOT_FOUND_ERR, tagName);
    }
    return val;
  }
  /**
   * Describe <code>getValue</code> method : search Element and return Value.
   * <br>w肳ꂽvZXhcAANVA^OŊYGgA̒l߂܂B
   * @param pid a <code>String</code> : vZXhc
   * @param act a <code>String</code> : ANV
   * @param tagName a <code>String</code> : 擾^OXPath`
   * @param  sysId a <code>String</code> : VXeID
   * @return a <code>String</code> : w肵^O̒l
   * @throws DOMException : ^O݂ȂꍇAO𓊂܂B
   */
  private synchronized String getValue(String pidVal, String actVal, String tagName, String sysId)
    throws DOMException, XPathExpressionException {

    Object[] prm = {pidVal, actVal};
    ResourceBundle rb = _msgRb.get(sysId);
    Element elm = null;
    Document doc = checkDoc(sysId);
    try {
      elm = getElement(doc.getDocumentElement(), PID, pidVal);
      if (elm == null) {
        throw new DOMException(DOMException.NOT_FOUND_ERR,
            MessageFormat.format(rb.getString("CntXmlPidErr"), prm));
      }
      if(actVal != null) {
        elm = getElement(elm, ACT, actVal);
        if (elm == null) {
          throw new DOMException(DOMException.NOT_FOUND_ERR,
              MessageFormat.format(rb.getString("CntXmlActErr"), prm));
        }
      }
    }
    catch (DOMException de) {
      throw de;
    }
    catch (Exception e) {
      e.printStackTrace();
      throw new DOMException(DOMException.SYNTAX_ERR, e.getMessage());
    }
    XPath xp = XPathFactory.newInstance().newXPath();
    return xp.evaluate(tagName, elm).trim();
  }
  
  /**
   * Describe <code>getElement</code> method : serch Element at Value.
   * <br>nꂽGg̔zŁAw肳ꂽGĝw肳ꂽlGg߂܂B
   * @param elm a <code>Element</code> : Gg
   * @param path a <code>String</code> : 擾Gg
   * @param val a <code>String</code> : l
   * @return a <code>Element</code> : 擾Gg
   * @throws DOMException ȂꍇAO𓊂܂B
   */
  private synchronized Element getElement(Element elm, String path, String val)
    throws DOMException {
    Object[] prm = {val};
    String sb = MessageFormat.format(path, prm);
    XPath xp = XPathFactory.newInstance().newXPath();
    Node nd = null;
    try {
      nd = (Node)xp.evaluate(sb, elm, XPathConstants.NODE);
    } catch (XPathExpressionException xpe) {
      throw new DOMException(DOMException.SYNTAX_ERR,
          "(" + sb + ") : " + xpe.getMessage());      
    }
    return (Element)nd;
  }

  /**
   * Describe <code>checkDoc</code> method : check and return Document.
   * <br>w肳ꂽVXeID̐XML߂B
   * <br>݂Ȃꍇ<code>DOMException</code>𓊂܂B
   * @param sysId  a <code>String</code> : VXeID
   * @return a <code>Document</code> : XML
   * @throws DOMException
   */
  private Document checkDoc(String sysId) throws DOMException {
    Document doc = getDoc(sysId);
    if (doc == null) {
      throw new DOMException(DOMException.NOT_FOUND_ERR, sysId + " is not Saved");
    }
    return doc;
  }
  //-------------------- public methods definition -------------------
  
  /**
   * Describe <code>getActDef</code> method : return Action Element Value.
   * <br>w肳ꂽvZXIDAANVzőΉElement̒l߂܂B
   * 
   * @param pid a <code>String</code> : vZXID
   * @param act a <code>String</code> : ANV
   * @param sysId a <code>String</code> : VXeID
   * @param cnt a <code>ACTCONT</code> : l擾Element
   * @return a <code>String</code> : w肵Element̒l
   * @throws DOMException ݂ȂꍇAO𓊂܂B
   * @throws XPathExpressionException ȏ㔭ɁAO𓊂܂B
   */
  public synchronized String getActDef(String pid, String act, String sysId, ACTCONT cnt) 
    throws DOMException, XPathExpressionException {
    return searchValue(pid, act, cnt.toString(), sysId);
  }

  /**
   * Describe <code>getExecAtrValue</code> method : return ExecClass Attrivute.
   * <br>w肳ꂽvZXIDAANVzExecClass̃Agr[g̒l擾B
   * 
   * @param nm a <code>CLS_ATR</code> : l擾Agr[g
   * @param pid a <code>String</code> : vZXID
   * @param act a <code>String</code> : ANV
   * @param sysId a <code>String</code> : VXeID
   * @return a <code>String</code> : w肵Attribute̒l
   * @throws DOMException
   * @throws XPathExpressionException
   */
  public synchronized String getExecAtrValue(CLS_ATR nm, String pid, String act, String sysId)
  throws DOMException, XPathExpressionException {
    XPath xp = XPathFactory.newInstance().newXPath();
    Object[] prm = {pid, act};
    return xp.evaluate(MessageFormat.format(nm.getVal(), prm),
        checkDoc(sysId).getDocumentElement());
  }

  /**
   * Describe <code>getProcDef</code> method : return Process Element Value.
   * <br>w肳ꂽvZXIDzőΉElement̒l߂܂B
   * 
   * @param pid a <code>String</code> : vZXID
   * @param sysId a <code>String</code> : VXeID
   * @param cnt a <code>PROCCONT</code> : l擾Element
   * @return a <code>String</code> : w肵Element̒l
   * @throws DOMException ݂ȂꍇAO𓊂܂B
   * @throws XPathExpressionException ȏ㔭ɁAO𓊂܂B
   */
  public synchronized String getProcDef(String pid, String sysId, PROCCONT cnt)
    throws DOMException, XPathExpressionException {    
    return searchValue(pid, null, cnt.toString(), sysId);
  }
  
  /**
   * Describe <code>getRootDef</code> method : return Root Element value.
   * <br>[gŒ`Element̒l߂B
   * @param  sysId a <code>String</code> : VXeID
   * @param cnt a <code>PROCCONT</code> : l擾Element
   * @return a <code>String</code> : w肵Element̒l
   */
  public String getRootDef(String sysId, ROOTCONT cnt) {
    return getSysProperty(sysId, cnt.toString());
  }
  
  /**
   * Describe <code>getSysErrorPage</code> method : return System Error Jsp Name.
   * <br>VXeG[\pJSP߂܂B
   * @param  sysId a <code>String</code> : VXeID
   * @return a <code>String</code> : System Error@Page JSP
   * @throws DOMException ݂ȂꍇAO𓊂܂B
   */
  public String getSysErrorPage(String sysId)
    throws DOMException, XPathExpressionException {
    String val = getRootDef(sysId, ROOTCONT.SysErrorPage);
    if (val == null) {
      throw new DOMException(DOMException.NOT_FOUND_ERR, "SysErrorPage Tag");
    }
    return val;
  }

  /**
   * Describe <code>getSysProperty</code> method : return root chiles element value.
   * <br>[g^O̒ɂw肳ꂽ^O̒l߂B
   * <br>w肳ꂽ^O݂Ȃꍇ́A<code>null</code>߂܂B
   * @param sysId a <code>String</code> : VXeID
   * @param name a <code>String</code> : 擾^O
   * @return a <code>String</code> : ݒ肳Ăl
   */
  private synchronized String getSysProperty(String sysId, String name) {
    if (name == null) {
      return null;
    } // end of if ()
    
    Document doc = checkDoc(sysId);
    if (doc == null) {
      return null;
    }
    String val = null;
    try {
      XPath xp = XPathFactory.newInstance().newXPath();
      val = xp.evaluate(name, doc.getDocumentElement());
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return val;
  }
}
