package com.hamaf.hikyaku.distribute;

import java.io.File;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.hamaf.hikyaku.containar.DiFactory;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.plugIn.PlugInUtils;
import com.hamaf.hikyaku.ui.ProcessBase;


import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFDistributeServlet is rCMS CT[ubg Java6 Ή.</p>
 * <p>FrCMS - t[[Nrx[XɂCMS(RecǗVXe)</p>
 * <br> vOC`Ŋe폈gݍނƂ\ƂB
 * <br>vOC plugin.xml Ɏw肷B
 * <br>ʏ̃Rg[EL[ƂẮAȉ̒lłB
 * <ul>
 *   <li>pluginId : AvP[V̒P
 *   <li>processId : ̒P
 *   <li>action : s鏈
 * </ul>
 * <br>̃NXsƂ́Aȉ̏ł---(ʂ)
 * <ul>
 *   <li>~łΕ\pJSPforwd
 *   <li>OCE`FbNĂяoAOCsłΕ\pJSPforwd
 *   <li>w肳ꂽJavaBean ̌Ăяo(Dispatch)
 *   <li>CommonMessagẽZbVւ̐ݒ
 *   <li>CommonMessageErrorStatusɂAJSP̌Ăяo(forwd)
 * </ul>
 * <br>Ȍo͎͂B
 *
 * <br>Httpget,post݂̂T|[g\łB
 *
 * <p>쌠: Copyright (c) 2007/06/01</p>
 * @author y-hamanaka
 * @version 0.2
 */
public class DistributeServlet extends HttpServlet {

  private static final long serialVersionUID = -3047984956312134207L;

  public static final String MAPPING_KEY = "com.hamaf.hikyaku.CommMessage";
  public static final String XSLPATH = "com.hamaf.hikyaku.XslPath";
  public static final String XMLFOWRD = "XmlTransForm";
  public static final String PLUGIN_ID = "HikyakuCmsPluginId";
  public static final String KEY_SAVE_ID = "HikyakuCmsSaveKeyList";
  public static final String CHAR = "utf-8";
  public static final String SYSID = "HikyakuCmsMain";
  public static final String SYSERR = "SystemErrorMessage";

  public enum SVAL {
    sysId("pluginId"),
    ProcId("processId"),
    Act("action"),
    Reserve("reserveSession"),
    ErrPage(""),
    StMsg(""),
    ForwdJSP("");

    private String _val;
    SVAL(String val) { _val = val; }
    public String getValue() { return _val; }
  };

  private static final String LOGCHK = "LogOnCheck";
  private static final String LOGCHKDI = "LogOnCheckDiType";
  private static final String RESRC = "DistributeMessage";
  private static final String CONTF = "ControlFile";
  private static final String MUTLI = "multipart/form-data";
  private static final String DI_FL = "DiFile";
  private static final String DI_CLS = "DiClass";
  private static final String CONT_MODE = "ControlGetMode";

  private ResourceBundle _resource;
  private ServletLogger _log;

  /**
   *  Creates a new <code>DistributeServlet.java</code> instance.
   * <br>Default Constructor
   *
   */
  public DistributeServlet() {
    super();
    _resource = ResourceBundle.getBundle(RESRC);
  }

  // ------ HttpServlet Methods
  /**
   * Describe <code>destroy</code> method : IuWFNgjƂɌĂяo܂.
   */
  public void destroy() {
     _log.logPut("finish", 2);
  }

  /**
   * Describe <code>init</code> method : ݒpɌĂяo܂.
   * @param config a <code>ServletConfig</code> : T[ubgRtBO[V
   */
  public void init(ServletConfig  config) throws ServletException {
    super.init(config);
    _log = new ServletLogger(this);
    ServletUtils.setParent(this);

    DiFactory dif = DiFactory.getInstance();
    String fl = config.getInitParameter(DI_FL);
    String cls = config.getInitParameter(DI_CLS);
    if ((fl != null && fl.length() > 0) || (cls != null && cls.length() > 0)) {
      dif.setContainar(cls, fl, SYSID);
    }
  }

  /**
   * Process an HTTP "GET" request.
   * <br>WebNCAgGetŌĂяoACɂȂ܂B
   * <br>菇͈ȉ̂Ƃs܂B
   * <ul>
   *   <li><code>processId</code>,<code>action</code>擾
   *   <li>sNX<code>(ExecClass)</code>𐶐ĂяoB
   *   <li>ʃbZ[WNXErrorStatusɂAʂJSP肷B
   *   <li>ʃbZ[WNXSessionɐݒ肵AJSPforwordB
   * </ul>
   * @param request The servlet request we are processing : bZ[WȂǂݒ肳
   * @param response The servlet response we are creating : bZ[Wݒ肷
   *
   * @exception IOException if an input/output error occurs
   * @exception ServletException if a servlet exception occurs
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    _log.logPut("doStart", 2);

    ServletUtils.setControl(SYSID, getInitParameter(CONTF), getInitParameter(CONT_MODE));

    request.setCharacterEncoding(CHAR);

    HttpServletRequest svReq = request;
    String conType = request.getContentType();
    if (conType != null && conType.startsWith(MUTLI)) {
      svReq = new MultipartServletRequest(request);
    }
    Map<SVAL, String> sval = saveValues(svReq, response);
    _log.logPut(sval.get(SVAL.StMsg), 1);

    String chk = ServletUtils.checkLogin(sval.get(SVAL.ProcId),
        getInitParameter(LOGCHK), getInitParameter(LOGCHKDI),
        SYSID, svReq, _resource);
    if (chk != null) {
      sval.put(SVAL.ForwdJSP, chk);
      forwardJsp(sval, null, svReq, response);
      return;
    }

    ServletUtils.clearSession(sval, request.getSession());

    try {
      String pluginId = sval.get(SVAL.sysId);
      if (pluginId != null && pluginId.length() > 0 && !SYSID.equals(pluginId)) {
        PlugInUtils.setControlXml(pluginId);
      }

      ProcessBase process = ServletUtils.procNew(sval);
      _log.logPut("callInit : " + process.getClass().getName(), 2);
      process.setSconfig(getServletConfig());

      CommonMessage cmsg = process.init(svReq, response, _resource, sval);
      if (cmsg.getErrorStatus() != STATUS.NORMAL) {
        forwardJsp(sval, cmsg, svReq, response);
        return;
      }
      setAppRoot(cmsg, pluginId);

      _log.logPut("callExec", 2);
      cmsg = process.exec(cmsg);

      _log.logPut("callFinish", 2);
      process.finish(cmsg);

      _log.logPut("forwardJSP", 2);
      forwardJsp(sval, cmsg, svReq, response);
    }
    catch (IllegalArgumentException e) {
      e.printStackTrace();
      sysError("NotFound", e.getMessage(), sval, svReq, response);
    }
    catch (ClassNotFoundException e) {
      e.printStackTrace();
      sysError("NotFound2", e.getMessage(), sval, svReq, response);
    }
    catch (ClassCastException e) {
      e.printStackTrace();
      sysError("AnMatch", e.getMessage(), sval, svReq, response);
    }
    catch (Exception e) {
      e.printStackTrace();
      sysError("ExecError", e.getMessage(), sval, svReq, response);
    }
  }

  /**
   * Process an HTTP "POST" request.
   * doGet("GET" Process)Ăяo܂B
   * @param request The servlet request we are processing : bZ[WȂǂݒ肳
   * @param response The servlet response we are creating : bZ[Wݒ肷
   *
   * @exception IOException if an input/output error occurs
   * @exception ServletException if a servlet exception occurs
   */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
      this.doGet(request, response);
  }

  private CommonMessage setAppRoot(CommonMessage cms, String pluginId) {
    StringBuilder rpsb = new StringBuilder();
    rpsb.append(getServletContext().getRealPath("/"));
    if (pluginId != null && pluginId.length() > 0 && !SYSID.equals(pluginId)) {
      rpsb.append(PlugInUtils.BASE_DIR);
      rpsb.append(File.separator);
      rpsb.append(pluginId);
    }
    cms.setAppRoot(rpsb.toString());
    return cms;
  }

  /**
   * Describe <code>sysError</code> method : System Error Process.
   * <br>VXeG[̎|Oɏo͂AVXeG[ʂNCAgɑMB
   * @param mid a <code>String</code> : bZ[Whc
   * @param msg a <code>String</code> : G[bZ[W
   * @param sval a <code>Map</code> : SVAL
   * @param req a <code>HttpServletRequest</code>
   * @param res a <code>HttpServletResponse</code>
   * @throws IOException
   * @throws ServletException
   */
  private void sysError(String mid, String msg, Map<SVAL, String> sval,
      HttpServletRequest req, HttpServletResponse res)
    throws  IOException, ServletException {
    Object[] mparm = {sval.get(SVAL.ProcId), sval.get(SVAL.Act), msg};
    String logMsg = MessageFormat.format(_resource.getString(mid), mparm);

    log(logMsg);
    req.getSession().setAttribute(SYSERR, logMsg);
    sval.put(SVAL.ForwdJSP, sval.get(SVAL.ErrPage));
    forwardJsp(sval, null, req, res);
  }

  /**
   * Describe <code>forwardJsp</code> method : forwardJsp.
   * <br>w肳ꂽiroւ̃tH[hsB
   * <br>X|XR~bgĂꍇ́A܂B
   * @param sval a <code>Map</code> : Map
   * @param msg a <code>CommonMessage</code> : M鋤ʃIuWFNg
   * @param req a <code>HttpServletRequest</code>
   * @param res a <code>HttpServletResponse</code>
   * @exception IOException
   * @exception ServletException
   */
  private void forwardJsp(Map<SVAL, String> sval, CommonMessage msg,
			  HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {

    String jsp = sval.get(SVAL.ForwdJSP);
    if (msg != null) {
      jsp = ServletUtils.getJspNm(sval, msg.getErrorStatus());
      req.setAttribute(MAPPING_KEY, msg);
    }
    _log.logPut("forward to "+ jsp + " .", 2);

    req.setAttribute(PLUGIN_ID, req.getParameter(SVAL.sysId.getValue()));

    RequestDispatcher rd = null;
    if (jsp.endsWith(".xsl")) {
      req.setAttribute(XSLPATH, jsp);
      rd = getServletContext().getNamedDispatcher(XMLFOWRD);
    }
    else {
      rd = getServletContext().getRequestDispatcher(jsp);
    }

    rd.forward(req, res);
  }

  /**
   * Describe <code>saveValues</code> method : save information items.
   * <br>KvƂȂ鍀ڂMapɕێB
   *
   * @param req a <code>HttpServletRequest</code> :
   * @param res a <code>HttpServletResponse</code> :
   * @return a <code>Map<SVAL,String></code> : ێMap
   * @throws IOException
   */
  private Map<SVAL, String> saveValues(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {
    if (req.getParameter(SVAL.ProcId.getValue()) == null ||
        req.getParameter(SVAL.Act.getValue()) == null) {
      errSend("NullId", res);
      throw new ServletException("Process or Action not found");
    }

    Map<SVAL, String> ret = new HashMap<SVAL, String>();
    ret.put(SVAL.sysId, req.getParameter(SVAL.sysId.getValue()));
    ret.put(SVAL.ProcId, req.getParameter(SVAL.ProcId.getValue()));
    ret.put(SVAL.Act, req.getParameter(SVAL.Act.getValue()));
    ret.put(SVAL.Reserve, req.getParameter(SVAL.Reserve.getValue()));
    Object[] prm = {ret.get(SVAL.ProcId), ret.get(SVAL.Act)};
    ret.put(SVAL.StMsg, MessageFormat.format(_resource.getString("ProcessMsg"), prm));
    try {
      ret.put(SVAL.ErrPage, ControlXml.newInstance().getSysErrorPage(SYSID));
    } catch (Exception ex) {
      errSend("SysErrorNFD", res);
      throw new ServletException(ex);
    }

    return ret;
  }

  /**
   * Describe <code>errSend</code> method : Error information put.
   * <br>G[bZ[WOɏo͂AG[̎|NCAgɑM܂B
   * @param msg a <code>String</code> : G[bZ[W
   * @param _res a <code>HttpServletResponse</code>
   * @exception IOException
   */
  private void errSend(String msg, HttpServletResponse res)
    throws IOException {
    String outm = msg;
    try {
      outm = _resource.getString(msg);
    } catch (MissingResourceException me) {
    }
    log(outm);

    res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, outm);
  }

  /**
   * @return resource
   */
  public final ResourceBundle getResource() {
    return _resource;
  }

  /**
   * @return log
   */
  public final ServletLogger getLog() {
    return _log;
  }

  public final ServletConfig getConfig() {
    return super.getServletConfig();
  }
}
