package com.hamaf.hikyaku.distribute;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>^CgFIllegalRetrieveDataException is retrieve data error happend Exception.</p>
 * <p>Fڂ̃G[̏ꍇɔO</p>
 * <br>G[ƂȂڂݒ肷Map̈ĂB
 * 
 * <p>쌠: Copyright (c) 2003/12/27</p>
 * @author Hamanaka
 * @version 1.0
 */
public final class IllegalRetrieveDataException extends RuntimeException {
  
  private static final long serialVersionUID = -3047984956312134207L;

  private Map<String, String> _errData = null;
  
  /**
   *  Creates a new <code>IllegalRetrieveDataException.java</code> instance.
   * <br>
   * @param msg a <code>String</code> : G[bZ[W
   * @param items a <code>Map</code> : ږ̃G[
   */
  public IllegalRetrieveDataException(String msg, Map<String, String> items) {
    super(msg);
    _errData = items;
  }

  /**
   *  Creates a new <code>IllegalRetrieveDataException.java</code> instance.
   * <br>
   * @param msg a <code>String</code> : G[bZ[W
   * @param items a <code>Map</code> : ږ̃G[
   * @param arg1 a <code>Throwable</code>
   */
  public IllegalRetrieveDataException(String msg, Map<String, String> items, Throwable arg1) {
    super(msg, arg1);
    _errData = items;
  }
  
  /**
   * Describe <code>setErrorItem</code> method : set error information.
   * <br>ڂƂ̃G[ݒ肷B
   * @param item a <code>String</code> : ږ
   * @param msg a <code>String</code> : G[
   */
  public void setErrorItem(String item, String msg) {
    if (_errData == null) {
      _errData = new HashMap<String, String>();
    }
    _errData.put(item, msg);
  }
  
  /**
   * Describe <code>getErrData</code> method : return item error information Map.
   * <br>
   * @return a <code>Map</code> : ږ̃G[
   */
  public Map<String, String> getErrData() {
    return _errData;
  }

  /**
   * Describe <code>toString</code> method : return Error infomation String.
   * <br>G[̏𕶎ɂĖ߂B
   * @return a <code>String</code> : G[
   */
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("\n--- Message -------------------------\n");
    sb.append(super.getMessage());
    sb.append("\n--- Map Value -----------------------\n");
    for (String kval : _errData.keySet()) {
      sb.append(kval);
      sb.append(" = ");
      sb.append(_errData.get(kval));
      sb.append("\n");
    }

    return sb.toString();
  }
    
}
