package com.hamaf.hikyaku.extension;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Properties;
import com.hamaf.hikyaku.distribute.ServletUtils;

/**
 * <p>^Cg: AppLogInfo֌W̃vpeBێB</p>
 * <p>: AppLogOutproperties̕ێsB</p>
 * <br> vpeBƂĕێ鍀
 * <ul>
 *  <li>AvP[VO@t@C̃vtBbNX
 *  <li>AvP[VO@o͐@pX
 *  <li>AvP[VO@o̓x̋Kl
 *  <li>AvP[VO@Pt@C̏o͍s
 *  <li>AvP[VOWo͂ɂo͂邩ۂ
 * </ul>
 * <br>ڍׂ<b>AppLogOut.properties file</b>QƁB
 *
 * <p>쌠: Copyright (c) 2004</p>
 * @author Hamanaka
 * @version 1.0
 */

public final class AppLogInfo {

  private static final String BASE_DIR = "/plugins/";
  private static final String FLNAME = "/AppLogOut.properties";
  private Properties property = null;

  /**
   * Get the value of LogOutName return Log file Prefix Name .
   * <br>fobOO@t@C̃vtBbNX nB
   * @return an <code>String</code> value of LogOutName.
   */
  public String getLogName() {
    return property.getProperty("LogOutName");
  }

  /**
   * Get the value of LogOutPath return LogOut path .
   * <br>fobOO@o͐@pX nB
   * @return an <code>String</code> value of XmlOutPath.
   */
  public String getLogPath() {
    return property.getProperty("LogOutPath");
  }

  /**
   * Describe <code>getLogLine</code> method : return Max outlin count a file.
   * <br><b>1 File</b>̏o͌߂
   * @return an <code>int</code> : max outline count
   */
  public int getLogLine() {
    int mli = 0;
    try {
      mli = Integer.parseInt(property.getProperty("LogLineCount"));
    } catch (Exception e) {
      mli = 1;
    }
    mli = Math.max(mli, 100);
    return mli;
  }

  /**
   * Describe <code>getLogOutLevel</code> method : return Log output level.
   * <br>Ȍo̓x߂B
   * @return a <code>String</code> : Log output level
   */
  public String getLogOutLevel() {
    return property.getProperty("LogOutLevel");
  }

  /**
   * Describe <code>getSystemOut</code> method : get SystemOut.
   * <br><b>SystemOut Property</b>̒lpɕϊĖ߂B
   * @return a <code>String</code> : value of SystemOut.toLowerCase
   */
  public String getSystemOut() {
    return property.getProperty("SystemOut").toLowerCase();
  }

  /**
   * Describe <code>getPropertyByName</code> method : get property by Name.
   * <br> vpeBw肵āAvpeBt@C̒l擾B
   * <br> Y閼OȂꍇ́A<b>null</b>߂܂B
   * <br> <b>Properties class</b>  <b>getProperty</b> Ăяo܂B
   *
   * @see java.util.Properties
   * @param argName a <code>String</code> :
   * @return a <code>String</code> :
   */
  public String getPropertyByName(String argName) {
    return property.getProperty(argName);
  }

  /**
   * Describe <code>init</code> method : clear & get properties file.
   * <br>ێ̈AvpeBt@CǂݍށB
   */
  public void init(String pid) {
    getProperties(pid);
  }

  //--------------------------------------------------------------------
  //      private Methods
  //--------------------------------------------------------------------

  /**
   * Describe <code>getProperties</code> method : get properties file.
   * <br><b>propertis File</b> eݒ擾B
   * <br>ݒt@C̓Ǎ "AppLogOut.properties" łB
   */
  private void getProperties(String pid) {
    property = new Properties();
    StringBuilder sb = new StringBuilder();
    sb.append(BASE_DIR);
    sb.append(pid);
    String ppath = ServletUtils.whichFile(sb.toString());
    try {
      File pfl = new File(ppath + FLNAME);
      if (pfl.exists()) {
        FileInputStream is = new FileInputStream(pfl);
        property.load(is);
        is.close();
      } else {
        System.out.println("### properties File [" + sb + "] ݂܂Blgp܂B");
      }
    } catch (FileNotFoundException ffe) {
      System.out.println("### properties File [" + sb + "] ݂܂Blgp܂B");
    } catch (Exception fex) {
      System.out.println("### properties File̎擾Ɏs܂B\n" + fex.getMessage() + "\nlgp܂B");
    }

    String lpath = property.getProperty("LogOutPath");
    if (lpath == null) {
      property.setProperty("LogOutPath", ppath);
    } else {
      StringBuilder ps = new StringBuilder();
      ps.append(ppath);
      if (lpath.length() > 0 && lpath.charAt(0) != File.separatorChar) ps.append(File.separator);
      ps.append(lpath);
      property.setProperty("LogOutPath", ps.toString());
    }
    if (property.getProperty("LogOutName") == null) {
      property.setProperty("LogOutName", "ApplicationLog");
    }
    if (property.getProperty("LogLineCount") == null) {
      property.setProperty("LogLineCount", "5000");
    }
    if (property.getProperty("LogOutLevel") == null) {
      property.setProperty("LogOutLevel", "debug");
    }
    if (property.getProperty("SystemOut") == null) {
      property.setProperty("SystemOut", "Yes");
    }
  }

}
