package com.hamaf.hikyaku.extension;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Calendar;

/**
 * <p>^Cg: AppricationLog write Omplematation class.</p>
 * <p>: AvP[VOo͂̎NXB</p>
 * <br><b>AppLogInfo</b>oRĊe평擾܂B
 *
 * @author Hamanaka
 * @version 1.0
 */
public class AppLogOutImpl implements AppLogOut {

  private AppLogInfo _ali = null;
  private BufferedWriter bfw = null;
  private int outLvl = -1;
  private int outLine = 0;

  /**
   * Describe <code>debug</code> method : Debug log write.
   * <br><b>Debug</b>pOo
   * @param msg a <code>String</code> : Message
   */
  public void debug(String msg) {
    if (outLvl >= LEVEL_DEBUG) {
      logWrite("DEBUG", msg);
    }
  }

  /**
   * Describe <code>info</code> method : Information log write.
   * <br><b>Info</b>pOo
   * @param msg a <code>String</code> : Message
   */
  public void info(String msg) {
    if (outLvl >= LEVEL_INFO) {
      logWrite("INFO", msg);
    }
  }

  /**
   * Describe <code>error</code> method : Error log write.
   * <br><b>Error</b>pOo
   * @param msg a <code>String</code> : Message
   */
  public void error(String msg) {
    logWrite("ERROR", msg);
  }

  /**
   * Describe <code>fclose</code> method : Log file close.
   * <br>o͒̃Ot@CN[YB
   */
  public void fclose() {
    try {
      bfw.close();
      bfw = null;
    } catch (Exception ce) {
      System.out.println("Close Error :" + ce.getMessage());
    }
    outLine = 0;
  }

  /**
   * Describe <code>setLevel</code> method : set log out level.
   * <br><code>AppLogInfo.getLogOutLevel()</code>̒lŏo̓xݒ肷B
   */
  public void setLevel(String pid) {

    _ali = new AppLogInfo();
    _ali.init(pid);
    if (_ali.getLogOutLevel().equals("error")) {
      outLvl = AppLogOut.LEVEL_ERROR;
    }
    else if (_ali.getLogOutLevel().equals("info")) {
      outLvl = AppLogOut.LEVEL_INFO;
    }
    else {
      outLvl = AppLogOut.LEVEL_DEBUG;
    }

  }

  /**
   * Describe <code>getLogFile</code> method : get output FileWriter.
   * <br>Oo͗p<b>FIleWriter</b>𐶐B
   */
  private synchronized void getLogFile() {
    if (bfw != null) {
      return;
    }

    File dir = new File(_ali.getLogPath());
    if (!dir.exists()) dir.mkdirs();
    
    Calendar now = Calendar.getInstance();
    StringBuffer flnsb = new StringBuffer();
    flnsb.append(_ali.getLogPath());
    flnsb.append(File.separator);
    flnsb.append(_ali.getLogName());
    flnsb.append(now.get(Calendar.YEAR));
    flnsb.append(ZeroAdd(now.get(Calendar.MONTH) + 1));
    flnsb.append(ZeroAdd(now.get(Calendar.DAY_OF_MONTH)));
    flnsb.append(ZeroAdd(now.get(Calendar.HOUR_OF_DAY)));
    flnsb.append(ZeroAdd(now.get(Calendar.MINUTE)));
    flnsb.append(ZeroAdd(now.get(Calendar.SECOND)));
    flnsb.append(ZeroAdd3(now.get(Calendar.MILLISECOND)));
    flnsb.append(".log");
    File svf = new File(flnsb.toString());
    String fln = svf.getAbsolutePath();
    try {
      bfw = new BufferedWriter(new FileWriter(fln));
    } catch (Exception exf) {
      System.out.println("LogFile 쐬 ERROR : " + exf.getMessage());
    }
  }

  private String ZeroAdd(int ii) {
    StringBuffer sb = new StringBuffer("00");
    sb.append(ii);
    return sb.substring(sb.length() - 2);
  }
  private String ZeroAdd3(int ii) {
    StringBuffer sb = new StringBuffer("000");
    sb.append(ii);
    return sb.substring(sb.length() - 3);
  }

  /**
   * Describe <code>createMsg</code> method : create message format.
   * <br>o̓bZ[WtH[}bgB
   * @param lvl a <code>String</code> : o Level
   * @param msg a <code>String</code> : Message
   * @return a <code>String</code> : output format message
   */
  private String createMsg(String lvl, String msg) {
    Calendar now = Calendar.getInstance();
    StringBuffer msb = new StringBuffer();
    msb.append("[");
    msb.append(now.get(Calendar.YEAR));
    msb.append("/");
    msb.append(now.get(Calendar.MONTH) + 1);
    msb.append("/");
    msb.append(now.get(Calendar.DAY_OF_MONTH));
    msb.append(" ");
    msb.append(now.get(Calendar.HOUR_OF_DAY));
    msb.append(":");
    msb.append(now.get(Calendar.MINUTE));
    msb.append(":");
    msb.append(now.get(Calendar.SECOND));
    msb.append("][");
    msb.append(lvl);
    msb.append("]");
    msb.append(msg);
    return msb.toString();
  }

  /**
   * Describe <code>logWrite</code> method : Log write.
   * <br>Oo͂
   * @param lv a <code>String</code> : o Level
   * @param msg a <code>String</code> : Message
   */
  private synchronized void logWrite(String lv, String msg) {

    if (outLvl < 0) {
      return;
    }

    if (_ali.getSystemOut().charAt(0) == 'y') {
      System.out.println(createMsg(lv, msg));
    }

    //o͍s̃`FbN
    if (++outLine > _ali.getLogLine()) {
      fclose();
    }

    try {
      getLogFile();
      bfw.write(createMsg(lv, msg));
      bfw.newLine();
      bfw.flush();
    } catch (Exception exi) {
      System.out.println("["+ lv + "]" + msg);
      exi.printStackTrace();
    }
  }

}
