package com.hamaf.hikyaku.extension;

import java.beans.XMLDecoder;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.text.MessageFormat;
import java.util.ResourceBundle;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.UnitItemCheck;
import com.hamaf.hikyaku.distribute.ControlXml;
import com.hamaf.hikyaku.util.ComUtils;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import static com.hamaf.hikyaku.distribute.ControlXml.ROOTCONT;

/**
 * <p>^CgFItemChecks is Item checked class.</p>
 * <p>Fw肳ꂽID̍ڂɑ΂A`FbNsB</p>
 * <br>`FbNڂ {@see com.hamaf.hikyaku.dataobject.UnitItemCheck UnitItemCheck} QƁB
 * <br>
 * <br>XML<b>UnitCheckXml</b>Ŏw肳ꂽtH_[
 * <br>w肳ꂽID̃tH_[̑SĂXml擾A
 * <br>̓eŃ`FbNs܂B
 * <br>Xml̓`FbNpUnitItemCheck Class̃vpeBLq
 * <br>XMLEncoder`ŋLqĂKv܂B
 *
 * @see com.hamaf.hikyaku.dataobject.UnitItemCheck.
 * <p>쌠: Copyright (c) 2004/02/12</p>
 * @author Hamanaka
 * @version 1.0
 */
public class ItemChecks {
  
  private static final String MSGFL = "ItemErrorMessage";

  /**
   *  Creates a new <code>ItemChecks.java</code> instance.
   * <br>Default Constructor
   *
   */
  public ItemChecks() {
  }

  /**
   * Describe <code>check</code> method : items unit check from xml.
   * <br>ڃ`FbN̏ĂяoB
   * <br>G[̏ꍇ<b>CommonMessage</b>ErrorStatusWARNINGyуG[bZ[Wݒ肳܂B
   * @param msg a <code>CommonMessage</code> : `FbN鍀ڐݒ肳ĂCommonMessage
   * @param gid a <code>String</code> :@IDi`FbNpXmli[ĂtH_[j
   * @return a <code>CommonMessage</code> : `FbNCommonMessage
   */
  public CommonMessage check(CommonMessage msg, String gid) {
    String sysId = msg.getSysId();
    ControlXml cx = ControlXml.newInstance();
    return doCheck(msg, cx.getRootDef(sysId, ROOTCONT.GAIJICHECK),
                   cnvertFlrNm(cx.getRootDef(sysId, ROOTCONT.UnitCheckXml), gid));
  }
  
  private String cnvertFlrNm(String ppath, String fldr) {
    StringBuilder stdir = new StringBuilder();
    stdir.append(ComUtils.convPath(ppath, true));
    stdir.append(fldr);
    return stdir.toString();
  }

  private CommonMessage doCheck(CommonMessage msg, String gaiji, String fldrs) {
    ResourceBundle _res = ResourceBundle.getBundle(MSGFL);
    
    File fldr = new File(fldrs);
    File[] fls = fldr.listFiles();
    if (fls == null) {
      msg.setErrorStatus(STATUS.ERROR);
      Object[] prm = {fldr.getAbsolutePath()};
      msg.addMessage(MessageFormat.format(_res.getString("ERR80"), prm));
      return msg;
    }
    msg.setErrorStatus(STATUS.NORMAL);
    boolean gaijiChk = "yes".equals(gaiji.toLowerCase());
    for (File fl : fls) {
      if (fl.isFile() && fl.getName().toLowerCase().endsWith(".xml")) {
        msg = xml2CheckBean(msg, fl.getAbsolutePath(), gaijiChk);
      }
    }
    return msg;
  }

  private CommonMessage xml2CheckBean(CommonMessage msg, String xml, boolean gchk) {
    try {
      XMLDecoder xd = new XMLDecoder(new BufferedInputStream
                                     (new FileInputStream(xml)));
      UnitItemCheck sb = (UnitItemCheck)xd.readObject();
      sb.setGaiji(gchk);
      sb.check(msg);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    return msg;
  }

}
