package com.hamaf.hikyaku.plugIn.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.plugIn.access.ViewMenuAccess;
import com.hamaf.hikyaku.plugIn.access.MenuAccess.MKUBUN;
import com.hamaf.hikyaku.plugIn.dto.VMenuDto;
import com.hamaf.hikyaku.plugIn.dto.VMenuSearchDto;
import com.hamaf.hikyaku.plugIn.ui.MenuCreate.MENU_ITEMS;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.access.GroupAccess;
import com.hamaf.hikyaku.security.access.MessageAccess;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.access.UserAccess.USER_TYPE;
import com.hamaf.hikyaku.security.dto.GroupSearchDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.MessageProcess;


/**
 * <p>^CgFMenuInfAcquisition is .</p>
 * <p>Fj[̎擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/02/14</p>
 * @author Yoshinori
 * @version 1.0
 */
public class MenuInfAcquisition {

	private ViewMenuAccess _vma = null;
	private GroupAccess _ga = null;
	private MessageProcess _mp = null;

	/**
	 *  Creates a new <code>MenuInfAcquisition.java</code> instance.
	 * <br>Default Constructor
	 */
	public MenuInfAcquisition(ViewMenuAccess vma, GroupAccess ga, MessageProcess mp) {
		_vma = vma;
		_ga = ga;
		_mp = mp;
	}

	/**
	 * Describe <code>getSystemMenu</code> method : .
	 * <br>VXeǗҌ@j[ڂ擾B
	 * <br>
	 * @param ud a <code>UserDto</code>
	 * @throws Exception
	 * @return a <code>List&lt;Map&lt;String,String&gt;&gt;</code> :
	 */
	public List<Map<String, String>> getSystemMenu(UserDto ud) throws Exception {
	  if (ud == null) return null;
	  if (!"1".equals(ud.getItemValue(UserDto.ADMIN_FLG)) &&
	      !USER_TYPE.SUPER.getVal().equals(ud.getItemValue(UserDto.USER_TYPE))) return null;

		VMenuSearchDto vsd = new VMenuSearchDto();
		vsd.setRetrieveValue(VMenuSearchDto.KUBUN, MKUBUN.SYSTEM.getVal());
		vsd.setSysId(DistributeServlet.SYSID);
		return getItems(vsd, ud);
	}

	/**
	 * Describe <code>getMessageMenu</code> method : .
	 * <br>ǗҌbZ[W\j[擾B
	 *
	 * @param ud a <code>UserDto</code>
	 * @return a <code>List&lt;Map&lt;String,String&gt;&gt;</code> :
	 * @throws Exception
	 */
	public List<Map<String, String>> getMessageMenu(UserDto ud) throws Exception {
	  if (ud == null) return null;
	  if (!"1".equals(ud.getItemValue(UserDto.ADMIN_FLG)) &&
	      !USER_TYPE.SUPER.getVal().equals(ud.getItemValue(UserDto.USER_TYPE))) return null;
		if (!_mp.isFound(MessageAccess.TO_KUBUN.MANAGER, null)) return null;

		VMenuSearchDto vsd = new VMenuSearchDto();
		vsd.setRetrieveValue(VMenuSearchDto.KUBUN, MKUBUN.MESSAGE.getVal());
		vsd.setSysId(DistributeServlet.SYSID);
		return getItems(vsd, ud);
	}

	/**
	 * Describe <code>getGroupMenu</code> method : .
	 * <br>O[vǗҌ@j[ڂ\B
	 *
	 * @param ud a <code>UserDto</code>
	 * @return a <code>List&lt;Map&lt;String,String&gt;&gt;</code> :
	 * @throws Exception
	 */
	public List<Map<String, String>> getGroupMenu(UserDto ud) throws Exception {
	    if (ud == null) return null;

	    GroupSearchDto gsd = new GroupSearchDto();
	    gsd.setRetrieveValue(GroupSearchDto.MANAGER, ud.getItemValue(UserDto.USER_ID));
	    gsd = (GroupSearchDto)_ga.find(gsd);
	    if (gsd.getKeys().size() == 0)  return null;

	    VMenuSearchDto vsd = new VMenuSearchDto();
	    vsd.setRetrieveValue(VMenuSearchDto.KUBUN, "X");
	    vsd.setSysId(DistributeServlet.SYSID);
	    return getItems(vsd, ud);
	  }

	/**
	 * Describe <code>getPulaginMenu</code> method : .
	 * <br>[U[ɑΉvOC̃j[ڂ擾B
	 * <br>
   * @param ud a <code>UserDto</code> :
	 * @return a <code>List<Map<String,String>></code> :
   * @throws Exception
	 */
	public List<Map<String, String>> getPulaginMenu(UserDto ud) throws Exception {
		VMenuSearchDto vsd = new VMenuSearchDto();
		vsd.setRetrieveValue(VMenuSearchDto.KUBUN, MKUBUN.PLUGIN.getVal());
		vsd.setSysId(DistributeServlet.SYSID);
		return getItems(vsd, ud);
	}

	private List<Map<String , String>> getItems(VMenuSearchDto vsd, UserDto ud) throws Exception {
    SecurityCheckUtils scu = new SecurityCheckUtils();
		List<Map<String , String>> ret = new ArrayList<Map<String, String>>();
		vsd = (VMenuSearchDto)_vma.find(vsd);
		for (List<String> keys : vsd.getKeys()) {
      if (scu.checkPossible(POSS_KUBUN.MENU, keys.get(1), keys.get(2), ud)) {
  			VMenuDto vmd = new VMenuDto();
  			vmd.setAllRequest();
  			vmd.setItemValue(VMenuDto.KUBUN, keys.get(0));
  			vmd.setItemValue(VMenuDto.PLUGIN_ID, keys.get(1));
  			vmd.setItemValue(VMenuDto.MENU_ID, keys.get(2));
  			vmd = (VMenuDto)_vma.findByPrimaryKey(vmd);
  			if (!vmd.isNotFound()) {
    				Map<String , String> dt = new HashMap<String, String>();
    				MENU_ITEMS[] items = MENU_ITEMS.values();
    				for (int i = 0; i < items.length; i++) {
    					dt.put(items[i].name(), vmd.getItemValue(items[i].getVal()));
    				}
    				ret.add(dt);
  			}
      }
		}
		return ret;
	}

}
