package com.hamaf.hikyaku.plugIn.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.plugIn.access.RetrieveAccess;
import com.hamaf.hikyaku.plugIn.access.ViewRetrieveAccess;
import com.hamaf.hikyaku.plugIn.dto.RetrieveDto;
import com.hamaf.hikyaku.plugIn.dto.VRetrieveDto;
import com.hamaf.hikyaku.plugIn.dto.VRetrieveSearchDto;
import com.hamaf.hikyaku.plugIn.ui.RetrieveCreate.RETRIEVE_ITEMS;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.dto.UserDto;

/**
 * <p>^CgFRetriveInfInitInfAcquisition is .</p>
 * <p>F̎擾s</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/06/23</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class RetrieveInfAcquisition {
  
  private RetrieveAccess _ra = null;
  private ViewRetrieveAccess _vra = null;

  /**
   *  Creates a new <code>RetriveInfInitInfAcquisition.java</code> instance.
   * <br>Default Constructor
   * @param ra a <code>RetrieveAccess</code>
   * @param vra a <code>ViewRetrieveAccess</code>
   */
  public RetrieveInfAcquisition(RetrieveAccess ra, ViewRetrieveAccess vra) {
    _ra = ra;
    _vra = vra;
  }
  
  /**
   * Describe <code>find</code> method : .
   * <br>B
   * 
   * @param vrsd a <code>VRetrieveSearchDto</code> : 
   * @return a <code>VRetrieveSearchDto</code> : 
   * @throws Exception
   */
  public VRetrieveSearchDto find(VRetrieveSearchDto vrsd) throws Exception {
    return (VRetrieveSearchDto)_vra.find(vrsd);
  }
  
  /**
   * Describe <code>findByPrimaryKey</code> method : .
   * <br>̏ڍׂ擾B
   * 
   * @param vrd a <code>VRetrieveDto</code> : 
   * @return a <code>VRetrieveDto</code> : 
   * @throws Exception
   */
  public VRetrieveDto findByPrimaryKey(VRetrieveDto vrd) throws Exception {
    return (VRetrieveDto)_vra.findByPrimaryKey(vrd);
  }

  /**
   * Describe <code>update</code> method : .
   * <br>e[uXVB
   * 
   * @param rd a <code>RetrieveDto</code> : 
   * @throws Exception
   */
  public void update(RetrieveDto rd) throws Exception {
    _ra.update(rd);
  }
  
  /**
   * Describe <code>getRetrieveInf</code> method : .
   * <br>e[u胆[U[ɑΉp擾B
   * 
   * @param ud a <code>UserDto</code> : 
   * @return a <code>List&lt;Map&lt;String,String&gt;&gt;</code> : 
   * @throws Exception
   */
  public List<Map<String, String>> getRetrieveInf(String val, UserDto ud) throws Exception {
    VRetrieveSearchDto vrsd = new VRetrieveSearchDto();
    vrsd.setRetrieveValue(VRetrieveSearchDto.USE_FLG, "1");
    vrsd.setSysId(DistributeServlet.SYSID);
    vrsd = (VRetrieveSearchDto)_vra.find(vrsd);
    return getItems(vrsd, val, ud);
  }
  private List<Map<String, String>> getItems(VRetrieveSearchDto vrsd, String sval, UserDto ud) throws Exception {
    List<Map<String, String>> ret = new ArrayList<Map<String,String>>();
    if (ud == null) return ret;
    SecurityCheckUtils scu = new SecurityCheckUtils();
    for (List<String> keys : vrsd.getKeys()) {
      if (scu.checkPossible(POSS_KUBUN.SEARCH, keys.get(0), keys.get(1), ud)) {
        VRetrieveDto vrd = new VRetrieveDto();
        vrd.setItemValue(VRetrieveDto.PLUGIN_ID, keys.get(0));
        vrd.setItemValue(VRetrieveDto.RETRIEVE_ID, keys.get(1));
        vrd.setAllRequest();
        vrd = (VRetrieveDto)_vra.findByPrimaryKey(vrd);
        if (!vrd.isNotFound()) {
          Map<String, String> dt = new HashMap<String, String>();
          RETRIEVE_ITEMS[] items = RETRIEVE_ITEMS.values();
          for (int i = 0; i < items.length; i++) {
            String val;
            if (items[i] == RETRIEVE_ITEMS.sval) {
              val = sval;
            } else {
              val = vrd.getItemValue(items[i].getVal());
              if (items[i] == RETRIEVE_ITEMS.opt && val.length() > 0) {
                if (!val.startsWith("&")) val = "&" + val;
              }
            }
            dt.put(items[i].name(), val);
          }
          ret.add(dt);
        }
      }
    }
    return ret;
  }
}
