package com.hamaf.hikyaku.plugIn.ui;

import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.plugIn.dto.VInitDto;
import com.hamaf.hikyaku.plugIn.dto.VInitSearchDto;
import com.hamaf.hikyaku.plugIn.process.InitInfAcquisition;
import com.hamaf.hikyaku.plugIn.ui.mapping.InitViewMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFInitSearch is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/02/23</p>
 * @author yoshinori
 * @version 1.0
 */
public class InitSearch extends StandardListProcess {

	private InitInfAcquisition _iia;

	/**
	 *  Creates a new <code>InitSearch.java</code> instance.
	 * <br>Default Constructor
	 */
	public InitSearch(InitViewMap ivm, InitInfAcquisition iia) {
		_jim = ivm;
		_iia = iia;
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _iia.findByPrimarykey((VInitDto)dii);
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected String[] checkDelete(DetailItemsInterface dii) {
		return null;
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
	 */
	@Override
	protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
			throws Exception {
		return _iia.find((VInitSearchDto)rki);
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new VInitDto();
	}

	private final String USE_TAG = "useflg";
  private final String POS_TAG = "position";
  private final String USE_VAL = "useval";
  private final String POS_VAL = "posval";
	/* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#editItems(com.hamaf.hikyaku.dataobject.DetailItemsInterface, java.util.Map)
   */
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    mp.put(USE_VAL, mxc.getTagValue(USE_TAG, dii.getItemValue(VInitDto.USE_FLG), USE_TAG + "Name"));
    String pos = dii.getItemValue(VInitDto.POSITION);
    if (pos == null || pos.length() == 0) {
      mp.put(POS_VAL, "");

    } else {
      mp.put(POS_VAL, mxc.getTagValue(POS_TAG, pos, POS_TAG + "Name"));

    }
    return super.editItems(dii, mp);
  }

  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
	 */
	@Override
	protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
			throws IllegalRetrieveDataException {
		VInitSearchDto visd = new VInitSearchDto();
		visd.setCondition(VInitSearchDto.PLUGIN_ID, "like");
		visd.setRetrieveValue(VInitSearchDto.PLUGIN_ID, keyl.getRetrieve("plgval"));
		visd.setOrderItem(VInitSearchDto.PLUGIN_ID, 1);
		visd.setOrderItem(VInitSearchDto.INIT_ID, 2);
		return visd;
	}

}
