package com.hamaf.hikyaku.plugIn.ui;

import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.plugIn.dto.VMenuDto;
import com.hamaf.hikyaku.plugIn.process.MenuInfAcquisition;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;


/**
 * <p>^CgFMenuCreate is .</p>
 * <p>Fj[̐</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/02/14</p>
 * @author Yoshinori
 * @version 1.0
 */
public class MenuCreate extends ProcessBase {

	public enum MENU_ITEMS {
		plgId( VMenuDto.PLUGIN_ID ),
    menuId( VMenuDto.MENU_ID ),
    dsp( VMenuDto.DISPLAY ),
    proc( VMenuDto.PROCESS ),
    act( VMenuDto.ACTION ),
    tget( VMenuDto.TARGET ),
    plgNm( VMenuDto.DISPLAY_NAME ),
    icon( VMenuDto.ICON );

    private int val;
		MENU_ITEMS(int argV) { val = argV; }
		public int getVal() { return val; }
	}

	private MenuInfAcquisition _mia;

	/**
	 *  Creates a new <code>MenuCreate.java</code> instance.
	 * <br>Default Constructor
	 */
	public MenuCreate(MenuInfAcquisition mia) {
		_mia = mia;
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	public CommonMessage exec(CommonMessage msg) throws Exception {
	  UserDto ud = (UserDto)session.getAttribute(LogInCheck.USER_INF);
		List<Map<String, String>> pmenul = _mia.getPulaginMenu(ud);
		msg.setResList(pmenul);
    List<Map<String, String>> smenul = _mia.getSystemMenu(ud);
    List<Map<String, String>> gmenul = _mia.getGroupMenu(ud);
    if (smenul == null) {
      smenul = gmenul;
    } else {
      if (gmenul != null) smenul.addAll(gmenul);
    }
    List<Map<String, String>> mmenul = _mia.getMessageMenu(ud);
    if (smenul == null) {
      smenul = mmenul;
    } else {
      if (mmenul != null) smenul.addAll(mmenul);
    }
    msg.setWorkBuff(smenul);
		return msg;
	}

}
