package com.hamaf.hikyaku.plugIn.ui;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.ServletUtils;
import com.hamaf.hikyaku.plugIn.PlugInUtils;
import com.hamaf.hikyaku.plugIn.access.PluginAccess;
import com.hamaf.hikyaku.plugIn.dto.InfoXml;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.dto.InfoXml.INF_TAG;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.XmlUtil;

/**
 * <p>^CgFNewSearch is get new plugin information.</p>
 * <p>FVKɐݒ肳ꂽvOC𒊏o</p>
 * <br>"plugins"tH_[̂o^̃vOC𒊏oB
 *
 * <p>쌠: Copyright (c) 2010/01/22</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class NewSearch extends ProcessBase {

  public static final String INFO_PASS = "infopass";
  
  private final String PLUGIN_ID = "plgId";
  private final String ICON_PASS = "skins/default/images/icon/PluginIcon.gif";

  private PluginAccess _pa = null;

  /**
   *  Creates a new <code>NewSearch.java</code> instance.
   * <br>Default Constructor
   */
  public NewSearch(PluginAccess pa) {
    _pa = pa;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    File bdir = new File(ServletUtils.whichFile(PlugInUtils.BASE_DIR));
    File[] subs = bdir.listFiles();
    if (subs == null) return msg;
    for (int i = 0; i < subs.length; i++) {
      File sdir = subs[i];
      if (sdir.isDirectory()) {
        if (checkNew(sdir)) {
          msg = addDetail(msg, sdir);
        }
      }
    }
    return msg;
  }
  /**
   * Describe <code>checkNew</code> method : checked new plug in.
   * <br>VKɒǉꂽvOCmFB
   *
   * @param cfl a <code>File</code> : mFfBNg[
   * @return a <code>boolean</code> : VK̂Ƃtrue
   * @throws Exception
   */
  private boolean checkNew(File cfl) throws Exception {
    PluginInfDto pid = new PluginInfDto();
    pid.setItemValue(PluginInfDto.PLUGIN_ID, cfl.getName());
    _pa.findByPrimaryKey(pid);
    if (pid.isNotFound()) return true;
    return false;
  }
  private CommonMessage addDetail(CommonMessage msg, File dir) throws Exception {
    InfoXml inf = new InfoXml();
    try {
      inf.setXml(dir);
    } catch (Exception xe) {
      xe.printStackTrace();
      return msg;
    }
    Map<String, String> dval = new HashMap<String, String>();
    dval.put(PLUGIN_ID, dir.getName());
    dval.put(INFO_PASS, dir.getPath().replaceAll("\\\\", "\\\\\\\\"));
    INF_TAG[] tags = INF_TAG.values();
    for (int i = 0; i < tags.length; i++) {
      String val = inf.getInfTag(tags[i]);
      if (tags[i].equals(INF_TAG.controlxmlpass)) {
        if (val == null || val.length() == 0) return msg;
        val = joinPath(dir, val);
        try {
          XmlUtil.createDocument(val);
        } catch (Exception xe) {
          xe.printStackTrace();
          return msg;
        }
      }
      if (tags[i].equals(INF_TAG.difile)) {
        if (val != null && val.length() > 0) val = joinPath(dir, val);
      }
      if (tags[i].equals(INF_TAG.icon)) {
        if (val == null || val.length() == 0) val = ICON_PASS;
      }
      if (tags[i].equals(INF_TAG.controlgetmode)) {
        if (val != null && val.length() > 4) val = val.substring(0, 4);
      }
      if (val == null) val = "";
      val = val.replaceAll("\\\\", "\\\\\\\\");
      dval.put(tags[i].name(), val);
    }
    msg.addResList(dval);
    return msg;
  }
  private String joinPath(File dir, String path) {
    File fl = new File(dir, path);
    return fl.getPath();
  }
}
