package com.hamaf.hikyaku.security;

import java.sql.SQLException;
import java.util.ResourceBundle;

import javax.servlet.http.HttpServletRequest;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.access.UserAccess;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.system.LogOnCheck;



/**
 * <p>^CgFLoginConfirmed.</p>
 * <p>FZbVLŁA[U[񂪕ێς݂̃`FbN</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/03/31</p>
 * @author Yoshinori
 * @version 1.0
 */
public class LoginConfirmed implements LogOnCheck {

	private final String LOGONPROC = DistributeServlet.SYSID + "securitylogin";
  private final String SYSMENU  = DistributeServlet.SYSID + "menuinit";
  private final String TOPFRAM  = DistributeServlet.SYSID + "topmsgdisp";
  private final String INITDISP = DistributeServlet.SYSID + "initdspdisp";
  private final String PARM_PLG = "pluginId";
  private final String PARM_PRO = "processId";
  private final String PARM_ACT = "action";
//  private final String PARM_TOP = "topframe";
  private final String MXL_LREQ = "loginreuired";

  private final String UGST = "guest";

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.system.LogOnCheck#check(javax.servlet.http.HttpServletRequest)
	 */
	@Override
	public boolean check(HttpServletRequest request) {
		StringBuffer sb = new StringBuffer();
		sb.append(request.getParameter(PARM_PLG));
		sb.append(request.getParameter(PARM_PRO));
		sb.append(request.getParameter(PARM_ACT));
		String chkval = sb.toString();
		if (LOGONPROC.equals(chkval)) return false;

		Object udt = request.getSession().getAttribute(LogInCheck.USER_INF);
		if (udt != null & udt instanceof UserDto) return false;

		MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(DistributeServlet.SYSID);
		String req = mxc.getConstant(MXL_LREQ);
		if ("yes".equals(req)) return true;

		if (!SYSMENU.equals(chkval) && !TOPFRAM.equals(chkval) && !INITDISP.equals(chkval)) return true;

    UserDto ud = new UserDto();
    ud.setItemValue(UserDto.USER_ID, UGST);
    ud.setAllRequest();
    UserAccess ua = new UserAccess();
		try {
			ud = (UserDto)ua.findByPrimaryKey(ud);
			if (ud.isNotFound()) ud = null;
		} catch (SQLException ex) {
			ud = null;
			ex.printStackTrace();
		}
		if (ud == null) return true;

		request.getSession().setAttribute(LogInCheck.USER_INF, ud);

		return false;
	}

	private final String DSPNM = "/displayTop.jsp";
	private final String MSG_DELS = "syslogoffMsg";
	private final String ATR_EMSG = "timeoutmsg";
	private final String DSP_JSP = "index.jsp";
	private final String ATR_ACT = "actval";

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.system.LogOnCheck#getJspUrl(javax.servlet.http.HttpServletRequest, java.util.ResourceBundle)
   */
  @Override
  public String getJspUrl(HttpServletRequest request, ResourceBundle resource) {
    request.setAttribute(ATR_EMSG, resource.getString(MSG_DELS));
    request.setAttribute(ATR_ACT, DSP_JSP);
    return DSPNM;
  }

}
