package com.hamaf.hikyaku.security.access;

import java.sql.SQLException;
import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.access.ExclusionException;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.extension.AppLogOutSingleImpl;
import com.hamaf.hikyaku.security.dto.UserDto;

/**
 * <p>^CgFUserAccess.</p>
 * <p>F[U[}X^̃ANZXNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/03/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserAccess extends DefaultTableAccess {

  public enum PWD_FLG {
    EMPTY("9"),
    INIT("1"),
    NORMAL("0");

    private String val;
    PWD_FLG(String v) { val = v; }
    public String getVal() { return val; }
  }
  public enum USER_TYPE {
    GUEST("a"),
    GENERAL("g"),
    SUPER("s");

    private String val;
    USER_TYPE(String v) { val = v; }
    public String getVal() { return val; }
  }

  private final String TBLNM = "M_USER";

  /**
   *  Creates a new <code>UserAccess.java</code> instance.
   * <br>Default Constructor
   */
  public UserAccess() {
    tableName = TBLNM;
//    super.setDebug();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#find(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  public RetrieveKeysInterface find(RetrieveKeysInterface rki)
      throws SQLException {
    return super.find(rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#findByPrimaryKey(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public DetailItemsInterface findByPrimaryKey(DetailItemsInterface dii)
      throws SQLException {
    if (!((dii instanceof UserDto) && dii.getItemValue(UserDto.USER_ID).equals(dii.getCommFld(COMMFLD.UUSR))))
      AppLogOutSingleImpl.newInstance().info(getClsMtd("findByPrimaryKey", dii));
    return super.findByPrimaryKey(dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#regist(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void regist(DetailItemsInterface dii) throws SQLException {
    AppLogOutSingleImpl.newInstance().info(getClsMtd("regist", dii));
    super.regist(dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#update(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void update(DetailItemsInterface dii) throws ExclusionException,
      SQLException {
    AppLogOutSingleImpl.newInstance().info(getClsMtd("update", dii));
    super.update(dii);
  }

  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.access.DefaultTableAccess#delete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	public void delete(DetailItemsInterface dii) throws ExclusionException,
			SQLException {
    AppLogOutSingleImpl.newInstance().info(getClsMtd("delete", dii));
		super.delete(dii);
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.access.DefaultTableAccess#deleteNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	public void deleteNoExclusion(DetailItemsInterface dii) throws SQLException {
		throw new SQLException("IllegalAccess");
	}

	/* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.access.DefaultTableAccess#updateNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	public void updateNoExclusion(DetailItemsInterface dii) throws SQLException {
		throw new SQLException("IllegalAccess");
	}

	private String getClsMtd(String accs, DetailItemsInterface dii) {
    Throwable thr = new Throwable();
    StackTraceElement[] stes = thr.getStackTrace();
    StringBuilder sb = new StringBuilder();
    sb.append(" UserMaster Access (");
    sb.append(accs);
    sb.append(") Class('");
    if (stes.length > 3) {
      sb.append(stes[3].getClassName());
      sb.append("'), Method('");
      sb.append(stes[3].getMethodName());
    } else {
      sb.append(stes[2].getClassName());
      sb.append("'), Method('");
      sb.append(stes[2].getMethodName());
    }
    sb.append("') : Access UserID('");
    sb.append(dii.getCommFld(COMMFLD.UUSR));
    sb.append("') Target UserID('");
    sb.append(dii.getItemValue(UserDto.USER_ID));
    sb.append("')");
    return sb.toString();
  }

}
