package com.hamaf.hikyaku.security.process;

import java.util.HashMap;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.security.access.BelongSql;
import com.hamaf.hikyaku.security.access.GroupAccess;
import com.hamaf.hikyaku.security.access.GroupUserSql;
import com.hamaf.hikyaku.security.access.HatubanAccess;
import com.hamaf.hikyaku.security.access.ViewGroupAccess;
import com.hamaf.hikyaku.security.access.ViewGroupSelAccess;
import com.hamaf.hikyaku.security.access.HatubanAccess.HKUBUN;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.dto.GroupSearchDto;
import com.hamaf.hikyaku.security.dto.VGroupDto;
import com.hamaf.hikyaku.ui.dto.CommonSelectDto;
import com.hamaf.hikyaku.ui.dto.CommonSelectSearchDto;

/**
 * <p>^CgFGroupProcess is .</p>
 * <p>FO[vǗp̏</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/10</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupProcess {

  private GroupAccess _ga = null;
  private ViewGroupAccess _vga = null;
  private ViewGroupSelAccess _vgs = null;
  private HatubanAccess _ha = null;
  private BelongSql _bs = null;
  private GroupUserSql _gs = null;
  
  /**
   *  Creates a new <code>GroupProcess.java</code> instance.
   * <br>Default Constructor
   */
  public GroupProcess(GroupAccess ga, ViewGroupAccess vga, ViewGroupSelAccess vgs,
      HatubanAccess ha, BelongSql bs, GroupUserSql gs) {
    _ga= ga;
    _vga = vga;
    _vgs = vgs;
    _ha = ha;
    _bs = bs;
    _gs = gs;
  }

  /**
   * Describe <code>findByPrimarykey</code> method : .
   * <br>O[v̎擾B
   * 
   * @param gd a <code>GroupDto</code> : 
   * @return a <code>GroupDto</code> : 
   * @throws Exception
   */
  public VGroupDto findByPrimarykey(VGroupDto vgd) throws Exception {
    return (VGroupDto)_vga.findByPrimaryKey(vgd);
  }
  
  /**
   * Describe <code>find</code> method : .
   * <br>O[v̌B
   * 
   * @param gsd a <code>GroupSearchDto</code> : 
   * @return a <code>GroupSearchDto</code> : 
   * @throws Exception
   */
  public GroupSearchDto find(GroupSearchDto gsd) throws Exception {
    return (GroupSearchDto)_ga.find(gsd);
  }
  
  /**
   * Describe <code>findSelectByKey</code> method : .
   * <br>O[vIpf[^擾B
   * 
   * @param csd a <code>CommonSelectDto</code> : 
   * @return a <code>CommonSelectDto</code> : 
   * @throws Exception
   */
  public CommonSelectDto findSelectByKey(CommonSelectDto csd) throws Exception {
    return (CommonSelectDto)_vgs.findByPrimaryKey(csd);
  }
  
  /**
   * Describe <code>findSelect</code> method : .
   * <br>O[vIpf[^B
   * 
   * @param cssd a <code>CommonSelectSearchDto</code> : 
   * @return a <code>CommonSelectSearchDto</code> : 
   * @throws Exception
   */
  public CommonSelectSearchDto findSelect(CommonSelectSearchDto cssd) throws Exception {
    return (CommonSelectSearchDto)_vgs.find(cssd);
  }
    
  /**
   * Describe <code>addGroup</code> method : .
   * <br>O[v̓o^B
   * 
   * @param gd a <code>GroupDto</code> : 
   * @throws Exception
   */
  public void addGroup(GroupDto gd) throws Exception {
  	gd.setItemValue(GroupDto.GROUP_ID, _ha.getNextNo(HKUBUN.GROUP, null));
    _ga.regist(gd);
  }
  
  /**
   * Describe <code>updateGroup</code> method : .
   * <br>O[v̍XVB
   * 
   * @param gd a <code>GroupDto</code> : 
   * @throws Exception
   */
  public void updateGroup(GroupDto gd) throws Exception {
    gd.setCommFld(COMMFLD.DEL, USE_FLG.USE.getVal());
    _ga.update(gd);
  }
  
  /**
   * Describe <code>checkDelete</code> method : .
   * <br>O[vhc̍폜mFB
   * <br>O[v֘A񖔂̓O[v[U[ɊYO[v݂ꍇ true ߂B
   * 
   * @param gid a <code>String</code> : O[vID
   * @return a <code>boolean</code> : ݂ꍇ TRUE
   * @throws Exception
   */
  public boolean checkDelete(String gid) throws Exception {
    PreparedItems pi = createPre(gid);
    pi = _bs.getChildren(pi);
    if (pi.getRetVal().size() > 0) return true;
    pi = _bs.getParents(pi);
    if (pi.getRetVal().size() > 0) return true;
    pi = _gs.getUsers(pi);
    if (pi.getRetVal().size() > 0) return true;
    return false;
  }
  
  /**
   * Describe <code>deleteGroup</code> method : .
   * <br>O[v̍폜B
   * 
   * @param gd a <code>GroupDto</code> : 
   * @throws Exception
   */
  public void deleteGroup(GroupDto gd) throws Exception {
    String gid = gd.getItemValue(GroupDto.GROUP_ID);
//    _ga.delete(gd);
    gd.setCommFld(COMMFLD.DEL, USE_FLG.DEL.getVal());
    _ga.update(gd);
    
    PreparedItems pi = createPre(gid);
    _bs.deleteByGroupId(pi);
    _bs.deleteByBelongId(pi);
    _gs.deleteByGroupId(pi);
  }

  private PreparedItems createPre(String gid) {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("in");
    Map<String, String> vals = new HashMap<String, String>();
    vals.put("GroupId", gid);
    vals.put("BelongId", gid);
    pi.addParam(vals);
    return pi;
  }
}
