package com.hamaf.hikyaku.security.process;

import com.hamaf.hikyaku.security.access.HatubanAccess;
import com.hamaf.hikyaku.security.access.MessageAccess;
import com.hamaf.hikyaku.security.access.HatubanAccess.HKUBUN;
import com.hamaf.hikyaku.security.dto.MessageDto;
import com.hamaf.hikyaku.security.dto.MessageSearchDto;

/**
 * <p>^CgFMessageProcess is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class MessageProcess {

	private MessageAccess _ma = null;
  private HatubanAccess _ha = null;

	/**
	 * Creates a new <code>MessageProcess.java</code> instance.
	 * <br>Default Constructor
	 * @param ma
	 */
	public MessageProcess(MessageAccess ma, HatubanAccess ha) {
		_ma = ma;
		_ha = ha;
	}

	/**
	 * Describe <code>find</code> method : .
	 * <br>bZ[WDBB
	 *
	 * @param msd a <code>MessageSearchDto</code> :
	 * @return <code>MessageSearchDto</code>
	 * @throws Exception
	 */
	public MessageSearchDto find(MessageSearchDto msd) throws Exception {
		return (MessageSearchDto)_ma.find(msd);
	}

	/**
	 * Describe <code>isFound</code> method : .
	 * <br>w肳ꂽM̋敪ƒl̃bZ[W݂邩`FbNB
	 * <br>݂Ƃ^(true)߂B
	 *
	 * @param kbn a <code>MessageAccess.TO_KUBUN</code>
	 * @param id a <code>String</code>
	 * @return ݂Ƃ^(true)
	 * @throws Exception
	 */
	public boolean isFound(MessageAccess.TO_KUBUN kbn, String id) throws Exception {
		MessageSearchDto msd = new MessageSearchDto();
		msd.setRetrieveValue(MessageSearchDto.TO_KUBUN, kbn.getVal());
		if (!kbn.equals(MessageAccess.TO_KUBUN.MANAGER)) {
			msd.setRetrieveValue(MessageSearchDto.TO_USER, id);
		}
		msd = (MessageSearchDto)_ma.find(msd);
		if (msd.getKeys().size() == 0) return false;
		return true;
	}

	/**
	 * Describe <code>findByPrimarikey</code> method : .
	 * <br>bZ[WDBڍ׏擾B
	 *
	 * @param md a <code>MessageDto</code> :
	 * @return <code>MessageDto</code> :
	 * @throws Exception
	 */
	public MessageDto findByPrimarikey(MessageDto md) throws Exception {
		return (MessageDto)_ma.findByPrimaryKey(md);
	}

	/**
	 * Describe <code>addMessage</code> method : .
	 * <br>bZ[WDB̓o^B
	 *
	 * @param md a <code>MessageDto</code> :
	 * @throws Exception
	 */
	public void addMessage(MessageDto md) throws Exception {
  	md.setItemValue(MessageDto.MEAASGE_ID, _ha.getNextNo(HKUBUN.MESSAGE, null));
		_ma.regist(md);
	}

	/**
	 * Describe <code>modMessage</code> method : .
	 * <br>bZ[WDB̍XVB
	 *
	 * @param md a <code>MessageDto</code> :
	 * @throws Exception
	 */
	public void modMessage(MessageDto md) throws Exception {
		_ma.update(md);
	}

	/**
	 * Describe <code>delMessage</code> method : .
	 * <br>bZ[WDB̍폜B
	 *
	 * @param md a <code>MessageDto</code> :
	 * @throws Exception
	 */
	public void delMessage(MessageDto md) throws Exception {
		_ma.delete(md);
	}

}
