package com.hamaf.hikyaku.security.process;

import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.plugIn.access.InitAccess;
import com.hamaf.hikyaku.plugIn.access.MenuAccess;
import com.hamaf.hikyaku.plugIn.access.RetrieveAccess;
import com.hamaf.hikyaku.plugIn.access.MenuAccess.MKUBUN;
import com.hamaf.hikyaku.plugIn.dto.InitDto;
import com.hamaf.hikyaku.plugIn.dto.MenuDto;
import com.hamaf.hikyaku.plugIn.dto.RetrieveDto;
import com.hamaf.hikyaku.security.access.PossibleAccess;
import com.hamaf.hikyaku.security.access.ViewPossibleAccess;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.dto.PossibleDto;
import com.hamaf.hikyaku.security.dto.PossibleSearchDto;
import com.hamaf.hikyaku.security.dto.VPossibleDto;

/**
 * <p>^CgFPossibleProcess is .</p>
 * <p>F}X^̏s</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/05/28</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PossibleProcess {

  private PossibleAccess _pa = null;
  private ViewPossibleAccess _vpa = null;
  private MenuAccess _ma = null;
  private InitAccess _ia = null;
  private RetrieveAccess _ra = null;

  /**
   *  Creates a new <code>PossibleProcess.java</code> instance.
   * <br>Default Constructor
   * @param pa
   * @param vpa
   * @param ma
   * @param ia
   */
  public PossibleProcess(PossibleAccess pa, ViewPossibleAccess vpa,
      MenuAccess ma, InitAccess ia, RetrieveAccess ra) {
    super();
    _pa = pa;
    _vpa = vpa;
    _ma = ma;
    _ia = ia;
    _ra = ra;
  }

  /**
   * Describe <code>find</code> method : .
   * <br>}X^B
   *
   * @param psd a <code>PossibleSearchDto</code> :
   * @return a <code>PossibleSearchDto</code> :
   * @throws Exception
   */
  public PossibleSearchDto find(PossibleSearchDto psd) throws Exception {
    return (PossibleSearchDto)_pa.find(psd);
  }

  /**
   * Describe <code>findByPrimaruKey</code> method : .
   * <br>}X^r[ڍ׃f[^擾B
   *
   * @param vpd a <code>VPossibleDto</code> :
   * @return a <code>VPossibleDto</code> :
   * @throws Exception
   */
  public VPossibleDto findByPrimaruKey(VPossibleDto vpd) throws Exception {
    vpd.clearRequest(VPossibleDto.KEY_DISP);
    if (POSS_KUBUN.MENU.getVal().equals(vpd.getItemValue(VPossibleDto.KUBUN))) {
      return findMenuByPrimaruKey(vpd);
    }
    if (POSS_KUBUN.IDSP.getVal().equals(vpd.getItemValue(VPossibleDto.KUBUN))) {
      return findInitByPrimaruKey(vpd);
    }
    if (POSS_KUBUN.SEARCH.getVal().equals(vpd.getItemValue(VPossibleDto.KUBUN))) {
      return findRetrieveByPrimaryKey(vpd);
    }
    return (VPossibleDto)_vpa.findByPrimaryKey(vpd);
  }
  private VPossibleDto findMenuByPrimaruKey(VPossibleDto vpd) throws Exception {
    vpd.setItemValue(PossibleDto.KUBUN, POSS_KUBUN.MENU.getVal());
    vpd = (VPossibleDto)_vpa.findByPrimaryKey(vpd);
    MenuDto md = new MenuDto();
    md.setItemValue(MenuDto.KUBUN, MKUBUN.PLUGIN.getVal());
    md.setItemValue(MenuDto.PLUGIN_ID, vpd.getItemValue(VPossibleDto.PLUGIN_ID));
    md.setItemValue(MenuDto.MENU_ID, vpd.getItemValue(VPossibleDto.KEY_ITEM));
    md.setRequestItem(MenuDto.DISPLAY);
    md.setSysId(DistributeServlet.SYSID);
    md = (MenuDto)_ma.findByPrimaryKey(md);
    vpd.setItemValue(VPossibleDto.KEY_DISP, md.getItemValue(MenuDto.DISPLAY));
    return vpd;
  }
  private VPossibleDto findInitByPrimaruKey(VPossibleDto vpd) throws Exception {
    vpd.setItemValue(PossibleDto.KUBUN, POSS_KUBUN.IDSP.getVal());
    vpd = (VPossibleDto)_vpa.findByPrimaryKey(vpd);
    InitDto id = new InitDto();
    id.setItemValue(InitDto.PLUGIN_ID, vpd.getItemValue(VPossibleDto.PLUGIN_ID));
    id.setItemValue(InitDto.INIT_ID, vpd.getItemValue(VPossibleDto.KEY_ITEM));
    id.setRequestItem(InitDto.DISPLAY);
    id.setSysId(DistributeServlet.SYSID);
    id = (InitDto)_ia.findByPrimaryKey(id);
    vpd.setItemValue(VPossibleDto.KEY_DISP, id.getItemValue(InitDto.DISPLAY));
    return vpd;
  }
  private VPossibleDto findRetrieveByPrimaryKey(VPossibleDto vpd) throws Exception {
    vpd.setItemValue(PossibleDto.KUBUN, POSS_KUBUN.SEARCH.getVal());
    vpd = (VPossibleDto)_vpa.findByPrimaryKey(vpd);
    RetrieveDto rd = new RetrieveDto();
    rd.setItemValue(RetrieveDto.PLUGIN_ID, vpd.getItemValue(VPossibleDto.PLUGIN_ID));
    rd.setItemValue(RetrieveDto.RETRIEVE_ID, vpd.getItemValue(VPossibleDto.KEY_ITEM));
    rd.setRequestItem(RetrieveDto.DISPLAY);
    rd.setSysId(DistributeServlet.SYSID);
    rd = (RetrieveDto)_ra.findByPrimaryKey(rd);
    vpd.setItemValue(VPossibleDto.KEY_DISP, rd.getItemValue(RetrieveDto.DISPLAY));
    return vpd;
  }

  /**
   * Describe <code>modify</code> method : .
   * <br>}X^̕ύXB
   *
   * @param pd a <code>PossibleDto</code> :
   * @throws Exception
   */
  public void modify(PossibleDto pd) throws Exception {
    _pa.update(pd);
  }

}
