package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.process.GroupMemberProcess;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.security.ui.mapping.GroupInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFGroupDel is .</p>
 * <p>FO[v̍폜p̉ʏ</p>
 * <br>łɗpĂꍇA[jObZ[W\B
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/12</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupDel extends StandardCheckAndUpdate {

  private GroupProcess _gp = null;
  private GroupMemberProcess _gmp = null;
  
  /**
   *  Creates a new <code>GroupDel.java</code> instance.
   * <br>Default Constructor
   * @param gp
   * @param gmp
   */
  public GroupDel(GroupInfMap gim, GroupProcess gp, GroupMemberProcess gmp) {
    _jim = gim;
    _gp = gp;
    _gmp = gmp;
  }
  
  private final String RGID = "gid";
  private final String NCHK = "CheckOk";
  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkMaster(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
		if ("1".equals(msg.getReqStr(NCHK))) return msg;
		String gid = msg.getReqStr(RGID);
		if (_gmp.getBelongs(gid).size() > 0) return errRet(msg);
		if (_gmp.getParent(gid).size() > 0) return errRet(msg);
		if (_gmp.getUsers(gid).size() > 0) return errRet(msg);
		return super.checkMaster(msg);
	}
	
	private final String MSGID = "GroupDelWR";
	private CommonMessage errRet(CommonMessage msg) {
		msg.setErrorStatus(STATUS.WARNING);
		msg.addMessage(resource.getString(MSGID));
		msg.setResMsg(NCHK, "1");
		return msg;
	}

	private final String MODOK = "GroupMod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _gp.deleteGroup((GroupDto)dii);
    msg.setResMsg(MODOK, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GroupDto();
  }

}
