package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.security.dto.GroupSearchDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.dto.VGroupDto;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.security.ui.mapping.VGroupInfMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFGroupList is .</p>
 * <p>FO[vꗗ\pNX</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/11</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupList extends StandardListProcess {

  private GroupProcess _gp = null;
  /**
   *  Creates a new <code>GroupList.java</code> instance.
   * <br>Default Constructor
   */
  public GroupList(VGroupInfMap gim, GroupProcess gp) {
    _jim = gim;
    _gp = gp;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gp.findByPrimarykey((VGroupDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ret = {"gname", super.resource.getString("DelLine")};
      return ret;
    }
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _gp.find((GroupSearchDto)rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VGroupDto();
  }

  private final String ALL_CHK = "allGp";
  private final String RET_CD = "rgcd";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    GroupSearchDto gsd = new GroupSearchDto();
    gsd.setRetrieveValue(GroupSearchDto.GROUP_CODE, keyl.getRetrieve(RET_CD));
    gsd.setCondition(GroupSearchDto.GROUP_CODE, "like");
    gsd.setOrderItem(GroupSearchDto.GROUP_CODE, 1);
    if (!"1".equals(keyl.getRetrieve(ALL_CHK))) {
      UserDto ud = (UserDto)session.getAttribute(LogInCheck.USER_INF);
      gsd.setRetrieveValue(GroupSearchDto.MANAGER, ud.getItemValue(UserDto.USER_ID));
    }
    return gsd;
  }

}
