package com.hamaf.hikyaku.security.ui;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Calendar;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.access.UserAccess.USER_TYPE;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.PasswordUtil;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFHeaderMessage.</p>
 * <p>F\̃j[̃bZ[W쐬</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/04/16</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class HeaderMessage extends ProcessBase {

  public static final String MX_MFL = "messageFile";
  public static final String MSGFROM = "topmsgFrom";
  public static final String MSGTO = "topmsgTo";
  public static final String TOPMSG = "topmsg";

  private final String PWDMSG = "pwdmsg";
  private final String GEST_USER = "userEntry";
  private final String MX_GEST_USER = "GustUserEntory";

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(DistributeServlet.SYSID);
    msg.setResMsg(PWDMSG, checkPswdMsg(mxc));
    String[] rdt = getTopMsg(mxc);
    msg.setResMsg(MSGFROM, rdt[0]);
    msg.setResMsg(MSGTO, rdt[1]);
    msg.setResMsg(TOPMSG, rdt[2]);
    msg.setResMsg(GEST_USER, mxc.getConstant(MX_GEST_USER));
    return msg;
  }

  private final String MX_INF = "info";
  private final String MX_WAR = "warning";
  private final String MX_INFM = "infoMessage";
  private final String MX_WARM = "warningMessage";

  private String checkPswdMsg(MasterXmlControl mxc) {
    UserDto ud = (UserDto)session.getAttribute(LogInCheck.USER_INF);
    if (ud == null) return "";
    String typ = ud.getItemValue(UserDto.USER_TYPE);
    if (!USER_TYPE.GENERAL.getVal().equals(typ)) return "";

    String bdt = ud.getItemValue(UserDto.PWD_UPDATE);
    Map<String, String> pwdinf = mxc.getItemValue(PasswordUtil.MXTAG, PasswordUtil.MXKEY);
    try {
      if (PasswordUtil.checkPeriod(bdt, pwdinf.get(MX_INF))) {
        return pwdinf.get(MX_INFM);
      }
      if (PasswordUtil.checkPeriod(bdt, pwdinf.get(MX_WAR))) {
        return pwdinf.get(MX_WARM);
      }
    } catch (Exception xe) { }
    return "";
  }

  private String[] getTopMsg(MasterXmlControl mxc) {
    String[] rval = {"","",""};
    String flnm = ComUtils.convPath(mxc.getConstant(MX_MFL), false);
    try {
      BufferedReader bfr = new BufferedReader(
          new InputStreamReader(new FileInputStream(flnm), "utf-8"));
      String kikan = bfr.readLine();
      if (kikan == null || kikan.length() == 0) {
        bfr.close();
        return rval;
      }

      String[] dt = kikan.split(",");
      Calendar ndt = Calendar.getInstance();
      Calendar sdt = DateUtil.getCalendar(dt[0]);
      Calendar edt = DateUtil.getCalendar(dt[1]);
      if (ndt.after(sdt) && ndt.before(edt)) {
        rval[0] = dt[0];
        rval[1] = dt[1];
        rval[2] = bfr.readLine();
      }
      bfr.close();
    } catch (Exception xe) { }
    return rval;
  }
}
