package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.MessageDto;
import com.hamaf.hikyaku.security.process.MessageProcess;
import com.hamaf.hikyaku.security.ui.mapping.MessageMap;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFMessageDel is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class MessageDel extends StandardUpdateProcess {

	private MessageProcess _mp = null;

	/**
	 * Creates a new <code>MessageDel.java</code> instance.
	 * <br>Default Constructor
	 * @param mp
	 * @param mm
	 */
	public MessageDel(MessageProcess mp, MessageMap mm) {
		super();
		_mp = mp;
		_jim = mm;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new MessageDto();
	}

  private final String DELOK = "MessageDel";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage callControl(DetailItemsInterface dii,
			CommonMessage msg) throws Exception {
		_mp.delMessage((MessageDto)dii);
    msg.setResMsg(DELOK, "1");
		return msg;
	}

}
