package com.hamaf.hikyaku.security.ui;

import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.dto.PossibleSearchDto;
import com.hamaf.hikyaku.security.dto.VPossibleDto;
import com.hamaf.hikyaku.security.process.PossibleProcess;
import com.hamaf.hikyaku.security.ui.mapping.VPossibleInfMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFPossibleList is .</p>
 * <p>FZLeBݒꗗ\</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/06/14</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PossibleList extends StandardListProcess {

  private PossibleProcess _pp = null;
  
  /**
   *  Creates a new <code>Possiblejp.java</code> instance.
   * <br>Default Constructor
   * @param pp
   * @param vpm
   */
  public PossibleList(PossibleProcess pp, VPossibleInfMap vpm) {
    _pp = pp;
    _jim = vpm;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _pp.findByPrimaruKey((VPossibleDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _pp.find((PossibleSearchDto)rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VPossibleDto();
  }

  private final String RET_PID = "rpid";
  private final String RET_KBN = "rkbn";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    PossibleSearchDto psd = new PossibleSearchDto();
    psd.setRetrieveValue(PossibleSearchDto.PLUGIN_ID, keyl.getRetrieve(RET_PID));
    psd.setRetrieveValue(PossibleSearchDto.KUBUN, keyl.getRetrieve(RET_KBN));
    psd.setOrderItem(PossibleSearchDto.PLUGIN_ID, 1);
    psd.setOrderItem(PossibleSearchDto.KUBUN, 2);
    psd.setOrderItem(PossibleSearchDto.KEY_ITEM, 3);
    return psd;
  }

  private final String TAG_ID = "possKbn";
  private final String TAG_NAME = "possKbnName";
  private final String KBN_NAME = "kbnDsp";
  private final String TAG_ID2 = "possTarget";
  private final String TAG_NAME2 = "possTargetName";
  private final String POSS_NAME = "possDsp";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#editItems(com.hamaf.hikyaku.dataobject.DetailItemsInterface, java.util.Map)
   */
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    Map<String, String> dt = mxc.getItemValue(TAG_ID, dii.getItemValue(VPossibleDto.KUBUN));
    mp.put(KBN_NAME, dt.get(TAG_NAME));
    dt = mxc.getItemValue(TAG_ID2, dii.getItemValue(VPossibleDto.TARGET_KUBUN));
    mp.put(POSS_NAME, dt.get(TAG_NAME2));
    return mp;
  }

}
