package com.hamaf.hikyaku.security.ui;

import java.text.MessageFormat;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.security.access.MessageAccess;
import com.hamaf.hikyaku.security.dto.MessageDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.MessageProcess;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFUserAdd is .</p>
 * <p>F[U[̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/03/17</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserAdd extends StandardCheckAndUpdate {

  private UserProcess _up = null;
  private MessageProcess _mp = null;

  /**
   *  Creates a new <code>UserAdd.java</code> instance.
   * <br>Default Constructor
   */
  public UserAdd(UserInfMap uim, UserProcess up, MessageProcess mp) {
    _jim = uim;
    _up = up;
    _mp = mp;
    _cfld = "UserAdd";
  }

  private final String ERRCD = "WCheckMsg";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkMaster(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
    UserDto ud = new UserDto();
    ud.setItemValue(UserDto.USER_ID, msg.getReq("uid"));
    ud = _up.findByPrimarykey(ud, session);
    if (!ud.isNotFound()) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.setResMsg("uid", resource.getString(ERRCD));
    }
    return super.checkMaster(msg);
  }

  private final String ADDOK = "UserAdd";
  private final String UKBN = "kbn";
  private final String KBN_GUEST = "guest";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _up.insert((UserDto)dii);
    msg.setResMsg(ADDOK, "1");
    if (KBN_GUEST.equals(msg.getReqStr(UKBN))) {
    	registMessage((UserDto)dii);
    }
    return msg;
  }

  private final String MSG_SUB = "GuestAddSub";
  private final String MSG_CON = "GustAddMsg";
  private void registMessage(UserDto ud) throws Exception {
  	MessageDto md = new MessageDto();
  	md.setItemValue(MessageDto.TO_KUBUN, MessageAccess.TO_KUBUN.MANAGER.getVal());
  	md.setItemValue(MessageDto.TO_USER, "manager");
  	md.setItemValue(MessageDto.FROM_USER, ud.getItemValue(UserDto.USER_ID));
  	md.setItemValue(MessageDto.REGISTER_DATE, DateUtil.getDate());
  	md.setItemValue(MessageDto.SUBJECT, resource.getString(MSG_SUB));
  	Object[] prm = {ud.getItemValue(UserDto.ABBREV), ud.getItemValue(UserDto.USER_ID)};
  	md.setItemValue(MessageDto.CONTENTS, MessageFormat.format(resource.getString(MSG_CON), prm));
  	_mp.addMessage(md);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }

}
