package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFUserMod is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/03/17</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserMod extends StandardCheckAndUpdate {

  private UserProcess _up = null;

  /**
   *  Creates a new <code>UserMod.java</code> instance.
   * <br>Default Constructor
   */
  public UserMod(UserInfMap uim, UserProcess up) {
    _jim = uim;
    _up = up;
    _cfld = "UserMod";
  }

  private final String MODOK = "UserMod";
  private final String MODMSG = "UpdateUserInf";
  private final String SELFCHK = "selfModFlg";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String uid = dii.getItemValue(UserDto.USER_ID);
    _up.update((UserDto)dii);
    msg.setResMsg(MODOK, "1");
    msg.addMessage(resource.getString(MODMSG));
    if ("1".equals(msg.getReqStr(SELFCHK))) {
      session.setAttribute(LogInCheck.USER_INF, _up.getDetailUserById(uid, session));   
    }
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }
}
