package com.hamaf.hikyaku.taglibs;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.Statement;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.access.ConnectFactory;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgF Db2Disp is DB item Display Tag.</p>
 * <p>FDBڂ\^OuB</p>
 * <br>w肳ꂽlPrimaryKeysAݒ肳ꂽڂ̒l߂B
 * <br>\ȃe[uPrimaryKeyڂ1̃e[ułB
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>l̍ږ</td>
 *   </tr>
 *   <tr>
 *     <td>table</td>
 *     <td>K{</td>
 *     <td>e[u</td>
 *   </tr>
 *   <tr>
 *     <td>keyColumn</td>
 *     <td>C</td>
 *     <td>L[Ƃ鍀ږ<br>
 *     (PrimaryKeyڂ1̏ꍇȗ\ŁA
 *      ȗPrimaryKeyڂɂȂ܂)</td>
 *   </tr>
 *   <tr>
 *     <td>dispColumn</td>
 *     <td>C</td>
 *     <td>\鍀ږ<br>
 *  (ȗxxxNAMEtB[hɂȂ܂)</td>
 *   </tr>
 *   <tr>
 *     <td>cond</td>
 *     <td>C</td>
 *     <td> (ǉ錟)</td>
 *   </tr>
 *   <tr>
 *     <td>dbkey</td>
 *     <td>C</td>
 *     <td>DBڑp̒`<br>
 *  }X^XML&lt;DbConnectCode&gt;̒l</td>
 *   </tr>
 *   <tr>
 *     <td>pid</td>
 *     <td>C</td>
 *     <td>vOCID<br>
 *  'dbkey'w肵ꍇAΏۂƂȂXML̃vOCID</td>
 *   </tr>
 * </table>
 *
 * <p>쌠: Copyright (c) 2007/06/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class Db2Disp extends TagSupport {

  private static final long serialVersionUID = 295682181614357598L;

  private String _item = null;
  private String _table = null;
  private String _keyColumn = null;
  private String _dispColumn = null;
  private String _cond = null;
  private String _pid = null;
  private String _dbkey = null;

  /**
   * Describe <code>doStartTag</code> method : ^OJnɌĂяo.
   * <br>w肳ꂽe[ulŃvC}sAw肳ꂽڂ̒l߂
   * <ul>
   *   <li>CommonMessage,KeyList'item'̒l擾
   *   <li>'table'PrimaryKeyږ擾
   *   <li>'column'null̏ꍇAŌオ<b>"NAME"</b>̍ږ擾
   *   <li>'table'PrimaryKeys'column'̒l擾
   * </ul>
   * @return an <code>int</code> : <code>EVAL_BODY_TAG</code>
   * @exception JspException if an error occurs
   */
  public int doStartTag() throws JspException {
    if (_item == null) {
      return SKIP_BODY;
    }

    String val = getItemVal();
    if (val == null || val.length() == 0) {
      return SKIP_BODY;
    }

    Connection conn = null;
    try{
      conn = ConnectFactory.getConnect(_dbkey, _pid);
      String knm = getKeyFld(conn);
      String fld = getNameFld(conn);
      if (knm == null || fld == null) {
        return SKIP_BODY;
      }

      pageContext.getOut().println(getDbValue(conn, createSql(knm, val, fld)));
    } catch(Exception e) {
      e.printStackTrace();
      throw new JspException(e);
    } finally {
      disConn(conn);
    }

    return SKIP_BODY;
  }
  // definition private methods
  private String getItemVal() {
    ServletRequest sr = pageContext.getRequest();
    CommonMessage cmm = (CommonMessage)sr.getAttribute(DistributeServlet.MAPPING_KEY);
    String val = null;
    if (cmm != null) {
      if (cmm.getErrorStatus() == STATUS.NORMAL) {
        val = cmm.getResMsg(_item);
      }
      if (val == null || val.equals("")) {
        val = cmm.getReq(_item);
      }
    }
    if (val == null || val.equals("")) {
      String proId = (String)
        pageContext.getSession().getAttribute(DistributeServlet.KEY_SAVE_ID);
      KeyList kl = (KeyList)pageContext.getSession().getAttribute(proId);
      if (kl != null) {
        val = kl.getRetrieve(_item);
      }
    }
    return val;
  }
  private String getKeyFld(Connection conn) throws Exception {
    if (_keyColumn != null) {
      return _keyColumn;
    }
    DatabaseMetaData dbmd = conn.getMetaData();
    ResultSet rs = null;
    if (dbmd.getDatabaseProductName().startsWith("Oracle")) {
      rs = dbmd.getPrimaryKeys(null, dbmd.getUserName(), _table);
    }
    else {
      rs = dbmd.getPrimaryKeys(null, null, _table);
    }

    String ret = null;
    if (rs.next()) {
      ret = rs.getString("COLUMN_NAME");
    }
    rs.close();
    return ret;
  }
  private String getNameFld(Connection conn) throws Exception {
    if (_dispColumn != null) {
      return _dispColumn;
    }

    DatabaseMetaData dbmd = conn.getMetaData();
    ResultSet rs = null;
    if (dbmd.getDatabaseProductName().startsWith("Oracle")) {
      rs = dbmd.getColumns(null, dbmd.getUserName(), _table, "%");
    }
    else {
      rs = dbmd.getColumns(null, null, _table, "%");
    }

    String ret = null;
    while (rs.next() && ret == null) {
      if (rs.getString("COLUMN_NAME").endsWith("NAME")) {
        ret = rs.getString("COLUMN_NAME");
      }
    }
    rs.close();
    return ret;
  }
  private String createSql(String kfld, String kval, String column) {
    StringBuffer sb = new StringBuffer();
    sb.append("select ");
    sb.append(column);
    sb.append(" from ");
    sb.append(_table);
    sb.append(" where ");
    sb.append(kfld);
    sb.append(" = '");
    sb.append(kval);
    sb.append("'");
    if (_cond != null && _cond.length() > 0) {
      sb.append(" AND ");
      sb.append(_cond);
    }
    return sb.toString();
  }
  private String getDbValue(Connection conn, String sql) throws Exception {
    Statement stm = conn.createStatement();
    String ret = "";
    try {
      ResultSet rs = stm.executeQuery(sql);
      if (rs.next()) {
        ret = rs.getString(1);
      }
      else {
        System.err.println("### Db2Disp NotFound SQL is " + sql);
      }
    } finally {
      stm.close();
    }
    return ret;
  }
  private void disConn(Connection conn) {
    if (conn == null) {
      return;
    } // end of if (conn == null)

    try {
      conn.close();
    }catch (Exception xe) {
      xe.printStackTrace();
    }
    conn = null;
  }

  /**
   * Describe <code>doEndTag</code> method : ^OIɌĂяo.
   *
   * @return an <code>int</code> : <code>EVAL_PAGE</code>
   * @exception JspException if an error occurs
   */
  public final int doEndTag() throws JspException {
    release();
    return EVAL_PAGE;
  }

  /**
   * Describe <code>release</code> method : ^O̓ԂZbg.
   */
  public void release() {
    _item = null;
    _table = null;
    _keyColumn = null;
    _dispColumn = null;
    _cond = null;
    _pid = null;
    _dbkey = null;
    super.release();
  }

  /**
   * @param cond cond ݒ肵܂B
   */
  public final void setCond(String cond) {
    _cond = cond;
  }
  /**
   * @param dispColumn dispColumn ݒ肵܂B
   */
  public final void setDispColumn(String dispColumn) {
    _dispColumn = dispColumn;
  }
  /**
   * @param item item ݒ肵܂B
   */
  public final void setItem(String item) {
    _item = item;
  }
  /**
   * @param keyColumn keyColumn ݒ肵܂B
   */
  public final void setKeyColumn(String keyColumn) {
    _keyColumn = keyColumn;
  }
  /**
   * @param table table ݒ肵܂B
   */
  public final void setTable(String table) {
    _table = table;
  }
	/**
	 * @param pid Zbg pid
	 */
	public void setPid(String pid) {
		_pid = pid;
	}

	/**
	 * @param dbkey Zbg dbkey
	 */
	public void setDbkey(String dbkey) {
		_dbkey = dbkey;
	}

}
