package com.hamaf.hikyaku.taglibs;

import java.net.MalformedURLException;
import java.text.MessageFormat;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;


/**
 * <p>^CgFDisplayPageControl is create page move button.</p>
 * <p>Fy[Wړp̕\𐶐</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>imgpt</td>
 *     <td>K{</td>
 *     <td>{^C[W݂pX <br>
 *     gif file(next_,prev_  s1,s2 y e_offt)KvƂȂ܂
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>directPageMoveFuncName</td>
 *     <td>C</td>
 *     <td>_CNgy[WړFunction@default=directPageMoveClick</td>
 *   </tr>
 *   <tr>
 *     <td>pageMoveFuncName</td>
 *     <td>C</td>
 *     <td>Oړ̏sFunction default=pageMoveClick</td>
 *   </tr>
 * </table>
 * 
 * <p>쌠: Copyright (c) 2007/05/08</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class DisplayPageControl extends TagSupport {

  private static final long serialVersionUID = 1161314216135798366L;
  private enum IMGS {
    EndIcon ("next_s2.gif"),
    EndGrayIcon ("next_s2_off.gif"),
    NextIcon ("next_s1.gif"),
    NextGrayIcon ("next_s1_off.gif"),
    FirstIcon ("prev_s2.gif"),
    FirstGrayIcon ("prev_s2_off.gif"),
    PrevIcon ("prev_s1.gif"),
    PrevGrayIcon ("prev_s1_off.gif");
    
    private final String val;
    IMGS(String dt) { val = dt; }
    public String eval() { return val; }
  };
  private static final String PAGETAG =
    "<table border='0'><tr><td>{0}</td><td>{1}</td><td>{2}</td></tr></table>";
    
  
  private String _directPageMoveFuncName = "directPageMoveClick";
  private String _pageMoveFuncName = "pageMoveClick";
  private String _imgpt;

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.SimpleTagSupport#doTag()
   */
  @Override
  public int doStartTag() throws JspException {
    String proId = (String)pageContext.getSession().getAttribute(DistributeServlet.KEY_SAVE_ID);
    KeyList keyList = (KeyList)pageContext.getSession().getAttribute(proId);
    if (keyList == null) {
      return SKIP_BODY;
    }
    
    Object[] prm = new Object[3];
    prm[0] = createPrevTag(keyList, _imgpt);
    prm[1] = createPageLink(keyList);
    prm[2] = createNextTag(keyList, _imgpt);

    try {
      pageContext.getOut().println(MessageFormat.format(PAGETAG, prm));
    } catch (Exception ioe) {
       throw new JspException(ioe.getMessage());
    }
    return SKIP_BODY;
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
     return EVAL_PAGE;
  }

  private static final String PREV_LINK_TAG = 
    "<span onclick=\"{2}(0); return false;\">\n" +
    "<img src=\"{0}\" height=\"24\" width=\"20\" style=\"border:0;cursor:pointer;\"></span>\n" +
    "<span onclick=\"{3}(''prev''); return false;\">\n" +
    "<img src=\"{1}\" height=\"24\" width=\"50\" style=\"border:0;cursor:pointer;\"></span>\n";
  private static final String PREV_NOLINK_TAG =
    "<img src=\"{0}\" height=\"24\" width=\"20\" style=\"border:0;\">\n" +
    "<img src=\"{1}\" height=\"24\" width=\"50\" style=\"border:0;\">\n";
  /**
   * Describe <code>createPrevTag</code> method : uOցv֌WHTMLԂ.
   * 
   * @param keyList a <code>KeyList</code>
   * @param path a <code>String</code> : C[Wt@Cւ̃pX
   * @return a <code>String</code> : Tag
   */
  private String createPrevTag(KeyList keyList, String path){
    String tagFrmt = null;
    Object[] prm = new Object[4];
    prm[2] = _directPageMoveFuncName;
    prm[3] = _pageMoveFuncName;
    try {
      if (keyList.hasBackPage()) {
        tagFrmt = PREV_LINK_TAG;
        prm[0] = getIconPath(path, IMGS.FirstIcon);
        prm[1] = getIconPath(path, IMGS.PrevIcon);
      }
      else {
        tagFrmt = PREV_NOLINK_TAG;
        prm[0] = getIconPath(path, IMGS.FirstGrayIcon);
        prm[1] = getIconPath(path, IMGS.PrevGrayIcon);
      }
    } catch (MalformedURLException e) {
      e.printStackTrace();
      throw new RuntimeException();
    }

    return MessageFormat.format(tagFrmt, prm);
  }
  
  private static final String NEXT_LINK_TAG =
    "<span onclick=\"{3}(''next''); return false;\">\n" +
    "<img src=\"{0}\" height=\"24\" width=\"50\" style=\"border:0;cursor:pointer;\"></span>\n" +
    "<span onclick=\"{2}({4}); return false;\">\n" +
    "<img src=\"{1}\" height=\"24\" width=\"20\" style=\"border:0;cursor:pointer;\"></span>\n";
  private static final String NEXT_NOLINK_TAG =
    "<img src=\"{0}\" height=\"24\" width=\"50\" style=\"border:0;\">\n" +
    "<img src=\"{1}\" height=\"24\" width=\"20\" style=\"border:0;\">\n";
  /**
   * uցv֌W̃NHTMLԂ
   * @param keyList
   * @return
   */
  private String createNextTag(KeyList keyList, String path){
    String tagFrmt = null;
    Object[] prm = new Object[5];
    prm[2] = _directPageMoveFuncName;
    prm[3] = _pageMoveFuncName;
    prm[4] = String.valueOf(keyList.getMaxPageNo() - 1);
    try {
      if (keyList.hasNextPage()) {
        tagFrmt = NEXT_LINK_TAG;
        prm[0] = getIconPath(path, IMGS.NextIcon);
        prm[1] = getIconPath(path, IMGS.EndIcon);
      }
      else {
        tagFrmt = NEXT_NOLINK_TAG;
        prm[0] = getIconPath(path, IMGS.NextGrayIcon);
        prm[1] = getIconPath(path, IMGS.EndGrayIcon);
      }
    } catch (MalformedURLException e) {
      e.printStackTrace();
      throw new RuntimeException();
    }

    return MessageFormat.format(tagFrmt, prm);
  }

  private static final String LINK_DSP =
    "<a href=''#'' onclick=\"{0}({1}); return false;\">{2}</a>&nbsp;\n";
  private static final String NON_DISP = "&nbsp;&nbsp;&nbsp;&nbsp;";
  private static final String CUURENT_PAGE_DSP = "<b>{0}</b>&nbsp;";
  private static final String OVER_CHAR = "...";
  /**
   * y[WNHTMLHTMLԂ
   * @param keyList
   * @return
   */
  private String createPageLink(KeyList keyList){
    StringBuilder sb = new StringBuilder();
    
    int pagingLinkSize = getPageLinkSize(keyList);
    int startPage = (keyList.getCurrentPage() / pagingLinkSize) * pagingLinkSize + 1;
    int maxPage = keyList.getMaxPageNo();
    Object[] prm = new Object[3];
    prm[0] = _directPageMoveFuncName;
    
    if(startPage > 1){
      prm[1] = String.valueOf(startPage - 2);  // Hikyakũy[WǗ̓[n܂̈ -2
      prm[2] = OVER_CHAR;
      sb.append(MessageFormat.format(LINK_DSP, prm));
    }else{
      sb.append(NON_DISP);
    }
    
    int endPage = Math.min(startPage + pagingLinkSize -1, maxPage);
    for(int ii = startPage; ii <= endPage; ii++){
      if(ii == keyList.getCurrentPage()+1){
        Object[] prm2 = new Object[1];
        prm2[0] = String.valueOf(ii);
        sb.append(MessageFormat.format(CUURENT_PAGE_DSP, prm2));
      }else{
        prm[1] = String.valueOf(ii - 1);
        prm[2] = String.valueOf(ii);
        sb.append(MessageFormat.format(LINK_DSP, prm));
      }
    }

    if(maxPage > endPage){
      prm[1] = String.valueOf(endPage);
      prm[2] = OVER_CHAR;
      sb.append(MessageFormat.format(LINK_DSP, prm));
    }else{
      sb.append(NON_DISP);
    }
    
    return sb.toString();
  }
  
  private static final String PAGE_SIZE = "pagingLinkSize";
  private int getPageLinkSize(KeyList keyList) {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(keyList.getSysId());
    String pgs = mxc.getConstant(PAGE_SIZE);
    if (pgs == null || pgs.length() == 0) { pgs = "10"; }
    return Integer.valueOf(pgs);
  }

  /**
   * Describe <code>getIconPath</code> method : getting icon file url.
   * <br>w肳ꂽ摜URL߂B
   * 
   * @param path a <code>String</code> : C[Wt@C̃pX
   * @param img a <code>IMGS</code> : 擾C[W
   * @return a <code>String</code> : C[Wt@CURL
   * @throws MalformedURLException
   */
  private String getIconPath(String path, IMGS img) throws MalformedURLException {
    StringBuilder sb = new StringBuilder();
    sb.append(path);
    sb.append("/");
    sb.append(img.eval());
//    String iconPath = pageContext.getServletContext().getResource(sb.toString()).getPath();
//    int pos = iconPath.indexOf("/", 2);
//    return iconPath.substring(pos);
    return sb.toString();
  }

  public final void setDirectPageMoveFuncName(String directPageMoveFuncName) {
    this._directPageMoveFuncName = directPageMoveFuncName;
  }
  public final void setPageMoveFuncName(String pageMoveFuncName) {
    this._pageMoveFuncName = pageMoveFuncName;
  }
  public final void setImgpt(String imgpt) {
    _imgpt = imgpt;
  }

}
