package com.hamaf.hikyaku.taglibs;

import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.util.JspUtils;
import com.hamaf.hikyaku.util.TextUtil;


/**
 * <p>^CgFListDispItem is .</p>
 * <p>F</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>name</td>
 *     <td>K{</td>
 *     <td>擾鍀ږ</td>
 *   </tr>
 *   <tr>
 *     <td>pos</td>
 *     <td>C</td>
 *     <td>Ώۃf[^̈ʒu</td>
 *   </tr>
 *   <tr>
 *     <td>mpos</td>
 *     <td>C</td>
 *     <td>Ώۃf[^o^ĂMap<br>
 *     LAposmpos̉ꂩw肷B</td>
 *   </tr>
 *   <tr>
 *     <td>nl2br</td>
 *     <td>C</td>
 *     <td>sR[h&lt;br&gt;ɕϊꍇA"yes"w肷B</td>
 *   </tr>
 *   <tr>
 *     <td>nocnv</td>
 *     <td>C</td>
 *     <td>^O̕ϊsȂꍇA"yes"ݒ肵܂B</td>
 *   </tr>
 * </table>
 *
 * <p>쌠: Copyright (c) 2007/05/17</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ListDispItem extends TagSupport {

  private static final long serialVersionUID = 729583089293978056L;
  private String _pos = null;
  private Map<String, String> _mpos = null;
  private String _name = null;
  private String _nl2br = null;
  private String _nocnv = null;

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.TagSupport#doStartTag()
   */
  @Override
  public int doStartTag() throws JspException {
    Map<String, String> dt = _mpos;
    CommonMessage msg = (CommonMessage)pageContext.getRequest().getAttribute(DistributeServlet.MAPPING_KEY);
    if (dt == null) {
      if (_pos == null) return SKIP_BODY;
      dt = msg.getResList().get(Integer.parseInt(_pos));
    }
    String val = dt.get(_name);
    boolean ncnv = false;
    if (_nocnv != null && _nocnv.length() > 0) {
      if (_nocnv.toUpperCase().startsWith("T") ||
          _nocnv.toUpperCase().startsWith("Y")) ncnv = true;
    }
    if (!ncnv) val = TextUtil.cnvJsp(val, msg.getCharCd());
    if (_nl2br != null && _nl2br.length() >0 ) {
      if (_nl2br.toLowerCase().startsWith("y") ||
          _nl2br.toLowerCase().startsWith("t")) val = JspUtils.changeNL2BR(val);
    }
    try {
      pageContext.getOut().println(val);
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
    return SKIP_BODY;
  }

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.TagSupport#doEndTag()
   */
  @Override
  public final int doEndTag() throws JspException {
    release();
    return EVAL_PAGE;
  }

  /* (Javadoc Ȃ)
   * @see javax.servlet.jsp.tagext.TagSupport#release()
   */
  @Override
  public void release() {
    _pos = null;
    _mpos = null;
    _name = null;
    _nl2br = null;
    _nocnv = null;
    super.release();
  }

  /**
   * @param mpos mpos ݒ肵܂B
   */
  public final void setMpos(Map<String, String> mpos) {
    _mpos = mpos;
  }

  /**
   * @param name name ݒ肵܂B
   */
  public final void setName(String name) {
    _name = name;
  }

  /**
   * @param pos pos ݒ肵܂B
   */
  public final void setPos(String pos) {
    _pos = pos;
  }

  /**
   * @param nl2br nl2br ݒ肵܂B
   */
  public final void setNl2br(String nl2br) {
    _nl2br = nl2br;
  }

  /**
   * @param nocnv Zbg nocnv
   */
  public void setNocnv(String nocnv) {
    _nocnv = nocnv;
  }

}
