package com.hamaf.hikyaku.ui;

import java.text.MessageFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.ControlXml;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import static com.hamaf.hikyaku.dataobject.KeyList.PAGE_ACT;
import static com.hamaf.hikyaku.distribute.ControlXml.PROCCONT;
import static com.hamaf.hikyaku.distribute.ControlXml.ROOTCONT;

/**
 * <p>^CgFListProcessBase is List Process Bean base class.</p>
 * <p>Fꗗ\pJavaBeañx[XƂȂNXB</p>
 * 
 * <br><code>ProcessBean</code><code>exec</code>\bhOverWriteA
 * <br>pNXׂ̃AuXgNg\bh`܂B
 * <ul>
 *   <li>getKeys : ꗗ\f[^Keyڂ̔z쐬郁\bh
 *   <li>getItem : Keyڂꗗ\p̍ڂ擾郁\bh
 * </ul>
 * 
 * ꗗpKeyڔzǗ邽߂ɁA<code>KeyList</code>NXCX^X
 * Kyeڔzݒ肵sessionɕۑ܂B
 * <br>t@C<code>(Hikyaku.xml)</code>&lt;KeySave&gt;^O"Yes"ݒ肷
 * <b><i>KeyList.KeyData</i></b>t@CɑޔNAB
 * <br>(sessionɕێ郁[ʂ팸邱Ƃo܂)
 * <br>
 * <br>NGXgbZ[W<b>pageAction</b>̒lɂA삪肳܂B
 * <ul>
 *   <li>get : bZ[W̌lɂKeyڂ̔z𐶐APy[Wڂ̕\s
 *      <br>NCAg̃NGXgKeyLisťMap֐ݒ肵܂B
 *      <br>ڂɃG[ꍇACommonMessagẽbZ[WXgɃbZ[Wݒ肵WARNINGŖ߂܂B
 *      <br>\f[^݂ȂꍇACAUTIONŖ߂܂B
 *   <li>reget : ۑĂiÓjlɂKeyڂ̔z𐶐APy[Wڂ̕\s
 *      <br>\f[^݂ȂꍇACAUTIONŖ߂܂B
 *   <li>next : ̕ł̕\s
 *      <br>\f[^݂ȂꍇAł̍ĕ\ƂȂ܂B
 *   <li>prev : O̕ł̕\s
 *      <br>\f[^݂ȂꍇAł̍ĕ\ƂȂ܂B
 *   <li>same : ł̍ĕ\si\ڂ͍Ď擾܂j
 * </ul>
 *
 * Py[Wɕ\s pageAction  get,reget ̎Ɏ̏Ō肳܂B
 * <OL Type="i" STYLE="List-Style-Type : Lower-Roman">
 *   <li>NGXgbZ[ẂApageLine̒l
 *   <li>rXmlPageLine̒l
 *   <li>Kl 30 Line/Page
 * </ol>
 * 
 * <p>쌠: Copyright (c) 2003/12/27</p>
 * @author Hamanaka
 * @version 1.0
 */
public abstract class ListProcessBase extends ProcessBase {

  protected KeyList _keys = null;
  protected String _pageAct = null;
  protected int _keyPos;

  private static final String PAGELINE = "pageLine";
  private static final String CURPG = "currentPage";
  private static final String PAGEACT = "pageAction";
  private static final String PA_GET = "get";
  private static final String PA_RGET = "reget";
  
  private Map<String, PAGE_ACT> _pact = new HashMap<String, PAGE_ACT>();
  {
    _pact.put(PA_GET, PAGE_ACT.FORWARD);
    _pact.put(PA_RGET, PAGE_ACT.FORWARD);
    _pact.put("next", PAGE_ACT.FORWARD);
    _pact.put("prev", PAGE_ACT.BACK);
    _pact.put("same", PAGE_ACT.SAME);
  };

  /**
   * Describe <code>exec</code> method : Hikyaku Process exec Method.
   * <br>rƖNX̎s(exec)\bhꗗ\pɃI[o[Cg
   * @param msg a <code>CommonMessage</code> : ʏbZ[W
   * @return a <code>CommonMessage</code> : ʏbZ[W
   * @exception Exception if an error occurs
   */
  public final CommonMessage exec(CommonMessage msg) throws Exception {
    log.fine(msgHed + resource.getString("ListStart"));
    
    String ks = ControlXml.newInstance().getRootDef(msg.getSysId(), ROOTCONT.KeySave);
    if (ks == null) ks = "";
    else if (ks.length() > 0) ks = ks.toLowerCase().substring(0, 1);
    
    _pageAct = msg.getReqStr(PAGEACT).toLowerCase();
    if (_pageAct.length() == 0) {
      throw new IllegalStateException(resource.getString("ListErr01"));
    }
    if (_pact.get(_pageAct) == null) {
      Object[] mmsg ={_pageAct};
      throw new IllegalStateException
        (MessageFormat.format(resource.getString("ListErr02"),mmsg));
    }
    
    _keys = (KeyList)saveObj;
    if (!_pageAct.equals(PA_GET) && _keys == null) {
      return msg;
    }
    
    msg = spareAction(msg, _pageAct);    

    if (_pageAct.equals(PA_GET) || _pageAct.equals(PA_RGET)) {
      if (_pageAct.equals(PA_GET)) {
        createKeyList(msg);
      }
      else {
        _keys.init();        
      }
      keyGet(msg);
      saveObj = _keys;
      if (msg.getErrorStatus() != STATUS.NORMAL) {
        return msg;
      }
    }
    else {
      if ("y".equals(ks)) _keys.resetKeyData();
      _keys.setCurrentPage(msg.getReq(CURPG));
    }
    
    msg = setListData(msg, _pact.get(_pageAct));
    
    msg = supplementEdit(msg, _keys, _pageAct);
    
    if ("y".equals(ks)) {
      if (_pageAct.equals(PA_GET) || _pageAct.equals(PA_RGET)) _keys.saveKeyData();
      _keys.releaseKeyData();
    }
    log.fine(msgHed + resource.getString("ListEnd"));
    return msg;
  }

  /**
   * Describe <code>keyGet</code> method : create key list.
   * <br>ڂ̒lAsKeyl<code>KeyList</code> Objectɐݒ肷B
   * @param msg a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   */
  private void keyGet(CommonMessage msg) {
    log.fine(msgHed + resource.getString("ListKeyGet"));
    try {
      _keys = getKeys(_keys);
    } catch (IllegalRetrieveDataException ae) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.addMessage(ae.getMessage());
      if (ae.getErrData() != null) {
        msg.setResMessage(ae.getErrData());
      }
      ae.printStackTrace();
      return;
    }

    if (_keys.getDataCount() == 0) {
      msg.setErrorStatus(STATUS.CAUTION);
      return;
    }

    if (msg.getReqStr(PAGELINE).length() > 0) {
      _keys.setPageCount(msg.getReq(PAGELINE));
    }
    else {
      try {
        String pcnt = ControlXml.newInstance().getProcDef(process, sysId, PROCCONT.PageLine);
        if (pcnt.length() > 0) {
          _keys.setPageCount(pcnt);
        }
      }
      catch (Exception de) {
        de.printStackTrace();
      }
    }

    msg.setErrorStatus(STATUS.NORMAL);
  }

  /**
   * Describe <code>setListData</code> method : set List item in CommonMessage.
   * <br>
   * @param msg a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   * @param pos an <code>int</code> :
   * @return a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   * @exception Exception if an error occurs
   */
  private CommonMessage setListData(CommonMessage msg, PAGE_ACT pos) throws Exception {
    log.fine(msgHed + resource.getString("ListDataGet"));
    List<String> keyItem = null;
    try {
      keyItem = _keys.getStartKey(pos);
    }  catch (IndexOutOfBoundsException ei) {
      msg.addMessage(ei.getMessage());
      msg.setErrorStatus(STATUS.WARNING);
      return msg;
    }
    _keyPos = _keys.getLastPos() - 1;
    msg.addResList(getItem(keyItem));
    while (_keys.hasNext()) {
      keyItem = _keys.getNextKey();
      _keyPos = _keys.getLastPos() - 1;
      msg.addResList(getItem(keyItem));
    }
    msg.setErrorStatus(STATUS.NORMAL);
    return msg;
  }

  /**
   * Describe <code>createStringMap</code> method : create key, String.value map
   * <br>NGXgp[^̍ڂƒlMap쐬B
   * @param msg a <code>CommonMessage</code>
   */
  private void createKeyList(CommonMessage msg) {
    Map<String, String> strmp = new HashMap<String, String>();
    for (String element : msg.getReqKeys()) {
      strmp.put(element, msg.getReqStr(element));
    }
    
    if (_keys == null) {
      _keys = new KeyList(strmp);
      _keys.setSysId(sysId);
      _keys.setProcess(process);
      _keys.setCharCD(msg.getCharCd());
    } else {
      _keys.getRetrieveAll().clear();
      _keys.getRetrieveAll().putAll(strmp);
      _keys.init();
    }
    return;
  }

  /**
   * Describe <code>getKeys</code> method : set Key List.
   * <br>ꗗ\̊esɑΉKeylListݒ肷B
   * <br>ȉ̎菇KeyList Classɐݒ肵܂B
   * <ol>
   *   <li>KeyList Class ɐݒ肳Ă錟ڂMapAgetRetrieve()Ōl擾B
   *   <li>ڂɃG[ꍇ́AO𓊂B
   *   <li>lꗗ\Ώۃf[^Key Object擾B
   *   <li>擾Key ObjectsetKey()\bhgpāAKeyList Classɐݒ肷B
   * </ol>
   * @param key a <code>KeyList</code> : ꗗ\p̃L[XgǗNX
   * @return a <code>KeyList</code> : ꗗ\p̃L[XgǗNX
   * @exception IllegalRetrieveDataException : ڂɃG[ꍇɓO
   */
  protected abstract KeyList getKeys(KeyList key)
    throws IllegalRetrieveDataException;

  /**
   * Describe <code>getItem</code> method : set Linr Item.
   * <br>ꗗ\p̍ڂ擾B
   * <br>Keyl̃IuWFNgAꗗ\̂Ps̍ڂݒ肵Object𐶐߂B
   * @param keyItem an <code>Object</code> : Keyl̃IuWFNg
   * @return an <code>Map</code> : \ڂ̃IuWFNg
   * @exception Exception if an error occurs
   */
  protected abstract Map<String, String> getItem(List<String> keyItem) throws Exception;

  /**
   * Describe <code>spareAction</code> method : spare process.
   * <br>ꗗł̗\p̃\bhB
   * <br>ꗗ̍ŏɌĂяo܂B
   * @param msg@a <code>CommonMessage</code>
   * @param act@a <code>String</code> : pageAction̒l
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  protected CommonMessage spareAction(CommonMessage msg, String act)
    throws Exception {
    return msg;
  }

  /**
   * Describe <code>saveSpare</code> method : save Obejct at current position in spare area of keyList.
   * <br>KeyList̗\̈Ɍ݂̈ʒuŕۑB
   * @param val an <code>Object</code> : ۑl
   */
  protected final void saveSpare(Object val) {
    if (_keys == null) {
      return;
    } // end of if (create keyList)
    _keys.setSpare(_keyPos, val);
  }

  /**
   * Describe <code>getSpare</code> method : get object at current position in spare area of keyList.
   * <br>KeyList̗\̈悩猻݈ʒu̒l擾B
   * @return an <code>Object</code> : 擾l
   */
  protected final Object getSpare() {
    return _keys.getSpare(_keyPos);
  }
  
  /**
   * Describe <code>supplementEdit</code> method : supplement CommonMessage.
   * <br><b>CommonMessage</b>ւ̕⑫ݒsA\p̃\bhB
   * <br>ꗗ̍ŌɌĂяo܂B
   * 
   * @param msg a <code>CommonMessage</code> : 
   * @param kl a <code>KeyList</code> : 
   * @param pact a <code>String</code> : PageAction
   * @return a <code>CommonMessage</code> : 
   * @exception Exception if an error occurs
   */
  protected CommonMessage supplementEdit(CommonMessage msg, KeyList kl, String pact)
    throws Exception {
    return msg;
  }
  
}
