package com.hamaf.hikyaku.ui;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Enumeration;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.MultiCommonMessage;
import com.hamaf.hikyaku.distribute.ControlXml;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.distribute.MultipartServletRequest;
import com.hamaf.hikyaku.distribute.ControlXml.ROOTCONT;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFMultipartProcessBase is Multipart request ProcessBase Class.</p>
 * <p>FmultipartőMꂽf[^ProcessBaseNX</p>
 * <br>CommonMessage̕ςMultiCommonMessagegp
 * <br>t@Ct@C̓e邱Ƃ\ɂ܂B
 * <br>NGXg<code>fileWrite</code><b>yes</b>̏ꍇɂ́A
 * Mt@Ce|[ɏo܂B
 * <br>ȊȌꍇ́AMꂽt@CByteArrayInputStreamɕϊ܂B
 * <br>
 * <br>MultipartServletRequest<code>"multiRequest"</code>ŗp\łB
 * <br>AAMultipartServletRequestĂȂꍇ́A<b>null</b>
 * ȂĂ܂B
 * <br>
 * <br>݂̂ƂPt@C̑MɂΉĂ܂B
 *
 * <p>쌠: Copyright (c) 2004/03/03</p>
 * @author Hamanaka
 * @version 1.0
 */
public abstract class MultipartProcessBase extends ProcessBase {

  private static final String MAXSIZE = "2M";
  private static final String PARM_MAX = "maxSize";
  private static final String PARM_WRT = "fileWrite";

  private static final String TEMP_PREFIX = "Hikyaku";

  protected final CommonMessage newCommonMessage() {
    log.fine(msgHed + resource.getString("MultiInit"));

    MultiCommonMessage mcm = new MultiCommonMessage();
    mcm.setErrorStatus(STATUS.NORMAL);
    mcm.setSession(session);
    mcm.setSysId(sysId);
    mcm.setCharCd(DistributeServlet.CHAR);
    for (Enumeration<?> enumt = request.getParameterNames(); enumt.hasMoreElements();) {
      String elm = (String)enumt.nextElement();
      mcm.setReq(elm, request.getParameterValues(elm));
    }
    mcm.setMaxSize(getMaxSize());

    if (!(request instanceof MultipartServletRequest)) {
      return mcm;
    }
    MultipartServletRequest multiRequest = (MultipartServletRequest)request;
    String orgFname = multiRequest.getSfName();
    mcm.setFileName(orgFname);
    if (orgFname == null || orgFname.length() == 0) {
      return mcm;
    }
    mcm.setContentType(multiRequest.getContType());

    ByteArrayOutputStream baos = multiRequest.getSavefl();
    mcm.setFileSize(baos.size());

    if ("yes".equals(request.getParameter(PARM_WRT).toLowerCase())) {
      String tfl = writeTemp(baos, orgFname);
      if (tfl != null) {
        mcm.setFile(true);
        mcm.setTempFileUrl(tfl);
        return mcm;
      }
    }

    ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
    mcm.setInput(bais);
    return mcm;
  }

  private String getMaxSize() {
    String maxsz = request.getParameter(PARM_MAX);
    if (maxsz == null) {
      maxsz = ControlXml.newInstance().getRootDef(sysId, ROOTCONT.MaxFileSize);
    }
    if (maxsz == null) {
      maxsz = MAXSIZE;
    }
    return maxsz;
  }

  private String writeTemp(ByteArrayOutputStream baos, String orgFN) {
    String sfx = null;
    int pos = orgFN.lastIndexOf(".");
    if (pos >= 0) {
      sfx = orgFN.substring(pos);
    }

    File tmp = null;
    try {
      tmp = File.createTempFile(TEMP_PREFIX, sfx);
      FileOutputStream fos = new FileOutputStream(tmp);
      fos.write(baos.toByteArray());
      fos.close();
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    }

    return tmp.getAbsolutePath();
  }

}
