package com.hamaf.hikyaku.ui;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.JspItemsMapping;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.RetrieveUnitCheck;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;


/**
 * <p>^CgF StandardListProcess Wꗗ\p ListProcess.</p>
 * <p>Fꗗ\p<b>ListProcessBase</b>gNXB</p>
 * <br>ȉ̏Lq܂
 * <table border="1">
 *   <tr bgcolor="#eeeeff">
 *     <td>b\h</td>
 *     <td>K{/C</td>
 *     <td>T</td>
 *   </tr>
 *   <tr>
 *     <td>setRetrieveVal</td>
 *     <td>K{</td>
 *     <td>p<b>DetaObject</b>Ɍݒ肷</td>
 *   </tr>
 *   <tr>
 *     <td>findKeys</td>
 *     <td>K{</td>
 *     <td>Rg[ĂяoʂDetaObject߂</td>
 *   </tr>
 *   <tr>
 *     <td>newDataObj</td>
 *     <td>K{</td>
 *     <td>ڍ׎擾p<b>DetaObejct</b>𐶐Ė߂</td>
 *   </tr>
 *   <tr>
 *     <td>callControl</td>
 *     <td>K{</td>
 *     <td>Rg[̌Ăяos</td>
 *   </tr>
 *   <tr>
 *     <td>checkDelete</td>
 *     <td>K{</td>
 *     <td>폜f[^̃`FbNs</td>
 *   </tr>
 *   <tr>
 *     <td>getCheckFolder</td>
 *     <td>C</td>
 *     <td>ڂ̍ڃ`FbNp̃tH_߂
 *        <br>DiContainarɂARXgN^[<b>_cfld</b>ɐݒ肵Ă܂܂B
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>selectKeys</td>
 *     <td>C</td>
 *     <td>ʂ̃L[XgҏWB</td>
 *   </tr>
 *   <tr>
 *     <td>setJspMapping</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕RtNXo^
 *        <br>DiContainarɂARXgN^[<b>_jim</b>ɐݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setItems</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕Rto^
 *        <br>LA<b>setJspMapping</b>Őݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>editItems</td>
 *     <td>C</td>
 *     <td>ꗗ\pڂ̕ҏWs</td>
 *   </tr>
 * </table>
 * <br>DiContainer𗘗pꍇARXgN^ňȉ̈ݒ\łB
 * <ul>
 *   <li>String (ڃ`FbNptH_) : _cfld ɐݒ肷
 *   <li>JspItemsMapping : _jim ɐݒ肷
 * </ul>
 *
 * <p>쌠: Copyright (c) 2007/05/29</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class StandardListProcess extends ListProcessBase {

  public static final String POSNM = "ListPosition";

  /**
   * _cfld a <code>String</code> : ڃ`FbNp̃tH_[
   */
  protected String _chkFld = null;
  /**
   * _jim a <code>JspItemsMapping</code> : JSPږ́Ff[^IuWFNgڑΉNX
   */
  protected JspItemsMapping _jim= null;

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#getKeys(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected final KeyList getKeys(KeyList key) throws IllegalRetrieveDataException {
    if (_chkFld == null) {
      _chkFld = getCheckFolder();
    }
    if (_chkFld != null && _chkFld.length() > 0) {
      RetrieveUnitCheck.retItemCheck(key, _chkFld);
    }

    RetrieveKeysInterface rki = setRetrieveVal(key);
    rki.setSysId(sysId);
    rki.setDel(USE_FLG.USE);
    try {
      rki = findKeys(rki);
      key.setKeyDataAll(selectKeys(rki.getKeys()));
      key.setKeyFields(rki.getPkeyFld());
    } catch (SQLException se) {
      throw new IllegalRetrieveDataException
        ("SQL ERROR : " + se.getMessage(), new HashMap<String, String>());
    } catch (Exception xe) {
      throw new IllegalRetrieveDataException
        ("Other ERROR : " + xe.getMessage(), new HashMap<String, String>());
    }
    return key;
  }


  /**
   * Describe <code>getCheckFolder</code> method : ڃ`FbNtH_̎擾.
   * <br>iDiContainaergpRXgN^[Őݒ肷ꍇ́AsvłBj
   * <br>ڂ̍ڃ`FbNsꍇɁA<b>override</b>ătH_߂B
   * <br>ڃ`FbNsȂꍇ́AsvłB
   * @return a <code>String</code> : ڃ`FbÑtH_
   */
  protected String getCheckFolder() {
    return null;
  }

  /**
   * Describe <code>setRetrieveVal</code> method : pDateObject̐Al̐ݒ.
   * <br>pDetaObject<code> (RetrieveKeysInterface rki) </code>𐶐ڂݒ肷B
   * <br>ex. RetrieveKeysInterface@rki = new xxxxRetDtObj();
   * <br> rki.setRetrieveValue(XXTblListDto.KEY_ITEM, keyl.getRetrieve("jspږ"));
   * <p>ڐݒ莞ɃG[ꍇ́A<code>IllegalRetrieveDataException</code>
   *  𐶐Ė߂B
   * <pre>
   * ̍ہAG[ږƃG[bZ[Wݒ肵Mapݒ肷B
   *    ex. Map&lt;String, String&gt; errmp = new HashMap&lt;String, String&gt;();
   *        errmp.put("jspږ", "G[bZ[W");
   *        throws new IllegalRetrieveDataException("bZ[W", errmp);
   * </pre>
   *
   * @param keyl a <code>KeyList</code>
   * @exception IllegalRetrieveDataException if an error occurs
   */
  protected abstract RetrieveKeysInterface setRetrieveVal(KeyList keyl)
    throws IllegalRetrieveDataException;

  /**
   * Describe <code>findKeys</code> method : ʂ擾.
   * <br>Rg[NXĂяoA߂lDetaObject߂B
   * <ol>
   *    <li>_Process_Control xcntl = new _Process_Control();
   *    <li>return xcntl.getKeys(rki);
   * </ol>
   * @param rki a <code>RetrieveKeysInterface</code>
   * @return a <code>RetrieveKeysInterface</code>
   * @exception Exception if an error occurs
   */
  protected abstract RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
    throws Exception;

  /**
   * Describe <code>selectKeys</code> method : L[̈ꗗIs.
   * <br>Rg[擾L[XgAf[^̑IsꍇɎgpB
   *
   * @param keys a <code>List&lt;List&lt;String&gt;&gt;</code> : 擾L[̃Xg
   * @return a <code>List&lt;List&lt;String&gt;&gt;</code> : ĨL[̃Xg
   */
  protected List<List<String>> selectKeys(List<List<String>> keys) {
    return keys;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#getItem(java.util.List)
   */
  @Override
  protected final Map<String, String> getItem(List<String> keyItem) throws Exception {
    if (_jim == null) {
      _jim = setJspMapping();
      if (_jim == null) {
        _jim = new JspItemsMapping();
        setItems();
      }
    }

    DetailItemsInterface dii = newDataObj();
    setRequestFields(dii);
    dii = setGetKey(dii, keyItem);
    dii.setSysId(sysId);
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      dii.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    dii = callControl(dii);

    Map<String, String> ret = setDisplayItems(dii);
    return editItems(dii, ret);
  }

  /**
   * Describe <code>setJspMapping</code> method : JSP}bsO̐ݒs.
   * <br>iDiContainaergpRXgN^[Őݒ肷ꍇ́AsvłBj
   * <br>JspItemsMappinǧpNXCX^XA߂B
   * <br>return new xxxMapping();
   */
  protected JspItemsMapping setJspMapping() {
    return null;
  }

  /**
   * Describe <code>setItems</code> method : ڂ̓o^.
   * <br>iJspItemsMapping̊gNXgpꍇ́AsetJspMapping𗘗p܂j
   * <br>鍀ڂ<b>DeataObject</b>̒`l(<code>int</code>)JSPł̖̂Ƃ
   *  Rto^B
   * <br>{Iɂ
   * <br> addItem(DataObject.ITEM_NAME, "JSPł̍ږ");
   * <br>ɂĕKvڕARto^sB
   */
  protected void setItems() { }

  /**
   * Describe <code>addItem</code> method : 擾ڔԍ:\ږ̗pMapւ̓o^.
   * <br>_items(<code>Map</code>)ɍڔԍJSPł̍ږ̕Rto^B
   * <ol>
   *  <li>key : JSPŎw肳Ă鍀ڂ̖(<code>String</code>)
   *  <li>value : DetailItemsInterfaceNX̍ڔԍ
   * </ol>
   * @param jspnm a <code>String</code> : JSPł̍ږ
   * @param pos an <code>int</code> : f[^ObjectŒ`Ă鍀ڈʒu
   */
  protected final void addItem(String jspnm, int pos) {
    _jim.addItem(jspnm, pos);
  }

  /**
   * Describe <code>newDataObj</code> method : ڍחpDataObject̐.
   * <br>ڍ׃f[^擾pDataObject𐶐B
   * <br>{Iɂ́A
   * <br> return new _DetailDTO_();
   * <br>ƂȂ܂B
   * @return a <code>DetailItemsInterface</code> : DataObject
   */
  protected abstract DetailItemsInterface newDataObj();

  /**
   * Describe <code>setGetKey</code> method : ꗗ\pL[̐ݒ.
   * <br>f[^IuWFNgɁAL[ڒlݒ肵Ė߂B
   * <br><code>DetaObject</code>PrimaryKeyږA̍ږƈvꍇ́A
   * <br>̂܂܎gpł܂B
   * <br>LȊȌꍇɂ́A<b>override</b>āAKeyl̐ݒs܂B
   * <ol>
   *   <li>f[^IuWFNg<b>keys</b>AL[lݒ肷B
   *     <br>ex. dtobj.setItemValue(_XXDtlDto_.KEY_ITEM, keys.get(0));
   *   <li>f[^IuWFNg߂B
   *     <br>ex. return dtobj;
   * </ol>
   * @param dii a <code>DetailItemsInterface</code>
   * @param key a <code>List</code> : KeyListɕۑKey̒l̔z
   * @return a <code>DetailItemsInterface</code>
   */
  protected DetailItemsInterface setGetKey(DetailItemsInterface dii, List<String> key) {
    for (int i = 0; i < key.size(); i++) {
      dii.setFldValue(_keys.getKeyFields().get(i), key.get(i));
    }
    return dii;
  }

  /**
   * Describe <code>setRequestFields</code> method : 擾ڂ̐ݒ.
   * <br>_jim擾鍀ڂ̐ݒsB
   * @param dii a <code>DetailItemsInterface</code> :
   */
  private void setRequestFields(DetailItemsInterface dii) {
    for (String it : _jim) {
      dii.setRequestItem(_jim.getDtoNo(it));
    }
  }

  /**
   * Describe <code>callControl</code> method : Rg[NXĂяo.
   * <br>Rg[NXĂяoA߂lDetaObject߂B
   * <ol>
   *   <li> _Process_Control xcntl = new _Process_Control();
   *   <li> return xcntl.getDetail(dii);
   * </ol>
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>DetailItemsInterface</code> :
   * @exception Exception if an error occurs
   */
  protected abstract DetailItemsInterface callControl(DetailItemsInterface dii)
     throws Exception;

  /**
   * Describe <code>setDisplayItems</code> method : ꗗ\ڗpMap𐶐.
   * <br>
   * @param dii a <code>DetailItemsInterface</code>
   * @return a <code>Map</code> : \ڐݒpMap
   */
  private Map<String, String> setDisplayItems(DetailItemsInterface dii) {
    Map<String, String> ret = new HashMap<String, String>();
    ret.put(POSNM, Integer.toString(_keyPos));
    String[] chkDl = checkDelete(dii);
    for (String kv : _jim) {
      if (chkDl != null && kv.equals(chkDl[0])) {
        ret.put(kv, chkDl[1]);
      }
      else {
        ret.put(kv, dii.getItemValue(_jim.getDtoNo(kv)));
      }
    }
    return ret;
  }

  /**
   * Describe <code>checkDelete</code> method : 폜f[^̃`FbN.
   * <br>DataObejctɃf[^݂A폜FLG<b>OFF</b>`FbNB
   * <br>폜f[^̏ꍇ́A폜̎|\鍀ږƕ\e<b>String[2]</b>߂܂B
   * <br>ex.
   * <pre>
   *    if (dii.isNotFound() || dii.getCommFld(COMMFLD.DEL).equals("1")) {
   *      String[] ret = {"jspږ", super.resource.getString("DelLine")};
   *      return ret;
   *    }
   *    return null;
   * </pre>
   * @param dii a <code>DetailItemsInterface</code>
   * @return a <code>String</code> : bZ[W\鍀ڂ̖
   */
  protected abstract String[] checkDelete(DetailItemsInterface dii);

  /**
   * Describe <code>delCheck</code> method : .
   * <br>폜ꂽf[^`FbNB@폜f[^̏ꍇAtrue ߂
   *
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>boolean</code> : 폜f[^̏ꍇ true
   */
  protected final boolean delCheck(DetailItemsInterface dii) {
    if (dii.isNotFound()) return true;
    String del = dii.getCommFld(COMMFLD.DEL);
    return del.equals(USE_FLG.DEL.getVal());
  }

  /**
   * Describe <code>editItems</code> method : ڕҏW.
   * <br>ҏWĕ\鍀ڂMapɐݒ肷ꍇA<b>override</b>B
   * <br>ҏWڂJSPږKeyɂ<b>mp</b>ɓo^B
   * @param dii a <code>DetailItemsInterface</code> :
   * @param mp a <code>Map</code> : ҏWڂݒ肷Map
   * @return a <code>Map</code> : ҏWMap
   * @exception Exception if an error occurs
   */
  protected Map<String, String> editItems(DetailItemsInterface dii, Map<String, String> mp)
    throws Exception {
    return mp;
  }

}
