package com.hamaf.hikyaku.util;


import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <p>^CgF֌W̃[eBeBNX.</p>
 * <p>Fȉ̋@\<code>static</code>ƂėLB</p>
 * <ol>
 *   <li>getDate  : VXet̎擾
 *   <li>getYearMonth : VXet̔N擾
 *   <li>getYear  : VXet̔N擾
 *   <li>getMonth : VXeť擾
 *   <li>getNendo : VXet̔Nx擾
 *   <li>getTime  : VXeԂ̎擾
 *   <li>convertDate : YY/MM/DD ̓tw̃tH[}bgɕϊ
 *   <li>change6to8  : YY/MM/DD(6) ̓t YYYY/MM/DD(8) `ɕϊ
 *   <li>change8to6  : YYYY/MM/DD(8) ̓t YY/MM/DD(6) `ɕϊ
 *   <li>getCalendar : YYYY/MM/DD`̃f[^<code>Calendar Object</code>ɕϊ
 *   <li>addDateTime : Ŏw肵NEԂɑ΂āẢZsȂ
 *   <li>getYoubi : w肳ꂽt('YYYY/MM/DD'`)̗j('',''EEE)߂
 *   <li>convWeek : YYYY/MM/DD`̃f[^YYYY/MM-Week`ɕϊ
 *   <li>getNextWeek : YYYY/MM-Week`̎̏T̒l߂
 *   <li>getLastWeek : YYYY/MM-Week`̑ȌT̒l߂
 *   <li>getRange : YYYY/MM/DDYYYY/MM/DD`Ŏw肳ꂽԂ̃f[^
 *       <br>TƂ̃f[^(YYYY/MM-Week`)ɕϊ<code>List</code>𐶐
 * </ol>
 * <p>쌠: Copyright (c) 2004</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class DateUtil {

  private static final String[] wval = {"","","","","","","","y"};
  private final static int[] WEEK_DAY = {8, 16, 24, 32};
  private final static String DATE_TYPE =
   "20[0-9]{2}/(01|02|03|04|05|06|07|08|09|10|11|12)/(01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)";
  private final static String WEEK_TYPE =
   "20[0-9]{2}/(01|02|03|04|05|06|07|08|09|10|11|12)-[1-6]";
  private final static Pattern DATE_PTN = Pattern.compile(DATE_TYPE);
  private final static Pattern WEEK_PTN = Pattern.compile(WEEK_TYPE);

  /**
   * Describe <code>getDate</code> method : convert System-Date to String.
   * <br>VXet"YYYY/MM/DD"()ɕϊĖ߂B
   * <br>
   * @return a <code>String</code> : VXet
   */
  public final static String getDate() {
    Date curdt = new Date();
    DateFormat dfd = DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN);
    return  dfd.format(curdt);
  }

  /**
   * VXet̔NuYYYY/MMv`ŕԂ
   * @return a <code>String</code> VXet̔NiYYYY/MMj
   */
  public final static String getYearMonth() {
    String ym = getDate();
    if (ym.length() < 7) {
      return "";
    }
    return ym.substring(0,7);
  }

  /**
   * VXetuYYYYv`ŕԂ.
   * @return a <code>String</code> VXetiYYYYj
   */
  public final static String getYear() {
    String ym = getDate();
    if (ym.length() < 4) {
      return "";
    }
    return ym.substring(0,4);
  }

  /**
   * VXetuMMv`ŕԂ
   * @return a <code>String</code> VXetiMMj
   */
  private final static String getMonth(){
    String ym = getDate();
    if (ym.length() < 7) {
      return "";
    }
    return ym.substring(5,7);
  }

  /**
   * VXetNx擾AŕԂ.
   * @return a <code>String</code> VXeNxiYYYYj
   */
  public final static String getNendo(){
    int nowYear  = Integer.parseInt(getYear());
    int nowMonth = Integer.parseInt(getMonth());
    if(nowMonth < 4){
      nowYear --;
    }
    return Integer.toString(nowYear);
  }

  /**
   * VXetw̃tH[}bgŕԂ.
   * @param format a <code>String</code> F tH[}bgw肷
   * @return a <code>String</code> tH[}bgꂽVXet
   */
  public final static String getFormatDate(String format) {
    Date dt = new Date();
    return getFormatDate(dt, format);
  }

  /**
   * <code>Date</code>w̃tH[}bgŕԂ.
   * @param dt a <code>Date</code>FtH[}bgst
   * @param format a <code>String</code>FtH[}bgw肷
   * @return <code>String</code> tH[}bgꂽt
   */
  public final static String getFormatDate(Date dt, String format) {
    SimpleDateFormat df = (SimpleDateFormat) DateFormat.getDateInstance();
    df.applyPattern(format);
    return df.format(dt);
  }

  /**
   * VXeԂuHH:MM:SSv`ŕԂ.
   * @return a <code>String</code> VXeԁiHH:MM:SSj
   */
  public final static String getTime() {
    Date dt = new Date();
    DateFormat df = DateFormat.getTimeInstance(DateFormat.MEDIUM, Locale.JAPAN);
    return df.format(dt);
  }

  /**
   * VXeԂw̃tH[}bgŕԂ.
   * @return a <code>String</code> VXe
   */
  public final static String getTime(String format) {
    Date dt = new Date();
    SimpleDateFormat df = (SimpleDateFormat) DateFormat.getDateInstance();
    df.applyPattern(format);
    return df.format(dt);
  }

  /**
   * w̓t(<code>date</code>)w̃tH[}bg(<code>format</code>)ɕϊĕԂ.
   * @param date a <code>String</code>F ϊ̓t (YY/MM/DD `)
   * @param format a <code>String</code>Fϊ`
   * @return a <code>String</code> : ϊ̓t
   */
  public final static String convertDate(String date, String format) {
    String[] item = date.split("/");
    if (item.length != 3) {
      return "";
    } // end of if (format check)

    if(item[0].length() == 2){
      if(Integer.parseInt(item[0]) < 80){
        item[0] = "20" + item[0];
      }else{
        item[0] = "19" + item[0];
      }
    }

    Calendar cal = Calendar.getInstance();
    cal.set(Integer.parseInt(item[0]),
      Integer.parseInt(item[1]) - 1,
      Integer.parseInt(item[2]));
    return getFormatDate(cal.getTime(), format);
  }

  /**
   * w̓t(<code>YY/MM/DD</code>)<code>yyyy/MM/dd</code>ɕϊĕԂ.
   * @param date a <code>String</code> : ϊ̓t (YY/MM/DD `)
   * @return a <code>String</code> : ϊ̓t
   */
  public final static String convertDate(String date) {
    return convertDate(date, "yyyy/MM/dd");
  }

  /**
   * Describe <code>change6to8</code> method : Convert AD6 to AD8.
   * <br>̂U(yy/mm/dd)W(yyyy/mm/dd)ɕϊB
   * <br>N80NȏȂ1900NAȂ2000NƂĂ܂B
   * @param ad6 a <code>String</code> : U
   * @return a <code>String</code> : W
   */
  public final static String change6to8(String ad6) {
    if (ad6.length() == 0) {
      return "";
    }
    StringBuffer sb = new StringBuffer();
    int year = 0;
    try {
      int p = ad6.indexOf("/");
      year = Integer.parseInt(ad6.substring(0, p));
    }
    catch (Exception e) {
    }
    if (year > 79) {
      sb.append("19");
    }
    else {
      sb.append("20");
    }
    sb.append(ad6);
    return sb.toString();
  }

  /**
   * Describe <code>change8to6</code> method :  Convert AD8 to AD6.
   * <br>̂W(yyyy/mm/dd)U(yy/mm/dd)ɕϊB
   * <br>N̏Q̂ԂB
   * @param ad8 a <code>String</code> : W
   * @return a <code>String</code> : U
   */
  public final static String change8to6(String ad8) {
    if (ad8 == null || ad8.length() < 5) {
      return ad8;
    }
    int p = ad8.indexOf("/");
    if (p < 4) {
      return ad8;
    }
    return ad8.substring(2);
  }

  /**
   * uYYYY/MM/DDv,uYYYY/MM/DD hh:mm:ssv`̓t<code>Calendar</code>ŕԂ.
   *  t`Ȃꍇ́Anull߂܂B
   * @param date a <code>String</code>FuYYYY/MM/DDv`̕
   * @return a <code>Calendar</code>FVXet
   */
  public final static Calendar getCalendar(String date){
    Calendar cld = Calendar.getInstance();
    DateFormat dfdf = null;
    if (date.length() < 11) {
      dfdf = DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN);
    }
    else {
      dfdf = DateFormat.getDateTimeInstance(DateFormat.LONG,DateFormat.MEDIUM, Locale.JAPAN);
    }

    try {
      cld.setTime(dfdf.parse(date));
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } // end of try-catch
    return cld;
  }

  /**
   * ̉ZiZjsȂ.
   *
   * @param dttm a <code>String</code> : ɂȂB"YYYY/MM/DD" or "YYYY/MM/DD hh:mm:ss"`
   * @param fld an <code>int</code> : Z(Z)tB[h̒liCalendarNX̒lj
   * @param amt an <code>int</code> : ZlBZꍇ̓}CiXlw肷
   * @return a <code>String</code> : vZʂ̓̕\
   */
  public final static String addDateTime(String dttm, int fld, int amt) {
    Calendar cld = getCalendar(dttm);
    if (cld == null) {
      return "";
    }
    cld.add(fld, amt);
    DateFormat dfdf = null;
    if (dttm.length() < 11) {
      dfdf = DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN);
    }
    else {
      SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
      sdf.applyPattern("yyyy/MM/dd HH:mm:ss");
      dfdf = sdf;
    }
    return dfdf.format(cld.getTime());
  }

  /**
   * ̐ݒsȂ.
   *
   * @param dttm a <code>String</code> : ɂȂB"YYYY/MM/DD" or "YYYY/MM/DD hh:mm:ss"`
   * @param fld an <code>int</code> : ݒ肷tB[h̒liCalendarNX̒lj
   * @param amt an <code>int</code> : ݒ肷lB
   * @return a <code>String</code> : ݒ茋ʂ̓̕\
   */
  public final static String setDateTime(String dttm, int fld, int amt) {
    Calendar cld = getCalendar(dttm);
    if (cld == null) {
      return "";
    }
    cld.set(fld, amt);
    DateFormat dfdf = null;
    if (dttm.length() < 11) {
      dfdf = DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN);
    }
    else {
      SimpleDateFormat sdf = (SimpleDateFormat)DateFormat.getDateTimeInstance();
      sdf.applyPattern("yyyy/MM/dd HH:mm:ss");
      dfdf = sdf;
    }
    return dfdf.format(cld.getTime());
  }

  /**
   * uYYYY/MM/DDv`̓t̗j̓{ꖼԂ.
   * @param dtstr a <code>String</code> : uYYYY/MM/DDv`̕
   * @return a <code>String</code> : j (AA΁AEEE)
   */
  public final static String getYoubi(String dtstr) {
    Calendar cld = getCalendar(dtstr);
    int wi = 0;
    if (cld != null) {
      wi = cld.get(Calendar.DAY_OF_WEEK);
    }
    return wval[wi];
  }

  /**
   * Describe <code>convWeek</code> method : convert day to week.
   * <br>YYYY/MM/DD`̓tf[^YYYY/MM-Week`ɕϊB
   * <br>
   * @param date a <code>String</code> : ϊt
   * @return a <code>String</code> : ϊ̒l
   * @throws IllegalArgumentException
   */
  public final static String convWeek(String date) throws IllegalArgumentException {
    if (checkDate(date)) {
      throw new IllegalArgumentException("w肳ꂽť`ԈĂ܂B t:" + date);
    }
    int dd = Integer.parseInt(date.substring(8));
    int week = 0;
    while (week < WEEK_DAY.length && dd > WEEK_DAY[week]) {
      week++;
    }
    week++;
    StringBuffer sb = new StringBuffer();
    sb.append(date.substring(0,7));
    sb.append("-");
    sb.append(week);
    return sb.toString();
  }

  /**
   * Describe <code>getNextWeek</code> method : get Next Week.
   * <br>YYYY/MM-Week`Ŏw肳ꂽt̗T̒l擾B
   * <br>
   * @param wdate a <code>String</code> : ƂȂT
   * @return a <code>String</code> : T̒l
   * @throws IllegalArgumentException
   * @throws ParseException
   */
  public final static String getNextWeek(String wdate)
   throws IllegalArgumentException, ParseException {

    Calendar cln = createCalender(wdate);

    int week = Integer.parseInt(wdate.substring(8));
    week++;
    if (week > 4) {
      week = 1;
      cln.add(Calendar.MONTH, 1);
    }

    return formatWdate(cln, week);
  }

  /**
   * Describe <code>getLastWeek</code> method : get get Last Week.
   * <br>YYYY/MM-Week`Ŏw肳ꂽt̑OT̒l擾B
   * <br>
   * @param wdate a <code>String</code> : ƂȂT
   * @return a <code>String</code> : OT̒l
   * @throws IllegalArgumentException
   * @throws ParseException
   */
  public final static String getLastWeek(String wdate)
   throws IllegalArgumentException, ParseException {

    Calendar cln = createCalender(wdate);

    int week = Integer.parseInt(wdate.substring(8));
    week--;
    if (week < 1) {
      week = 4;
      cln.add(Calendar.MONTH, -1);
    }

    return formatWdate(cln, week);
  }

  /**
   * Describe <code>getRange</code> method : get range week.
   * <br>YYYY/MM/DDYYYY/MM/DD`Ŏw肳ꂽԂ̃f[^A
   * <br>TƂ̃f[^(YYYY/MM-Week`)ɕϊ<code>List</code>𐶐
   * @param rdate a <code>String</code> : 
   * @return a <code>List&lt;String&gt;</code> : ͈͓̏TList
   * @throws IllegalArgumentException
   * @throws ParseException
   */
  public final static List<String> getRange(String rdate) throws IllegalArgumentException, ParseException {
    String rfr = rdate.substring(0, 10);
    String rto = rdate.substring(10);
    if (checkDate(rfr)) {
      throw new IllegalArgumentException("w肳ꂽFrom̓t`ԈĂ܂B t:" + rfr);
    }
    if (checkDate(rto)) {
      throw new IllegalArgumentException("w肳ꂽTo̓t`ԈĂ܂B t:" + rto);
    }

    List<String> rval = new ArrayList<String>();
    String stdt = convWeek(rfr);
    String eddt = convWeek(rto);
    while (eddt.compareTo(stdt) >= 0) {
      rval.add(stdt);
      stdt = getNextWeek(stdt);
    }

    return rval;
  }

  // ---------- private \bh̒`

  private static Calendar createCalender(String wdate)
  throws IllegalArgumentException, ParseException {
    if (checkWeek(wdate)) {
      throw new IllegalArgumentException("w肳ꂽť`ԈĂ܂B t:" + wdate);
    }
    StringBuffer sb = new StringBuffer();
    sb.append(wdate.substring(0,7));
    sb.append("/01");
    Calendar cln = Calendar.getInstance();
    cln.setTime(DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN).parse(sb.toString()));
    return cln;
  }

  private static String formatWdate(Calendar cln, int week) {
    StringBuffer val = new StringBuffer();
    val.append(DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN).format(cln.getTime()));
    val.setLength(7);
    val.append("-");
    val.append(week);
    return val.toString();
  }

  private static boolean checkDate(String dt) {
    Matcher mc = DATE_PTN.matcher(dt);
    return !mc.matches();
  }
  private static boolean checkWeek(String dt) {
    Matcher mc = WEEK_PTN.matcher(dt);
    return !mc.matches();
  }

  public static void main (String[] args) {
    System.out.println("-------- DateUtil Exec Sample -----------------------");
    System.out.println(" getDate() is " + getDate());
    System.out.println(" getYearMonth() is " + getYearMonth());
    System.out.println(" getYear() is " + getYear());
    System.out.println(" getMonth() is " + getMonth());
    System.out.println(" getNendo() is " + getNendo());
    System.out.println(" getTime() is " + getTime());
    System.out.println(" convertDate(\"04/12/03\") is " + convertDate("04/12/03"));
    System.out.println(" change6to8(\"04/11/30\") is " + change6to8("04/11/30"));
    System.out.println(" change8to6(\"2004/12/14\") is " + change8to6("2004/12/14"));
    System.out.println(" getCalendar(\"2004/12/24\") is " + getCalendar("2004/12/24"));
    System.out.println(" getCalendar(\"2005/02/20 14:01:06\") is "
                       + getCalendar("2005/02/20 14:01:06"));
    System.out.println(" getYoubi(\"2004/12/24\") is " + getYoubi("2004/12/24"));
    System.out.println(" addDateTime(\"2005/12/24,Calendar.DATE,2) is " + addDateTime("2005/12/24",Calendar.DATE,2));
    System.out.println(" addDateTime(\"2005/12/24 04:01:06\",Calendar.MINUTE,13) is " + addDateTime("2005/12/24 04:01:06",Calendar.MINUTE,13));
    System.out.println("-------- DateUtil Sample End  -----------------------");
    try {
      System.out.println(" convWeek(\"2004/12/04\") is " + convWeek("2004/12/04"));
      System.out.println(" getNextWeek(\"2004/12-4\") is " + getNextWeek("2004/12-4"));
      System.out.println(" getLastWeek(\"2005/01-1\") is " + getLastWeek("2005/01-1"));
      System.out.println(" getRange(\"2004/11/202005/01/31\") is " + getRange("2004/11/202005/01/31"));
    } catch (Exception xe) {
      xe.printStackTrace();
    } // end of try-catch
  } // end of main ()

}
