package com.hamaf.hikyaku.util;

import java.util.StringTokenizer;

/**
 * <p>^CgFJspUtils is ̕ϊȂǂs[eBeB.</p>
 * <p>FJSPł̗p𒆐SƂϊȂǂ̃c[W</p>
 * <ol>
 *   <li>changeNL2BR : s&lt;br&gt;ɕϊ
 *   <li>changeTab2BR : Tab&lt;br&gt;ɕϊ
 *   <li>cutString : 󔒁A^uAsŕ
 * </ol>
 *
 * <p>쌠: Copyright (c) 2004/03/04</p>
 * @author Hamanaka
 * @version 1.0
 */
public class JspUtils {

  /**
   * Describe <code>changeNL2BR</code> method : convert newLine to &lt;br&gt;.
   * <br>s<code>(\n)</code>Html̉s<code> &lt;br&gt; </code>
   * ϊĖ߂܂B
   * @param org a <code>String</code> : ϊ镶
   * @return a <code>String</code> : ϊ̕
   */
  public final static String changeNL2BR(String org) {
        return replaceBR(org, '\n');
  }
  /**
   * Describe <code>changeNL2BR</code> method : convert tab to &lt;br&gt;.
   * <br>^u<code>(\t)</code>Html̉s<code> &lt;br&gt; </code>
   * ϊĖ߂܂B
   * @param org a <code>String</code> : ϊ镶
   * @return a <code>String</code> : ϊ̕
   */
  public final static String changeTab2BR(String org) {
    return replaceBR(org, '\t');
  }

  private final static String replaceBR(String org, char chk) {
    if (org == null || org.length() == 0) {
      return "";
    }
    StringBuffer sb = new StringBuffer();
    for (int i = 0; i < org.length(); i++) {
      if (org.charAt(i) == chk) {
        sb.append("<br>");
      }
      else {
        sb.append(org.charAt(i));
      }
    }
    return sb.toString();
  }

  /**
   * Describe <code>cutString</code> method : String Split by control code.
   * <br>󔒕A^uAsAAsAїp蕶
   * <code>(\t\n\r\f)</code>ŕĖ߂B
   * @param org a <code>String</code> : 镶
   * @return a <code>String[]</code> : ̕
   */
  public final static String[] cutString(String org) {
    StringTokenizer st = new StringTokenizer(org);
    if (st.countTokens() <1) {
      return new String[]{};
    }
    String[] rval = new String[st.countTokens()];
    int p = 0;
    while (st.hasMoreTokens()) {
      rval[p] = st.nextToken();
      p++;
    }
    return rval;
  }

}
