package com.hamaf.hikyaku.util;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

/**
 * <p>^CgFMailSendUtil is .</p>
 * <p>F[MpNX</p>
 * <br>eLXg[𑗐MꍇAȉ̍ڂݒ"sendTextMessage()"ĂяoB
 * <table>
 *  <tr>
 *  	<th>vpeB</th>
 *  	<th>K^C</th>
 *  	<th>e</th>
 *  </tr>
 *  <tr>
 *  	<td>smtpAddress</td>
 *  	<td>K{</td>
 *  	<td>SMTPT[o[̃AhX</td>
 *  </tr>
 *  <tr>
 *  	<td>smtpPort</td>
 *  	<td>C</td>
 *  	<td>̃|[gԍ(25)ȊȌꍇw肷</td>
 *  </tr>
 *  <tr>
 *  	<td>mailFrom</td>
 *  	<td>K{</td>
 *  	<td>M҂̃[AhX</td>
 *  </tr>
 *  <tr>
 *  	<td>smtpAuth</td>
 *  	<td>C</td>
 *  	<td>SMTPT[o[Ń[U[F؂Kvȏꍇtrueݒ肷</td>
 *  </tr>
 *  <tr>
 *  	<td>smtpUser</td>
 *  	<td>C</td>
 *  	<td>"smtpAuth"trueݒ肵ꍇAFؗp̃[U[IDw肷</td>
 *  </tr>
 *  <tr>
 *  	<td>smtpPassword</td>
 *  	<td>C</td>
 *  	<td>"smtpAuth"trueݒ肵ꍇAFؗp̃pX[hw肷</td>
 *  </tr>
 *  <tr>
 *  	<td>sendTo</td>
 *  	<td>K{</td>
 *  	<td>M̃[AhX</td>
 *  </tr>
 *  <tr>
 *  	<td>sendCC</td>
 *  	<td>C</td>
 *  	<td>CCɎw肷郁[AhX</td>
 *  </tr>
 *  <tr>
 *  	<td>sendBCC</td>
 *  	<td>C</td>
 *  	<td>BCCɎw肷郁[AhX</td>
 *  </tr>
 *  <tr>
 *  	<td>subject</td>
 *  	<td>C</td>
 *  	<td>[̃^Cg</td>
 *  </tr>
 *  <tr>
 *  	<td>text</td>
 *  	<td>C</td>
 *  	<td>[̖{</td>
 *  </tr>
 * </table>
 * <br>Ytt@Ct[𑗐MꍇAL̍ڂ"sendFile"ݒ"sendMimeMessage()"ĂяoB
 *
 * <p>쌠: Copyright (c) 2011/01/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class MailSendUtil {

	/**
	 * SMTPT[o[ڑpvpeB
	 */
	private String _smtpAddress = null;
	private int _smtpPort = -1;
	private String _mailFrom = null;
	private boolean _smtpAuth = false;
	private String _smtpUser = null;
	private String _smtpPassword = null;

	private List<String> _sendTo = new ArrayList<String>();
	private List<String> _sendCC = new ArrayList<String>();
	private List<String> _sendBCC = new ArrayList<String>();
	private String _subject = null;
	private String _text = null;

	private List<String> _sendFile = new ArrayList<String>();

	private final String CHAR_SET = "iso-2022-jp";

	/**
	 * Describe <code>sendTextMessage</code> method : .
	 * <br>eLXgbZ[W̑MB
	 *
	 * @throws IllegalArgumentException
	 * @throws MessagingException
	 * @throws AddressException
	 * @throws MessagingException
	 */
	public void sendTextMessage() throws IllegalArgumentException,
		MessagingException, AddressException, MessagingException {
		checkRequired();
		Session ss = getSession();
		MimeMessage mm = getMimeMessage(ss);
		mm.setText(_text, CHAR_SET);
		Transport.send(mm);
	}

	/**
	 * Describe <code>sendMimeMessage</code> method : .
	 * <br>Ytt@Ct[̑MB
	 *
	 * @throws IllegalArgumentException
	 * @throws MessagingException
	 * @throws AddressException
	 * @throws MessagingException
	 * @throws UnsupportedEncodingException
	 */
	public void sendMimeMessage() throws IllegalArgumentException,
		MessagingException, AddressException, MessagingException, UnsupportedEncodingException {
		checkRequired();
		Session ss = getSession();
		MimeMessage mm = getMimeMessage(ss);
		mm = setMultipart(mm);
		Transport.send(mm);
	}

	private void checkRequired() throws IllegalArgumentException {
		if (_smtpAddress == null)
			throw new IllegalArgumentException("SMTP Address is null.");
		if (_mailFrom == null)
			throw new IllegalArgumentException("Mail From is null.");
		if (_sendTo == null || _sendTo.size() == 0)
			throw new IllegalArgumentException("Mail To is null.");
	}
	private Session getSession() {
		Properties p = new Properties();
		p.put("mail.smtp.host", _smtpAddress);
		p.put("mail.from", _mailFrom);
		if (_smtpPort > 0) p.put("mail.smtp.port", _smtpPort);
		if (!_smtpAuth) {
			return Session.getDefaultInstance(p);
		}

		SmtpAuth sa = new SmtpAuth(_smtpUser, _smtpPassword);
		p.put("mail.smtp.auth", "true");
		return Session.getInstance(p, sa);
	}
	private MimeMessage getMimeMessage(Session ss) throws AddressException, MessagingException {
		MimeMessage msg = new MimeMessage(ss);
		InternetAddress[] to = new InternetAddress[_sendTo.size()];
		for (int i = 0; i < to.length; i++) {
			to[i] = new InternetAddress(_sendTo.get(i));
		}
		msg.setRecipients(Message.RecipientType.TO, to);
		if (_sendCC != null && _sendCC.size() > 0) {
			InternetAddress[] cc = new InternetAddress[_sendCC.size()];
			for (int i = 0; i < cc.length; i++) {
				cc[i] = new InternetAddress(_sendCC.get(i));
			}
			msg.setRecipients(Message.RecipientType.CC, cc);
		}
		if (_sendBCC != null && _sendBCC.size() > 0) {
			InternetAddress[] cc = new InternetAddress[_sendBCC.size()];
			for (int i = 0; i < cc.length; i++) {
				cc[i] = new InternetAddress(_sendBCC.get(i));
			}
			msg.setRecipients(Message.RecipientType.BCC, cc);
		}
		msg.addFrom(InternetAddress.parse(_mailFrom));
		msg.setSubject(_subject, CHAR_SET);
		msg.setSentDate(new Date());
		return msg;
	}
	private MimeMessage setMultipart(MimeMessage msg) throws MessagingException, UnsupportedEncodingException {
		Multipart mp = new MimeMultipart();
		MimeBodyPart mbpt = new MimeBodyPart();
		mbpt.setText(_text, CHAR_SET);
		mp.addBodyPart(mbpt);
		for (String flnm : _sendFile) {
			MimeBodyPart mbp = new MimeBodyPart();
			FileDataSource fds = new FileDataSource(flnm);
			mbp.setDataHandler(new DataHandler(fds));
			mbp.setFileName(MimeUtility.encodeWord(fds.getName()));
			mp.addBodyPart(mbp);
		}
		msg.setContent(mp);
		return msg;
	}

	/**
	 * @param smtpAddress Zbg smtpAddress
	 */
	public void setSmtpAddress(String smtpAddress) {
		_smtpAddress = smtpAddress;
	}
	/**
	 * @param smtpPort Zbg smtpPort
	 */
	public void setSmtpPort(int smtpPort) {
		_smtpPort = smtpPort;
	}
	/**
	 * @param mailFrom Zbg mailFrom
	 */
	public void setMailFrom(String mailFrom) {
		_mailFrom = mailFrom;
	}
	/**
	 * @param sendTo Zbg sendTo
	 */
	public void setSendTo(List<String> sendTo) {
		if (sendTo == null) sendTo = new ArrayList<String>();
		_sendTo = sendTo;
	}
	public void addSendTo(String sendTo) {
		if (sendTo == null) return;
		_sendTo.add(sendTo);
	}
	/**
	 * @param sendCC Zbg sendCC
	 */
	public void setSendCC(List<String> sendCC) {
		if (sendCC == null) sendCC = new ArrayList<String>();
		_sendCC = sendCC;
	}
	public void addSendCC(String sendCC) {
		if (sendCC == null) return;
		_sendCC.add(sendCC);
	}
	/**
	 * @param sendBCC Zbg sendBCC
	 */
	public void setSendBCC(List<String> sendBCC) {
		if (sendBCC == null) sendBCC = new ArrayList<String>();
		_sendBCC = sendBCC;
	}
	public void addSendBCC(String sendBCC) {
		if (sendBCC == null) return;
		_sendBCC.add(sendBCC);
	}
	/**
	 * @param subject Zbg subject
	 */
	public void setSubject(String subject) {
		_subject = subject;
	}
	/**
	 * @param text Zbg text
	 */
	public void setText(String text) {
		_text = text;
	}

	/**
	 * @param smtpAuth Zbg smtpAuth
	 */
	public void setSmtpAuth(boolean smtpAuth) {
		_smtpAuth = smtpAuth;
	}

	/**
	 * @param smtpUser Zbg smtpUser
	 */
	public void setSmtpUser(String smtpUser) {
		_smtpUser = smtpUser;
	}

	/**
	 * @param smtpPassword Zbg smtpPassword
	 */
	public void setSmtpPassword(String smtpPassword) {
		_smtpPassword = smtpPassword;
	}

	/**
	 * @param sendFile Zbg sendFile
	 */
	public void setSendFile(List<String> sendFile) {
		if (sendFile == null) sendFile = new ArrayList<String>();
		_sendFile = sendFile;
	}
	public void addSendFile(String sendFile) {
		if (sendFile == null) return;
		_sendFile.add(sendFile);
	}

	/**
	 * Describe <code>setProperties</code> method : .
	 * <br>\[XvpeBݒ肷B
	 *
	 * @param name a <code>String</code> : \[X
	 */
	public void setProperties(String name) {
		ResourceBundle rb = ResourceBundle.getBundle(name);
		setSmtpAddress(getResourceValue(rb, "smtpAddress"));
		String prt = getResourceValue(rb, "smtpPort");
		if (prt != null && prt.length() > 0) setSmtpPort(Integer.parseInt(prt));
		setMailFrom(getResourceValue(rb, "mailFrom"));
		String auth = getResourceValue(rb, "smtpAuth");
		if (auth != null && auth.length() > 0) setSmtpAuth(Boolean.parseBoolean(auth));
		setSmtpUser(getResourceValue(rb, "smtpUser"));
		setSmtpPassword(getResourceValue(rb, "smtpPassword"));
		addSendTo(getResourceValue(rb, "sendTo"));
		addSendCC(getResourceValue(rb, "sendCC"));
		addSendBCC(getResourceValue(rb, "sendBCC"));
		setSubject(getResourceValue(rb, "subject"));
		setText(getResourceValue(rb, "text"));
	}
	private String getResourceValue(ResourceBundle rb, String key) {
		try {
			return rb.getString(key);
		}
		catch (Exception ex) { }
		return null;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("smtpAddress : ");
		sb.append(_smtpAddress.toString());
		sb.append("\nsmtpPort : ");
		sb.append(_smtpPort);
		sb.append("\nmailFrom : ");
		sb.append(_mailFrom.toString());
		sb.append("\nsmtpAuth : ");
		sb.append(_smtpAuth);
		sb.append("\nsmtpUser : ");
		sb.append(_smtpUser.toString());
		sb.append("\nsmtpPassword : ");
		sb.append(_smtpPassword.toString());
		sb.append("\nsendTo : ");
		sb.append(_sendTo.toString());
		sb.append("\nsendCC : ");
		sb.append(_sendCC.toString());
		sb.append("\nsendBCC : ");
		sb.append(_sendBCC.toString());
		sb.append("\nsubject : ");
		sb.append(_subject.toString());
		sb.append("\ntext : ");
		sb.append(_text.toString());
		return sb.toString();
	}
}
