package com.hamaf.hikyaku.util;

import java.text.MessageFormat;
import java.util.List;
import java.util.Map;
import java.util.ResourceBundle;

import javax.servlet.ServletRequest;
import javax.servlet.http.HttpSession;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgF MessageUtil is CommonMessage, KeyList access class.</p>
 * <p>F<b>CommonMessage, KeyList</b>𑀍삷郆[eBeBWB</p>
 * <br>ȉ̋@\<b>static</b>ŗpӂĂ܂B
 * <ol>
 *   <li>getMessage : }X^XML&lt;messageData&gt;^OɎw肳Ă郁bZ[W擾
 *   <li>getRsrcMsg : Resource File烁bZ[W擾
 *   <li>getItem : CommonMessagew肵ڒl擾
 *   <li>getKeyItem : KeyListw肵ڒl擾
 * </ol>
 *
 * <p>쌠: Copyright (c) 2007/05/02</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class MessageUtil {

  private final static String MSG = "messageData";
  private final static String MSGDT = "messageDataName";

  /**
   * Describe <code>getMessage</code> method : change code to message from MasterXml.
   * <br>w肳ꂽR[hŃ}X^Xml烁bZ[W擾B
   *
   * @param cd a <code>String</code> : R[h
   * @param sysid a <code>String</code> : VXeID
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getMessage(String cd, String sysid) {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysid);
    Map<String, String> dtmp = mxc.getItemValue(MSG, cd);
    return dtmp.get(MSGDT);
  }
  /**
   * Describe <code>getMessage</code> method : change code to message with convert from MasterXml.
   * <br>w肳ꂽR[hƕϊz胁bZ[W擾B
   *
   * @param cd a <code>String</code> : R[h
   * @param sysid a <code>String</code> : VXeID
   * @param parm <code>Object[]</code> : ϊz
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getMessage(String cd, String sysid, Object[] parm) {
    return MessageFormat.format(getMessage(cd, sysid), parm);
  }
  /**
   * Describe <code>getMessage</code> method : change code to message with convert from MasterXml.
   * <br>w肳ꂽR[hƕϊ񃊃Xg胁bZ[W擾B
   *
   * @param cd a <code>String</code> : R[h
   * @param sysid a <code>String</code> : VXeID
   * @param parm a <code>List</code> : ϊ񃊃Xg
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getMessage(String cd, String sysid, List<String> parm) {
    return getMessage(cd, sysid, parm.toArray());
  }
  /**
   * Describe <code>getMessage</code> method : change code to message with convert from MasterXml.
   * <br>w肳ꂽR[hƕϊ胁bZ[W擾B
   * <br>ϊ镶񂪂P̏ꍇ̊ȈՔłłB
   *
   * @param cd a <code>String</code> : R[h
   * @param sysid a <code>String</code> : VXeID
   * @param parm a <code>String</code> : ϊ
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getMessage(String cd, String sysid, String... parm) {
    return getMessage(cd, sysid, parm);
  }

  /**
   * Describe <code>getRsrcMsg</code> method : change code to message with convert from Resource file.
   * <br>w肳ꂽR[hŃ\[Xt@C烁bZ[W擾B
   *
   * @param rfl a <code>String</code> : Resource File 
   * @param cd a <code>String</code> : R[h
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getRsrcMsg(String rfl, String cd) {
    ResourceBundle rb = ResourceBundle.getBundle(rfl);
    return rb.getString(cd);
  }
  /**
   * Describe <code>getRsrcMsg</code> method : change code to message with convert from Resource file.
   * <br>w肳ꂽR[hƕϊz胁bZ[W擾B
   *
   * @param rfl a <code>String</code> : Resource File 
   * @param cd a <code>String</code> : R[h
   * @param parm a <code>Object[]</code> : ϊz
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getRsrcMsg(String rfl, String cd, Object[] parm) {
    return MessageFormat.format(getRsrcMsg(rfl, cd), parm);
  }
  /**
   * Describe <code>getRsrcMsg</code> method : change code to message with convert from Resource file.
   * <br>w肳ꂽR[hƕϊ񃊃Xg胁bZ[W擾B
   *
   * @param rfl a <code>String</code> : Resource File 
   * @param cd a <code>String</code> : R[h
   * @param parm a <code>List</code> : ϊ񃊃Xg
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getRsrcMsg(String rfl, String cd, List<String> parm) {
    return getRsrcMsg(rfl, cd, parm.toArray());
  }
  /**
   * Describe <code>getRsrcMsg</code> method : change code to message with convert from Resource file.
   * <br>w肳ꂽR[hƕϊ胁bZ[W擾B
   * <br>ϊ镶񂪂P̏ꍇ̊ȈՔłłB
   *
   * @param rfl a <code>String</code> : Resource File 
   * @param cd a <code>String</code> : R[h
   * @param parm a <code>String</code> : ϊ
   * @return a <code>String</code> : 擾bZ[W
   */
  public final static String getRsrcMsg(String rfl, String cd, String... parm) {
    return getRsrcMsg(rfl, cd, parm);
  }

  /**
   * Describe <code>getItem</code> method : get item value from CommonMessage.
   *@<br><b>CommonMessage</b>獀ڂ̒lo
   * @param msg a <code>CommonMessage</code> :
   * @param item a <code>String</code> : ږ
   * @param nocnv a <code>boolean</code> : ^O̕ϊȂꍇAtrue
   * @return a <code>String</code> : 擾l
   */
  public final static String getItem(CommonMessage msg, String item, boolean nocnv) {
    if (msg == null) {
      return "";
    }

    String val = null;
    if (msg.getErrorStatus() == STATUS.NORMAL) {
    	if (nocnv) {
    		val = msg.getResMsg(item);
    	} else {
    		val = msg.getResMsg4JSP(item);
    	}
    }
    if (val == null || val.equals("")) {
    	if (nocnv) {
    		val = msg.getReqStr(item);
    	} else {
    		val = msg.getReq4JSP(item);
    	}
    }
    return val;
  }

  /**
   * Describe <code>getItem</code> method : get item value from CommonMessage.
   * <br><b>CommonMessage</b>獀ڂ̒lo
   * @param req a <code>ServletRequest</code>
   * @param item a <code>String</code> : ږ
   * @param nocnv a <code>boolean</code> : ^O̕ϊȂꍇAtrue
   * @return a <code>String</code> : 擾l
   */
  public final static String getItem(ServletRequest req, String item, boolean nocnv) {
    CommonMessage msg = (CommonMessage)
      req.getAttribute(DistributeServlet.MAPPING_KEY);
    return getItem(msg, item, nocnv);
  }

  /**
   * Describe <code>getKeyItem</code> method : get item value from KeyList.
   * <br><b>KeyList</b>獀ڂ̒lo
   * @param kl a <code>KeyList</code> :
   * @param item a <code>String</code> : ږ
   * @return a <code>String</code> : 擾l
   */
  public final static String getKeyItem(KeyList kl, String item) {
    if (kl == null) {
      return "";
    }
    return kl.getRetrieve4Jsp(item);
  }

  /**
   * Describe <code>getKeyItem</code> method : get item value from KeyList..
   * <br><b>KeyList</b>獀ڂ̒lo
   * @param session a <code>HttpSession</code>
   * @param item a <code>String</code> : ږ
   * @return a <code>String</code> : 擾l
   */
  public final static String getKeyItem(HttpSession session, String item) {
    String proId = (String)session.getAttribute(DistributeServlet.KEY_SAVE_ID);
    KeyList kl = (KeyList)session.getAttribute(proId);
    if (kl == null) {
      return null;
    }
    return getKeyItem(kl, item);
  }

  /**
   * Describe <code>getSpare2Str</code> method : get spare area date.
   * <br><b>KeyList</b>̕⏕GA̒l𕶎ɂĖ߂B
   *
   * @param session a <code>HttpSession</code>
   * @param pos a <code>String</code> : ڂ̈ʒu
   * @return a <code>String</code> : 擾l
   */
  public final static String getSpare(HttpSession session, String pos) {
    return getSpare(session, Integer.parseInt(pos));
  }
  public final static String getSpare(HttpSession session, int ipos) {
    String proId = (String)session.getAttribute(DistributeServlet.KEY_SAVE_ID);
    KeyList kl = (KeyList)session.getAttribute(proId);
    if (kl == null) {
      return null;
    }
    Object val = kl.getSpare(ipos);
    if (val == null) {
      return "";
    }
    return TextUtil.cnvJsp(val, kl.getCharCD());
  }

  private static final String IPTAG = "<input type=\"text\"";
  private static final String[] TGNMS = {" name=\"", " class=\"", " size=\""," maxlength=\""};
  /**
   * Describe <code>createTextTag</code> method : create &lt;input type=text &gt; tag.
   * <br>eLXgtB[hp̃^O𐶐B
   *
   * @param name a <code>String</code> : nameɐݒ肷镶Asvȏꍇnull
   * @param cls a <code>String</code> : classɐݒ肷镶Asvȏꍇnull
   * @param size a <code>String</code> : sizeɐݒ肷镶Asvȏꍇnull
   * @param maxlength a <code>String</code> : maxlengthɐݒ肷镶Asvȏꍇnull
   * @param attr a <code>String</code> : ̑̑ƂĐݒ肷镶Asvȏꍇnull
   * @return a <code>String</code> : eLXgtB[hp̃^O
   */
  public final static String createTextTag(String name, String cls, String size,
      String maxlength, String attr) {
    String[] dts = {name, cls, size, maxlength};
    StringBuffer sb = new StringBuffer();
    sb.append(IPTAG);
    for (int i = 0; i < TGNMS.length; i++) {
      if (dts[i] != null) {
        sb.append(TGNMS[i]);
        sb.append(dts[i]);
        sb.append("\"");
        if (i == 0) {
          sb.append(" id=\"");
          sb.append(dts[i]);
          sb.append("\"");
        }
      }
    }
    if (attr != null) {
      sb.append(" ");
      sb.append(attr);
    }
    sb.append(" ");
    return sb.toString();
  }

  private static String ERRFRMT = "<br><font color=\"red\">{0}</font>\n";
  /**
   * Describe <code>createErrorMsg</code> method : create Item Error Message.
   * <br>ڃG[p̃bZ[W𐶐B
   * <br>Statusm[}AyсAYڂ̃bZ[Wꍇ́A̕߂B
   *
   * @param req a <code>ServletRequest</code>
   * @param item a <code>String</code> : ΏۂƂȂ鍀
   * @return a <code>String</code> : bZ[W
   */
  public final static String createErrorMsg(ServletRequest req, String item) {
    if (item == null) {
      return "";
    }
    CommonMessage cmm = (CommonMessage)req.getAttribute(DistributeServlet.MAPPING_KEY);
    if (cmm == null || cmm.getErrorStatus() == STATUS.NORMAL) {
      return "";
    }
    String dt = cmm.getResMsg4JSP(item);
    if (dt == null || dt.length() == 0) {
      return "";
    }

    Object[] prm = {dt};
    return MessageFormat.format(ERRFRMT, prm);
  }

}
