package com.hamaf.hikyaku.util;

import java.util.logging.Level;
import java.util.logging.Logger;

/** <p>g[XȌo͂s.</p><br>
 * y\bhLoggerx̊֌Wz<br>
 *  <table border="1" cellspacing="0" cellpadding="1">
 *  <tr bgcolor="#CCCCFF">
 *    <th width="80px">\bh</th>
 *    <th width="100px">x</th>
 *    <th>Ăяo^C~O</th>
 *  </tr>
 *  <tr>
 *    <td>enter</td>
 *    <td>FINE</td>
 *    <td>\bh̊Jn</td>
 *  </tr>
 *  <tr>
 *    <td>exit</td>
 *    <td>FINE</td>
 *    <td>\bh̏I</td>
 *  </tr>
 *  <tr>
 *    <td>debug</td>
 *    <td>FINER</td>
 *    <td>fobOp̏o͂sꍇ</td>
 *  </tr>
 *  <tr>
 *    <td>exception</td>
 *    <td>WARNING</td>
 *    <td>\O̗O</td>
 *  </tr>
 *  <tr>
 *    <td>sql</td>
 *    <td>FINER</td>
 *    <td>SQLs</td>
 *  </tr>
 *  <tr>
 *    <td>info</td>
 *    <td>INFO</td>
 *    <td>̕\sꍇ</td>
 *  </tr>
 *  <tr>
 *    <td>config</td>
 *    <td>CONFIG</td>
 *    <td>RtBM[V̕\sꍇ</td>
 *  </tr>
 *  </table>
 * @author y-hamanaka
 * @version 1.0
 */
public class Trace {
  private static final int ALIGN_LEFT  = 0;
  private static final int ALIGN_RIGHT = 1;

  /**
   * e\bh̍ŏɕKĂяo܂.
   */
  public final static void enter(){
    putLog(Level.FINE, "Enter", "");
  }

  /**
   * e\bh̍ŌɕKĂяo܂.
   */
  public final static void exit(){
    putLog(Level.FINE,"Exit","");
  }

  /**
   * e\bhŔCӂ̉ӏŎs܂
   * @param debugText a <code>String</code> : g[XOɏo͂fobO𕶎Ŏw肷
  */
  public final static void debug(String debugText){
    putLog(Level.FINER,"Debug",debugText);
  }

  /**
   * ProcessBaseCatcheExceptionG[̓eo͂鎞Ɏs
   * @param description G[bZ[W𕶎Ŏw肷
  */
  public final static void exception(String description){
    putLog(Level.WARNING,"Exception",description);
  }

  /** 
   * ProcessBaseCatcheExceptionG[̓eo͂鎞Ɏs
   * @param e an <code>Exception</code> : ExceptioñCX^Xw肷
  */
  public final static void exception(Exception e){
    StackTraceElement elms[] = e.getStackTrace();
    StringBuffer logText = new StringBuffer();
    logText.append(e.toString());
    logText.append("\r\n");
    for(int i=0;i<elms.length;i++){
      logText.append("\t");
      logText.append(elms[i].toString());
      logText.append("\r\n");
    }
    putLog(Level.WARNING,"Exception",logText.toString());
  }

  /** 
   * SQLsOɎs.<br>
   * @@@ʏADao̊eX[p[NXŎIɏo͂邽߁A<br>
   * @@@vO}ӎĎs邱Ƃ͂܂
   * @param sql sΏۂSQL𕶎Ŏw肷
  */
  public final static void sql(String sql){
    putLog(Level.FINER,"Sql",sql);
  }

  /**
   * \ꍇ.
   * @param msg a <code>String</code> : \郁bZ[W
   */
  public final static void info(String msg) {
    putLog(Level.INFO,"Message",msg);
  }

  /**
   * RtBM[V\ꍇ.
   * @param msg a <code>String</code> : \郁bZ[W
   */
  public final static void config(String msg) {
    putLog(Level.CONFIG, "Config", msg);
  }

  /**
   * Describe <code>putLog</code> method : write Log Message.
   * <br>g[XOt@C֏oBB
   * <br>o`
   * <br>"[h NX \bh  bZ[W"
   * <br>ƂȂ܂B
   * @param lvl a <code>Level</code> : Õx
   * @param logMode a <code>String</code> : o͂郂[h
   * @param msg a <code>String</code> : o͂郁bZ[W
   */
  private static void putLog(Level lvl, String logMode, String msg) {
    Throwable thr = new Throwable();
    StackTraceElement[] stes = thr.getStackTrace();
    String pknm = stes[2].getClassName();
    int p = pknm.lastIndexOf(".");
    if (p >= 0) {
      pknm = pknm.substring(0, p);
    }
    Logger logr = Logger.getLogger(pknm);

    StringBuffer sb = new StringBuffer();
    sb.append(toChar(logMode,9,ALIGN_LEFT));
    sb.append(" ");
    sb.append(toChar(stes[2].getClassName(),65,ALIGN_LEFT));
    sb.append(" ");
    sb.append(toChar(stes[2].getMethodName(),20,ALIGN_LEFT));
    sb.append(" ");
    sb.append(msg);

    logr.log(lvl, sb.toString());
  }
//---------  private methods ------------------------------------------
  private static String toChar(String string,int size,int align){
    String retStr = "";
    switch(align){
    case ALIGN_LEFT:
      retStr = string + toSpace(size - string.length());
      break;
    case ALIGN_RIGHT:
      retStr = toSpace(size - string.length()) + string;
      break;
    default:
      retStr = string + toSpace(size - string.length());
      break;
    }
    return retStr;
  }
  private static String toSpace(int size){
    StringBuffer sb = new StringBuffer();
    for(int i=0;i<size;i++){
      sb.append(" ");
    }
    return sb.toString();
  }


  public static void main (String[] args) {
    System.out.println("-------- Trace Exec Sample -----------------------");
    enter();
    exit();
    debug("debug comment");
    exception("exception message");
    sql("sql message");
    info("Info message");
    System.out.println("-------- Trace Sample End  -----------------------");
  } // end of main ()
  
}
