package com.hamaf.hikyaku.util;

import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * <p>^Cg: XmlUtil is opretion DOM Utility.</p>
 * <p>: XML̑s[eBeBNX</p>
 * <p>쌠: Copyright (c) 2003</p>
 * @author Hamanaka
 * @version 1.0
 */

public class XmlUtil {
  public XmlUtil() {
  }

  /**
   * Describe <code>createDocument</code> method : create new Document Object.
   * ṼhLgIuWFNg𐶐Ė߂܂B
   * @return a <code>Document</code> : Document
   * @throws java.lang.Exception
   */
  public final static Document createDocument() throws Exception {
    DocumentBuilder db = DocumentBuilderFactory.newInstance().newDocumentBuilder();
    return db.newDocument();
  }

  /**
   * Describe <code>createDocument</code> method : create new Document from Xml File.
   * <br>w肳ꂽAXML File(URLw) DOM \zĖ߂܂B
   * @param fileName a <code>String</code> : Document \z XML File URL
   * @return a <code>Document</code> : Document
   * @throws java.lang.Exception
   */
  public final static Document createDocument(String fileName) throws Exception {
    return createDocument(ComUtils.getResource(fileName));
  }

  /**
   * Describe <code>createDocument</code> method : create new Document from Xml File.
   * <br>nꂽ̓Xg[ DOM \zĖ߂܂B
   * @param input an <code>InputStream</code> : Document \z̓Xg[
   * @return a <code>Document</code> : Document
   * @throws java.lang.Exception
   */
  public final static Document createDocument(InputStream input) throws Exception {
    DocumentBuilder db = DocumentBuilderFactory.newInstance().newDocumentBuilder();
    return db.parse(input);
  }
  
  /**
   * Describe <code>writeXml</code> method : Document write to Writer.
   * <br>DOMXML`ŃC^[ɏo܂B
   * <br>R[hɑΉ<code>Writer</code>w肷邱ƁB
   * @param xml a <code>Document</code> : o͂Document Object
   * @param out an <code>Writer</code> : o͐Writer
   * @param encode a <code>StreamResult</code> : o͂镶R[hiKl UTF-8j
   * @throws java.lang.Exception
   */
  public final static void writeXml(Document xml, Writer out, String encode) throws Exception {
    StreamResult sr = new StreamResult(out);
    trancformXml(xml, sr, encode);
  }

  /**
   * Describe <code>writeXml</code> method : Document write to OutputStream.
   * <br>DOMXML`ŃXg[ɏo܂B
   * @param xml a <code>Document</code> : o͂Document Object
   * @param out an <code>OntputStream</code> : o͐̃Xg[
   * @param encode a <code>StreamResult</code> : o͂镶R[hiKl UTF-8j
   * @throws java.lang.Exception
   */
  public final static void writeXml(Document xml, OutputStream out, String encode) throws Exception {
    if (encode == null || encode.length() == 0) encode = "utf-8";
    OutputStreamWriter osw = new OutputStreamWriter(out, encode);
    StreamResult sr = new StreamResult(osw);
    trancformXml(xml, sr, encode);
  }

  /**
   * Describe <code>writeXml</code> method : Document write to File.
   * <br>DOMXML`Ńt@Cɏo܂B
   * @param xml a <code>Document</code> : o͂Document Object
   * @param fileName a <code>String</code> : o͐̃t@C̃tpX
   * @param encode a <code>StreamResult</code> : o͂镶R[hiKl UTF-8j
   * @throws java.lang.Exception
   */
  public final static void writeXml(Document xml, String fileName, String encode) throws Exception {
    FileOutputStream fos = new FileOutputStream(fileName);
    writeXml(xml, fos, encode);
  }

  /**
   * Describe <code>trancformXml</code> method : Document write to StreamResult.
   * <br>DOMXML`ŃXg[\[Xɏo܂B
   * @param xml a <code>Document</code> : o͂Document Object
   * @param src a <code>StreamResult</code> : o͐Result
   * @param encode a <code>StreamResult</code> : o͂镶R[hiKl UTF-8j
   * @throws java.lang.Exception
   */
  private static void trancformXml(Document xml, Result src, String encode) throws Exception {
    DOMSource ds = new DOMSource(xml);
    Transformer tf = TransformerFactory.newInstance().newTransformer();
    if (encode != null) {
      tf.setOutputProperty(OutputKeys.ENCODING, encode);
    }
    tf.transform(ds, src);
  }

  /**
   * Describe <code>getPreviousElement</code> method : return First Previous Element.
   * nꂽm[ĥ̃Ggm[h߂܂BYm[h݂Ȃꍇ null Ԃ܂B
   * @param nd a <code>Node</code> : ɂȂm[h
   * @return a <code>Node</code> : ̃Ggm[h
   */
  public final static Node getPreviousElement(Node nd) {
    Node rnd = nd.getPreviousSibling();
    while (rnd != null && rnd.getNodeType() != Node.ELEMENT_NODE) {
      rnd = rnd.getPreviousSibling();
    }
    return rnd;
  }

  /**
   * Describe <code>getNextElement</code> method : return First Next Element.
   * nꂽm[ĥ̃Ggm[h߂܂BYm[h݂Ȃꍇ null Ԃ܂B
   * @param nd a <code>Node</code> : ɂȂm[h
   * @return a <code>Node</code> : ̃Ggm[h
   */
  public final static Node getNextElement(Node nd) {
    Node rnd = nd.getNextSibling();
    while (rnd != null && rnd.getNodeType() != Node.ELEMENT_NODE) {
      rnd = rnd.getNextSibling();
    }
    return rnd;
  }

}