package com.hamaf.hikyakucms.sample.schedule.process;

import com.hamaf.hikyakucms.sample.schedule.access.CategoryAccess;
import com.hamaf.hikyakucms.sample.schedule.access.HatsubanAccess;
import com.hamaf.hikyakucms.sample.schedule.access.HatsubanAccess.HATSUBAN_KBN;
import com.hamaf.hikyakucms.sample.schedule.dto.CategoryDto;
import com.hamaf.hikyakucms.sample.schedule.dto.CategorySearchDto;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;

/**
 * <p>^CgFCategoryProcess is .</p>
 * <p>FJeS[֌W̏</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/08/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class CategoryProcess {

   private CategoryAccess _ca = null;
   private HatsubanAccess _ha;

  /**
   *  Creates a new <code>CategoryProcess.java</code> instance.
   * <br>Default Constructor
   */
  public CategoryProcess() {
    _ca = new CategoryAccess();
    _ha = new HatsubanAccess();
  }

  /**
   * Describe <code>find</code> method : .
   * <br>JeS[̌B
   *
   * @param csd a <code>CategorySearchDto</code> :
   * @return a <code>CategorySearchDto</code> :
   * @throws Exception
   */
  public CategorySearchDto find(CategorySearchDto csd) throws Exception {
    return (CategorySearchDto)_ca.find(csd);
  }

  /**
   * Describe <code>getDetail</code> method : .
   * <br>JeS[̏ڍ׎擾B
   *
   * @param cd a <code>CategoryDto</code> :
   * @return a <code>CategoryDto</code> :
   * @throws Exception
   */
  public CategoryDto getDetail(CategoryDto cd) throws Exception {
    return (CategoryDto)_ca.findByPrimaryKey(cd);
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>JeS[̓o^B
   *
   * @param cd a <code>CategoryDto</code> :
   * @throws Exception
   */
  public void regist(CategoryDto cd) throws Exception {
    cd.setItemValue(CategoryDto.CATEGORY_ID,
    		_ha.getNextNo(HATSUBAN_KBN.CATEGORY, null, cd.getSysId()));
    _ca.regist(cd);
  }

  /**
   * Describe <code>update</code> method : .
   * <br>JeS[̍XVB
   *
   * @param cd a <code>CategoryDto</code> :
   * @throws Exception
   */
  public void update(CategoryDto cd) throws Exception {
    _ca.update(cd);
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>JeS[̎gpsݒ菈B
   *
   * @param cd a <code>CategoryDto</code> :
   * @throws Exception
   */
  public void delete(CategoryDto cd) throws Exception {
    cd.setCommFld(COMMFLD.DEL, USE_FLG.DEL.getVal());
    _ca.update(cd);
  }

}
