package com.hamaf.hikyakucms.sample.schedule.process;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import com.hamaf.hikyakucms.sample.schedule.access.HolidayAccess;
import com.hamaf.hikyakucms.sample.schedule.access.SqlExec;
import com.hamaf.hikyakucms.sample.schedule.dto.HolidayDto;
import com.hamaf.hikyakucms.sample.schedule.dto.HolidaySearchDto;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFHolidayProcess is .</p>
 * <p>Fj֌W̏sB</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/08/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class HolidayProcess {

  private HolidayAccess _ha = null;
  private SqlExec _se = null;

  /**
   *  Creates a new <code>HolidayProcess.java</code> instance.
   * <br>Default Constructor
   */
  public HolidayProcess() {
    _ha = new HolidayAccess();
    _se = new SqlExec();
  }

  /**
   * Describe <code>isHoliday</code> method : .
   * <br>w肳ꂽt(YYYY/MM/DD`)x`FbNB
   *
   * @param date  a <code>String</code> : `FbNt(YYYY/MM/DD`)
   * @param sysId a <code>String</code> :
   * @return a <code>boolean</code> : x̏ꍇA'true'
   */
  public boolean isHoliday(String date, String sysId) {
  	Calendar dt = DateUtil.getCalendar(date);
  	int week = dt.get(Calendar.DAY_OF_WEEK);
  	if (week == Calendar.SATURDAY || week == Calendar.SUNDAY) return true;
  	try {
			return isNationalHoliday(date, sysId);
		}
		catch (Exception ex) {	}
		return false;
  }
  /**
   * Describe <code>isHoliday</code> method : .
   * <br>w肳ꂽt(YYYY/MM/DD`)j`FbNB
   *
   * @param date a <code>String</code> : `FbNt(YYYY/MM/DD`)
   * @param sysId a <code>String</code> :
   * @return a <code>boolean</code> : j̏ꍇA'true'
   */
  public boolean isNationalHoliday(String date, String sysId) throws Exception {
    HolidayDto hd = new HolidayDto();
    hd.setItemValue(HolidayDto.YEAR, date.substring(0,4));
    hd.setItemValue(HolidayDto.MMDD, date.substring(5));
    hd.setSysId(sysId);
    hd = (HolidayDto)_ha.findByPrimaryKey(hd);
    return !hd.isNotFound();
  }

  /**
   * Describe <code>copyHoliday</code> method : .
   * <br>w肳ꂽN̏j𗂔NɕʂB
   *
   * @param year a <code>String</code> : ʌ̔N
   * @param userId a <code>String</code> : XVv[U[ID
   * @throws Exception
   */
  public void copyHoliday(String newyear, String today, String year, String userId, String plgid) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(plgid);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("NEWYEAR", newyear);
    pm.put("TODAY", today);
    pm.put("YEAR", year);
    pm.put("UPDUSER", userId);
    pi.addParam(pm);
    _se.copyHoliday(pi);
  }

  /**
   * Describe <code>find</code> method : .
   * <br>ǰB
   *
   * @param hsd a <code>HolidaySearchDto</code> :
   * @return a <code>HolidaySearchDto</code> :
   * @throws Exception
   */
  public HolidaySearchDto find(HolidaySearchDto hsd) throws Exception {
    return (HolidaySearchDto)_ha.find(hsd);
  }

  /**
   * Describe <code>getDetail</code> method : .
   * <br>j̎擾B
   *
   * @param hd a <code>HolidayDto</code> :
   * @return a <code>HolidayDto</code> :
   * @throws Exception
   */
  public HolidayDto getDetail(HolidayDto hd) throws Exception {
    return (HolidayDto)_ha.findByPrimaryKey(hd);
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>j̓o^B
   *
   * @param hd a <code>HolidayDto</code> :
   * @throws Exception
   */
  public void regist(HolidayDto hd) throws Exception {
    _ha.regist(hd);
  }

  /**
   * Describe <code>update</code> method : .
   * <br>j̍XVB
   *
   * @param hd a <code>HolidayDto</code> :
   * @throws Exception
   */
  public void update(HolidayDto hd) throws Exception {
    _ha.update(hd);
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>j̍폜B
   *
   * @param hd a <code>HolidayDto</code> :
   * @throws Exception
   */
  public void delete(HolidayDto hd) throws Exception {
    _ha.delete(hd);
  }

}
