package com.hamaf.hikyakucms.sample.schedule.ui;

import com.hamaf.hikyakucms.sample.schedule.dto.CategoryDto;
import com.hamaf.hikyakucms.sample.schedule.dto.CategorySearchDto;
import com.hamaf.hikyakucms.sample.schedule.process.CategoryProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.CategoryMap;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFCategoryList is .</p>
 * <p>FJeS[ꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/31</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CategoryList extends StandardListProcess {

	private CategoryProcess _cp = null;

	/**
	 * Creates a new <code>CategoryList.java</code> instance.
	 * <br>Default Constructor
	 */
	public CategoryList() {
		_jim = new CategoryMap();
		_cp = new CategoryProcess();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _cp.getDetail((CategoryDto)dii);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected String[] checkDelete(DetailItemsInterface dii) {
		if (delCheck(dii)) {
      String[] ret = {"name", super.resource.getString("DelLine")};
      return ret;
		}
		return null;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
	 */
	@Override
	protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
			throws Exception {
		return _cp.find((CategorySearchDto)rki);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new CategoryDto();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
	 */
	@Override
	protected RetrieveKeysInterface setRetrieveVal(KeyList kl)
			throws IllegalRetrieveDataException {
		CategorySearchDto csd = new CategorySearchDto();
		String nm = kl.getRetrieve("sname");
		if (nm.length() > 0) {
			csd.setRetrieveValue(CategorySearchDto.CATEGORY_NAME, nm);
			csd.setCondition(CategorySearchDto.CATEGORY_NAME, "like");
		}
		csd.setOrderItem(CategorySearchDto.CATEGORY_ID, 1);
		return csd;
	}

}
