package com.hamaf.hikyakucms.sample.schedule.ui;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.process.ScheduleProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.ScheduleMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFDirectMod is .</p>
 * <p>FDrag&DroppXPW[XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/02/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DirectMod extends StandardUpdateProcess {

	private ScheduleProcess _sp = null;
	/**
	 * Creates a new <code>DirectMod.java</code> instance.
	 * <br>Default Constructor
	 */
	public DirectMod() {
    _sp = new ScheduleProcess();
    _jim = new ScheduleMap();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new ScheduleDto();
	}

	private final String MSG_START = "top";
	private final String MSG_INTERVAL = "height";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage callControl(DetailItemsInterface dii,
			CommonMessage msg) throws Exception {
		ScheduleDto sd = new ScheduleDto();
		sd.setItemValue(ScheduleDto.USER_ID, dii.getItemValue(ScheduleDto.USER_ID));
		sd.setItemValue(ScheduleDto.SEQNO, dii.getItemValue(ScheduleDto.SEQNO));
		sd.setSysId(dii.getSysId());
		sd = _sp.findbyprimarykey(sd);

		sd.setItemValue(ScheduleDto.DAY, dii.getItemValue(ScheduleDto.DAY));
		sd.setCommFld(COMMFLD.UUSR, getUserID());
		String tfrom = compTime("08:00", msg.getReq(MSG_START));
		sd.setItemValue(ScheduleDto.TIME_FROM, tfrom);
		sd.setItemValue(ScheduleDto.TIME_TO, compTime(tfrom, msg.getReq(MSG_INTERVAL)));
		_sp.update(sd);
		return msg;
	}
	private String compTime(String btime, String interval) {
		if (btime == null || btime.length() == 0) return "";
		if (interval == null || interval.length() == 0) return btime;

		Calendar cd = Calendar.getInstance();
		String shour = btime.substring(0,2);
		String sminuts = btime.substring(3);
		cd.set(Calendar.HOUR_OF_DAY, Integer.parseInt(shour));
		cd.set(Calendar.MINUTE, Integer.parseInt(sminuts));
		cd.add(Calendar.MINUTE, Integer.parseInt(interval));
		SimpleDateFormat df = (SimpleDateFormat)DateFormat.getTimeInstance();
		df.applyPattern("HH:mm");
		return df.format(cd.getTime());
	}

}
