package com.hamaf.hikyakucms.sample.sns.access;

import java.sql.SQLException;
import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.access.ExclusionException;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyakucms.sample.sns.dto.BoardDto;

/**
 * <p>^CgFBoardAccess is .</p>
 * <p>Ffe[uANZXNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BoardAccess extends DefaultTableAccess {

  private final String TBLNM = "M_BOARD";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>BoardAccess.java</code> instance.
   * <br>Default Constructor
   */
  public BoardAccess() {
    tableName = TBLNM;
    connectionParameter = PARM;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#regist(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void regist(DetailItemsInterface dii) throws SQLException {
    dii = completionDto(dii);
    super.regist(dii);
  }
  private DetailItemsInterface completionDto(DetailItemsInterface cd) {
    if (cd.isRequestItem(BoardDto.DETAIL)) {
      String dtl = cd.getItemValue(BoardDto.DETAIL);
      if (dtl != null && dtl.length() > 0) cd.setItemValue(BoardDto.RET_DETAIL, dtl.replaceAll("<.+?>", ""));
    }
    return cd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#update(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void update(DetailItemsInterface dii) throws ExclusionException,
      SQLException {
    dii = completionDto(dii);
    super.update(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#updateNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void updateNoExclusion(DetailItemsInterface dii) throws SQLException {
    dii = completionDto(dii);
    super.updateNoExclusion(dii);
  }

}
