package com.hamaf.hikyakucms.sample.sns.access;

import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyakucms.sample.sns.dto.Hatsuban2Dto;

/**
 * <p>^CgFHatsuban2Access is .</p>
 * <p>Fԃe[ũANZXNX</p>
 * <br>ԃe[u͋LŎgp
 *
 * <p>쌠: Copyright (c) 2011/02/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class Hatsuban2Access extends DefaultTableAccess {

  // "C","S"ScheduleŎgpς
  public enum HATSUBAN2_KBN {
    COMMUNICATION("R", 9, false),
    NOTICE("N",7,true),
    GENRE("G",7,false),
    FILE("F",7,true),
    ENRUETE("E", 9, false),
    CONVERSATION("V", 9, false),
    SOLILOQUY("H", 9, false);

    private String key;
    private int len;
    private boolean subk;
    HATSUBAN2_KBN(String k, int l, boolean sk) { key = k; len = l; subk = sk;}
    public String getKey() { return key; }
    public int getLen() { return len; }
    public boolean getSubk() { return subk; }

  };

  private final String TBLNM = "M_HATUBAN";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>Hatsuban2Access.java</code> instance.
   * <br>Default Constructor
   */
  public Hatsuban2Access() {
    tableName = TBLNM;
    connectionParameter = PARM;
  }

  public String getNextNo(HATSUBAN2_KBN kb, String key, String sysId) throws Exception {
    Hatsuban2Dto hd = getHatubanDto(kb, key, sysId);
    hd = (Hatsuban2Dto)findByPrimaryKey(hd);
    if (hd.isNotFound()) {
      String mno = addNo("0", kb);
      hd.setItemValue(Hatsuban2Dto.MAX_NUMBER, mno);
      regist(hd);
      return mno;
    }
    String mno = addNo(hd.getItemValue(Hatsuban2Dto.MAX_NUMBER), kb);
    hd.setItemValue(Hatsuban2Dto.MAX_NUMBER, mno);
    update(hd);
    return mno;
  }

  private Hatsuban2Dto getHatubanDto(HATSUBAN2_KBN kb, String key, String sysId) {
    Hatsuban2Dto hd = new Hatsuban2Dto();
    hd.setItemValue(Hatsuban2Dto.KUBUN, kb.getKey());
    hd.setSysId(sysId);
    if (kb.getSubk()) {
      hd.setItemValue(Hatsuban2Dto.KEY_VALUE, key);
    } else {
      hd.setItemValue(Hatsuban2Dto.KEY_VALUE, "key");
    }
    hd.setAllRequest();
    return hd;
  }

  private String addNo(String no, HATSUBAN2_KBN kb) {
    int len = kb.getLen();
    int ino = Integer.parseInt(no);
    ino++;
    no = String.valueOf(ino);
    if(no.length() > len) {
      return no.substring(no.length() - len);
    }
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < (len - no.length()); i++) {
      sb.append("0");
    }
    sb.append(no);
    return sb.toString();
  }

}
