package com.hamaf.hikyakucms.sample.sns.commonUi;

import java.text.Format;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.process.FootprintsProcess;
import com.hamaf.hikyakucms.sample.sns.process.RestrictionProcess;
import com.hamaf.hikyakucms.sample.sns.ui.CommunicationDetail;

/**
 * <p>^CgFFootprintsList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/18</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class FootprintsList extends ProcessBase {

  private final String MSG_UID = "userId";
  private final String MSG_UNM = "userName";
  private final String MSG_KDT = "kakuninbi";
  private final String MSG_BTN = "osirase";
  private final String MSG_CNT = "counter";

  private final String MSG_TTL = "title";
  private final String MSG_LTL = "listTitle";

  private final String REQ_KBN = "checkKbn";
  private final String REQ_DOC = "docKbn";
  private final String REQ_SEQ = "keySeq";

  private FootprintsProcess _fp = null;
  /**
   * Creates a new <code>FootprintsList.java</code> instance.
   * <br>Default Constructor
   */
  public FootprintsList() {
    _fp = new FootprintsProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    List<String[]> ulst = null;
    HATSUBAN2_KBN dockbn = getKbn(msg.getReqStr(REQ_DOC));
    String kseq = msg.getReqStr(REQ_SEQ);
    String kbn = msg.getReqStr(REQ_KBN).toLowerCase();
    if (kbn.startsWith("no")) {
      msg.setResMsg(MSG_TTL, "mF");
      msg.setResMsg(MSG_LTL, "ʒm");
      String grps = msg.getReqStr(CommunicationDetail.MSG_GID);
      List<String> grpl = new ArrayList<String>();
      if (grps.length() > 0 && !RestrictionProcess.ALL_USERID.equals(grps)) {
        String[] grp = grps.split(",");
        for (int i = 0; i < grp.length; i++) {
          grpl.add(grp[i]);
        }
      }
      ulst = _fp.getNotCheckUsers(dockbn, kseq, grpl, sysId, getUserID(), true);
    } else {
      msg.setResMsg(MSG_TTL, "mFς");
      msg.setResMsg(MSG_LTL, "mF");
      ulst = _fp.getCheckUsers(dockbn, kseq, sysId, getUserID());
    }
    Format fm = NumberFormat.getIntegerInstance();
    msg.setResMsg(MSG_CNT, fm.format(ulst.size()));
    for (String[] vals : ulst) {
      Map<String, String> mdt = new HashMap<String, String>();
      mdt.put(MSG_UNM, vals[0]);
      mdt.put(MSG_UID, vals[1]);
      mdt.put(MSG_KDT, vals[2]);
      if (kbn.startsWith("no")) {
        mdt.put(MSG_BTN, "ʒm");
      } else {
        mdt.put(MSG_BTN, "");
      }
      msg.addResList(mdt);
    }
    msg.setErrorStatus(STATUS.NORMAL);
    return msg;
  }
  private HATSUBAN2_KBN getKbn(String val) {
    HATSUBAN2_KBN.values();
    for (int i = 0; i < HATSUBAN2_KBN.values().length; i++) {
      HATSUBAN2_KBN kbn = HATSUBAN2_KBN.values()[i];
      if (kbn.getKey().equals(val)) return kbn;
    }
    return null;
  }

}
