package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.CommunicationDto;
import com.hamaf.hikyakucms.sample.sns.process.CommunicationProcess;
import com.hamaf.hikyakucms.sample.sns.process.FootprintsProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.CommunicationMap;

/**
 * <p>^CgFCommunicationDelete is .</p>
 * <p>FǗҗpAʒm폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommunicationDelete extends StandardUpdateProcess {

  private CommunicationProcess _cp = null;
  private FootprintsProcess _fp = null;

  /**
   * Creates a new <code>CommunicationDelete.java</code> instance.
   * <br>Default Constructor
   */
  public CommunicationDelete() {
    _jim = new CommunicationMap();
    _cp = new CommunicationProcess();
    _fp = new FootprintsProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new CommunicationDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii, CommonMessage msg) throws Exception {
    if (!"all".equals(msg.getReqStr("delType"))) {
      delProc(dii);
      return msg;
    }
    KeyList kyl = (KeyList)super.saveObj;
    for (List<String> keys : kyl) {
      for (int i = 0; i < keys.size(); i++) {
        dii.setItemValue(i, keys.get(i));
      }
      delProc(dii);
    }
    return msg;
  }
  private void delProc(DetailItemsInterface dii) throws Exception {
    CommunicationDto cd = (CommunicationDto)dii;
    cd = _cp.findByPrimaryKey(cd);
    _cp.delete(cd);
    _fp.delFootprints(HATSUBAN2_KBN.COMMUNICATION, cd.getItemValue(CommunicationDto.SEQNO), cd.getSysId());
  }

}
