package com.hamaf.hikyakucms.sample.sns.managerUi;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.dto.VEnqueteSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.EnqueteMap;

/**
 * <p>^CgFEnqueteList is .</p>
 * <p>FǗҗpAP[gꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/04</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteList extends StandardListProcess {

  private EnqueteProcess _ep = null;
  private boolean _ret = false;

  /**
   * Creates a new <code>EnqueteList.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteList() {
    _jim = new EnqueteMap();
    _ep = new EnqueteProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    VEnqueteSearchDto vesd = new VEnqueteSearchDto();
    if (keyl.getRetrieve("ret").length() == 0) return vesd;

    _ret = true;
    String finish = keyl.getRetrieve("sfinish");
    if (finish != null && finish.length() > 0) {
      vesd.setRetrieveValue(VEnqueteSearchDto.FINISH_DAY, finish);
      vesd.setCondition(VEnqueteSearchDto.FINISH_DAY, "<=");
    }
    String dayto = keyl.getRetrieve("sdayTo");
    if (dayto != null && dayto.length() > 0) {
      vesd.setRetrieveValue(VEnqueteSearchDto.DAY_TO, dayto);
      vesd.setCondition(VEnqueteSearchDto.DAY_TO, "<=");
    }
    vesd.setRetrieveValue(VEnqueteSearchDto.MANAGER, keyl.getRetrieve("smanager"));
    String entusr = keyl.getRetrieve("sentryName");
    if (entusr != null && entusr.length() > 0) {
      vesd.setRetrieveValue(VEnqueteSearchDto.ENTRY_NAME, entusr);
      vesd.setCondition(VEnqueteSearchDto.ENTRY_NAME, "LIKE");
    }
    String value = keyl.getRetrieve("sval");
    if (value != null && value.length() > 0) {
      vesd.setRetrieveValue(VEnqueteSearchDto.RETVAL, "%" + value + "%");
      vesd.setCondition(VEnqueteSearchDto.RETVAL, "LIKE");
    }
    return vesd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    if (_ret) rki = _ep.find((VEnqueteSearchDto)rki);
    return rki;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _ep.getDetail((EnqueteDto)dii);
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ddt = {"contents", MSG_DEL};
      return ddt;
    }
    return null;
  }

}
