package com.hamaf.hikyakucms.sample.sns.managerUi;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.sns.dto.GenreDto;
import com.hamaf.hikyakucms.sample.sns.dto.GenreSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.GenreProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.GenreMap;

/**
 * <p>^CgFGenreList is .</p>
 * <p>FW}X^̈ꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/11</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GenreList extends StandardListProcess {

  private GenreProcess _gp = null;
  /**
   * Creates a new <code>GenreList.java</code> instance.
   * <br>Default Constructor
   */
  public GenreList() {
    _jim = new GenreMap();
    _gp = new GenreProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    GenreSearchDto gsd = new GenreSearchDto();
    gsd.setOrderItem(GenreSearchDto.GENRE_ID, 1);
    return gsd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _gp.find((GenreSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GenreDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gp.getDetail((GenreDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ret = {"name", super.resource.getString("DelLine")};
      return ret;
    }
    return null;
  }

}
