package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquyDto;
import com.hamaf.hikyakucms.sample.sns.process.FootprintsProcess;
import com.hamaf.hikyakucms.sample.sns.process.SoliloquyProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.SoliloquyMap;

/**
 * <p>^CgFSoliloquyDelete is .</p>
 * <p>FǗҗpƂ茾폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class SoliloquyDelete extends StandardUpdateProcess {

  private SoliloquyProcess _sp = null;
  private FootprintsProcess _fp = null;

  /**
   * Creates a new <code>SoliloquyDelete.java</code> instance.
   * <br>Default Constructor
   */
  public SoliloquyDelete() {
    _jim = new SoliloquyMap();
    _sp = new SoliloquyProcess();
    _fp = new FootprintsProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new SoliloquyDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (!"all".equals(msg.getReqStr("delType"))) {
      delProc(dii);
      return msg;
    }
    KeyList kyl = (KeyList)super.saveObj;
    for (List<String> keys : kyl) {
      for (int i = 0; i < keys.size(); i++) {
        dii.setItemValue(i, keys.get(i));
      }
      delProc(dii);
    }
    return msg;
  }
  private void delProc(DetailItemsInterface dii) throws Exception {
    SoliloquyDto cd = (SoliloquyDto)dii;
    _sp.delete(cd);
    _fp.delFootprints(HATSUBAN2_KBN.SOLILOQUY, cd.getItemValue(SoliloquyDto.SEQNO), cd.getSysId());
  }

}
