package com.hamaf.hikyakucms.sample.sns.process;

import java.util.List;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyakucms.sample.sns.access.CommunicationAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access;
import com.hamaf.hikyakucms.sample.sns.access.ModifyCommunication;
import com.hamaf.hikyakucms.sample.sns.access.VCommunecationAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.CommunicationDto;
import com.hamaf.hikyakucms.sample.sns.dto.VCommunicationDto;
import com.hamaf.hikyakucms.sample.sns.dto.VCommunicationSearchDto;

/**
 * <p>^CgFCommunicationProcess is .</p>
 * <p>FA̋Ɩ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/01</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommunicationProcess {

  private CommunicationAccess _ca = null;
  private VCommunecationAccess _vca = null;
  private Hatsuban2Access _ha = null;

 /**
  *  Creates a new <code>CommunicationProcess.java</code> instance.
  * <br>Default Constructor
  */
 public CommunicationProcess() {
   _ca = new CommunicationAccess();
   _vca = new VCommunecationAccess();
   _ha = new Hatsuban2Access();

//   _vca.setDebug();
 }

 /**
  * Describe <code>find</code> method : .
  * <br>ǍB
  *
  * @param csd a <code>CommunicationSearchDto</code> :
  * @return a <code>CommunicationSearchDto</code> :
  * @throws Exception
  */
 public VCommunicationSearchDto find(VCommunicationSearchDto csd) throws Exception {
   return (VCommunicationSearchDto)_vca.find(csd);
 }

 /**
  * Describe <code>getDetail</code> method : .
  * <br>Ȁڍ׎擾B
  *
  * @param cd a <code>CommunicationDto</code> :
  * @return a <code>CommunicationDto</code> :
  * @throws Exception
  */
 public VCommunicationDto getDetail(VCommunicationDto cd) throws Exception {
   return (VCommunicationDto)_vca.findByPrimaryKey(cd);
 }

 /**
 * Describe <code>findByPrimaryKey</code> method : .
 * <br>A̎擾B
 *
 * @param cd a <code>CommunicationDto</code> :
 * @return a <code>CommunicationDto</code> :
 * @throws Exception
 */
public CommunicationDto findByPrimaryKey(CommunicationDto cd) throws Exception {
   return (CommunicationDto)_ca.findByPrimaryKey(cd);
 }

/**
 * Describe <code>regist</code> method : .
 * <br>A̓o^B
 *
 * @param cd a <code>CommunicationDto</code> :
 * @return a <code>String</code> : ԂSeqNo
 * @throws Exception
 */
public String regist(CommunicationDto cd) throws Exception {
   String nno = _ha.getNextNo(HATSUBAN2_KBN.COMMUNICATION, null, cd.getSysId());
   cd.setItemValue(CommunicationDto.SEQNO, nno);
   String mng = cd.getItemValue(CommunicationDto.MANAGER);
   if (mng == null || mng.length() == 0) cd.setItemValue(CommunicationDto.MANAGER, cd.getCommFld(COMMFLD.UUSR));
   if ("1".equals(cd.getItemValue(CommunicationDto.ALL_FLG))) {
     cd.addRestriction(RestrictionProcess.ALL_USERID);
   }
   ModifyCommunication mc = new ModifyCommunication();
   try {
     mc.addCommunication(cd);
     mc.addRestriction(cd);
   }
   catch (Exception ex) {
     mc.rollBack();
     throw ex;
   }
   mc.commit();
   return nno;
 }

 /**
  * Describe <code>update</code> method : .
  * <br>A̍XVB
  *
  * @param cd a <code>CommunicationDto</code> :
  * @throws Exception
  */
 public void update(CommunicationDto cd) throws Exception {
   String mng = cd.getItemValue(CommunicationDto.MANAGER);
   if (mng == null || mng.length() == 0) cd.setItemValue(CommunicationDto.MANAGER, cd.getCommFld(COMMFLD.UUSR));
   if ("1".equals(cd.getItemValue(CommunicationDto.ALL_FLG))) {
     cd.addRestriction(RestrictionProcess.ALL_USERID);
   }
   ModifyCommunication mc = new ModifyCommunication();
   try {
     mc.modCommunication(cd);
     mc.delRestrictionAll(cd);
     mc.addRestriction(cd);
   }
   catch (Exception ex) {
     mc.rollBack();
     throw ex;
   }
   mc.commit();
 }

 /**
  * Describe <code>deleteLogical</code> method : .
  * <br>A̎gpsݒ菈B
  *
  * @param cd a <code>CommunicationDto</code> :
  * @throws Exception
  */
 public void deleteLogical(CommunicationDto cd) throws Exception {
   cd.setCommFld(COMMFLD.DEL, USE_FLG.DEL.getVal());
   _ca.update(cd);
 }

 /**
 * Describe <code>delete</code> method : .
 * <br>A̍폜B
 *
 * @param cd a <code>CommunicationDto</code> :
 * @throws Exception
 */
 public void delete(CommunicationDto cd) throws Exception {
   ModifyCommunication mc = new ModifyCommunication();
   try {
     mc.delCommunication(cd);
     mc.delRestrictionAll(cd);
     List<String> flnms = mc.delAppendFileAll(cd);
     for (String flnm : flnms) {
       mc.delEntityFile(flnm);
     }
   }
   catch (Exception ex) {
     mc.rollBack();
     throw ex;
   }
   mc.commit();
 }

}
