package com.hamaf.hikyakucms.sample.sns.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyakucms.sample.sns.access.FootprintsAccess;
import com.hamaf.hikyakucms.sample.sns.access.SqlExec;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.FootprintsDto;
import com.hamaf.hikyakucms.sample.sns.dto.FootprintsSearchDto;

/**
 * <p>^CgFFootprintsProcess is .</p>
 * <p>FՏ̏NX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class FootprintsProcess {

  private FootprintsAccess _fa = null;
  private SecurityCheckUtils _scu = null;
  private SqlExec _se = null;

  /**
   * Creates a new <code>FootprintsProcess.java</code> instance.
   * <br>Default Constructor
   */
  public FootprintsProcess() {
    _fa = new FootprintsAccess();
    _scu = new SecurityCheckUtils();
    _se = new SqlExec();

//  _se.setDebug();
  }

  /**
   * Describe <code>getCheckUsers</code> method : .
   * <br>Ղo^[U[̈ꗗ擾B
   * <br>[[U[, [U[ID]̃Xg߂B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code>
   * @param keySeq a <code>String</code> : SeqNo
   * @param sysId a <code>String</code> : vOCID
   * @param uid a <code>String</code> : v郆[U[ID
   * @return a <code>List&lt;String[]&gt;</code> : Ղ[U[̃Xg
   * @throws Exception
   */
  public List<String[]> getCheckUsers(HATSUBAN2_KBN kbn, String keySeq,
      String sysId, String uid)  throws Exception {
    List<String[]> ret = new ArrayList<String[]>();
    FootprintsDto fd = new FootprintsDto();
    fd.setSysId(sysId);
    List<String> uids = getFootUser(kbn, keySeq, sysId);
    for (String id : uids) {
      UserDto ud = _scu.getUserInf(id, uid);
      String unm = ud.getItemValue(UserDto.ABBREV);
      if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
      fd.setItemValue(FootprintsDto.CATEGORY, kbn.getKey());
      fd.setItemValue(FootprintsDto.KEY_SEQNO, keySeq);
      fd.setItemValue(FootprintsDto.USER_ID, id);
      fd = (FootprintsDto)_fa.findByPrimaryKey(fd);
      String[] dt = {unm, id, fd.getCommFld(COMMFLD.UPDT)};
      ret.add(dt);
    }
    return ret;
  }
  private List<String> getFootUser(HATSUBAN2_KBN kbn, String keySeq,
      String sysId) throws Exception {
    List<String> ret = new ArrayList<String>();
    FootprintsSearchDto fsd = new FootprintsSearchDto();
    fsd.setRetrieveValue(FootprintsSearchDto.CATEGORY, kbn.getKey());
    fsd.setRetrieveValue(FootprintsSearchDto.KEY_SEQNO, keySeq);
    fsd.setSysId(sysId);
    fsd = (FootprintsSearchDto)_fa.find(fsd);
    for (List<String> keys : fsd) {
      ret.add(keys.get(2));
    }
    return ret;
  }

  /**
   * Describe <code>getNotCheckUsers</code> method : .
   * <br>Ղv^̃[U[̈ꗗ擾B
   * <br>[[U[, [U[ID]̃Xg߂B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code>
   * @param keySeq a <code>String</code> : SeqNo
   * @param gids a <code>List&lt;String&gt;</code> : ΏۃO[v̈ꗗ
   * @param sysId a <code>String</code> : vOCID
   * @param uid a <code>String</code> : v郆[U[ID
   * @param notme a <code>boolean</code> : ꍇ true
   * @return a <code>List&lt;String[]&gt;</code> : ՂȂ[U[̃Xg
   * @throws Exception
   */
  public List<String[]> getNotCheckUsers(HATSUBAN2_KBN kbn, String keySeq, List<String> gids,
      String sysId, String uid, boolean notme)  throws Exception {
    List<String[]> ret = new ArrayList<String[]>();
    List<String> uids = getFootUser(kbn, keySeq, sysId);
    if (notme) uids.add(uid);
    List<String> chkUid = null;
    if (gids == null || gids.size() == 0) {
      chkUid = _scu.getUserAll();
    } else {
      chkUid = _scu.getUserInGp(gids);
    }
    for (String auid : chkUid) {
      if (!uids.contains(auid)) {
        UserDto ud = _scu.getUserInf(auid, uid);
        String unm = ud.getItemValue(UserDto.ABBREV);
        if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
        String[] dt = {unm, auid, ""};
        ret.add(dt);
      }
    }
    return ret;
  }

  /**
   * Describe <code>isFootprints</code> method : .
   * <br>Ղo^Ă邩`FbNB
   * <br>o^ĂꍇA"1" @o^̏ꍇA"0" ߂B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code>
   * @param keySeq a <code>String</code> : SeqNo
   * @param sysId a <code>String</code> : vOCID
   * @param uid a <code>String</code> : `FbN郆[U[ID
   * @return a <code>String</code> : o^Ăꍇ "1"AȊO "0"
   * @throws Exception
   */
  public String isFootprints(HATSUBAN2_KBN kbn, String keySeq,
      String sysId, String uid)  throws Exception {
    FootprintsDto fd = new FootprintsDto();
    fd.setItemValue(FootprintsDto.CATEGORY, kbn.getKey());
    fd.setItemValue(FootprintsDto.KEY_SEQNO, keySeq);
    fd.setItemValue(FootprintsDto.USER_ID, uid);
    fd.setSysId(sysId);
    fd = (FootprintsDto)_fa.findByPrimaryKey(fd);
    return fd.isNotFound()? "0": "1";
  }

  /**
   * Describe <code>add</code> method : .
   * <br>Ղ̓o^B
   *
   * @param fd a <code>FootprintsDto</code>
   * @throws Exception
   */
  public void add(FootprintsDto fd) throws Exception {
    _fa.regist(fd);
  }

  /**
   * Describe <code>delFootprints</code> method : .
   * <br>w肳ꂽ̑Ղ폜B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code> :
   * @param keySeq a <code>String</code> : No
   * @param sysId a <code>String</code> : vOCID
   * @throws Exception
   */
  public void delFootprints(HATSUBAN2_KBN kbn, String keySeq, String sysId) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(sysId);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("CATEGORY", kbn.getKey());
    pm.put("SEQNO", keySeq);
    pi.addParam(pm);
    _se.delFootprints(pi);
  }
}
