package com.hamaf.hikyakucms.sample.sns.ui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.VANswerCountMap;

/**
 * <p>^CgFAnswerList is .</p>
 * <p>F񓚌̕\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AnswerList extends StandardListProcess {

  private AnswerProcess _ap = null;
  private EnqueteProcess _ep = null;

  /**
   * Creates a new <code>AnswerList.java</code> instance.
   * <br>Default Constructor
   */
  public AnswerList() {
    _jim = new VANswerCountMap();
    _ap = new AnswerProcess();
    _ep = new EnqueteProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    VAnswerCountSearchDto vacsd = new VAnswerCountSearchDto();
    vacsd.setRetrieveValue(VAnswerCountSearchDto.ENQUETE_SEQNO,
        keyl.getRetrieve("seqNo"));
    return vacsd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _ap.findAnsCount((VAnswerCountSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VAnswerCountDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _ap.getAnsCount((VAnswerCountDto)dii);
  }

  private String MSG_TTL = "title";
  private String MSG_FLG = "saysFlg";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#supplementEdit(com.hamaf.hikyaku.dataobject.CommonMessage, com.hamaf.hikyaku.dataobject.KeyList, java.lang.String)
   */
  @Override
  protected CommonMessage supplementEdit(CommonMessage msg, KeyList kl,
      String pact) throws Exception {
    String seqNo = kl.getRetrieve("seqNo");
    msg.setWorkBuff(_ap.getSays(seqNo, getUserID(), sysId));
    EnqueteDto ed = new EnqueteDto();
    ed.setItemValue(EnqueteDto.SEQNO, seqNo);
    ed.setRequestItem(EnqueteDto.CONTENTS);
    ed.setRequestItem(EnqueteDto.SAYS_FLG);
    ed.setSysId(sysId);
    ed = _ep.findByPrimaryKey(ed);
    msg.setResMsg(MSG_TTL, ed.getItemValue(EnqueteDto.CONTENTS));
    msg.setResMsg(MSG_FLG, ed.getItemValue(EnqueteDto.SAYS_FLG));

    if ("1".equals(ed.getItemValue(EnqueteDto.SAYS_FLG))) {
      List<Map<String, String>> wmsg = new ArrayList<Map<String,String>>();
      List<String[]> dt = _ap.getSays(seqNo, getUserID(), sysId);
      for (String[] val : dt) {
        Map<String, String> mdt = new HashMap<String, String>();
        mdt.put("says", val[0]);
        mdt.put("unm", val[1]);
        wmsg.add(mdt);
      }
      msg.setWorkBuff(wmsg);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

}
