package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerDto;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.AnswerMap;

/**
 * <p>^CgFAnswerUserList is .</p>
 * <p>F񓚎҃Xg</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/01</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AnswerUserList extends StandardListProcess {

  private AnswerProcess _ap = null;

  /**
   * Creates a new <code>AnswerUserList.java</code> instance.
   * <br>Default Constructor
   */
  public AnswerUserList() {
    _jim = new AnswerMap();
    _ap = new AnswerProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, keyl.getRetrieve("seqNo"));
    asd.setRetrieveValue(AnswerSearchDto.Q_SEQNO, keyl.getRetrieve("qSeqNo"));
    asd.setOrderItem(AnswerSearchDto.USER_ID, 1);
    return asd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _ap.find((AnswerSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AnswerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _ap.getDetail((AnswerDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

}
