package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.ui.StandardDetailProcess;
import com.hamaf.hikyakucms.sample.sns.dto.ConversationDto;
import com.hamaf.hikyakucms.sample.sns.process.ConversationProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.ConversionMap;

/**
 * <p>^CgFConversationDetail is .</p>
 * <p>Fb^̏ڍו\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/23</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ConversationDetail extends StandardDetailProcess {

  private ConversationProcess _cp = null;
  /**
   * Creates a new <code>ConversationDetail.java</code> instance.
   * <br>Default Constructor
   */
  public ConversationDetail() {
    _jim = new ConversionMap();
    _cp = new ConversationProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new ConversationDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _cp.findByPrimaryKey((ConversationDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#setKeys(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String ps = msg.getReqStr("pos");
    String seq = msg.getReqStr("seqNo");
    if (ps.length() > 0) return false;
    dii.setItemValue(ConversationDto.SEQNO, seq);
    return true;
  }

  private final String MSG_UP = "updateFlg";
  private final String MSG_REP = "replayFlg";
  private final String MSG_TUP = "updateTitle";
  private final String MSG_LTL = "listTitle";
  private final String ORG_DTL = "originalDetail";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#editItems(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    msg.setResMsg(MSG_UP, "0");
    msg.setResMsg(MSG_REP, "0");
    String fdt = msg.getResMsg("finish");
    if (fdt == null || fdt.length() == 0) {
      msg.setResMsg(MSG_REP, "1");
      if (getUserID().equals(msg.getResMsg(COMMFLD.UUSR.getVal()))) msg.setResMsg(MSG_UP, "1");
    }
    if ("1".equals(msg.getResMsg("lvl"))) {
      msg.setResMsg(MSG_TUP, "1");
      msg.setResMsg(MSG_LTL, "⍇e");
    } else {
      msg.setResMsg(MSG_TUP, "0");
      msg.setResMsg(MSG_LTL, "ԐMe");
    }
    msg.setResMsg(ORG_DTL, msg.getResMsg("detail"));
    return super.editItems(msg);
  }

}
