package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;
import com.hamaf.hikyakucms.sample.sns.dto.ConversationDto;
import com.hamaf.hikyakucms.sample.sns.process.ConversationProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.ConversionMap;

/**
 * <p>^CgFConversationUpdate is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/23</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ConversationUpdate extends StandardCheckAndUpdate {

  private final String FLD = "ConversationUpdate";
  private ConversationProcess _cp = null;
  /**
   * Creates a new <code>ConversationUpdate.java</code> instance.
   * <br>Default Constructor
   */
  public ConversationUpdate() {
    _jim = new ConversionMap();
    _cfld = FLD;
    _cp = new ConversationProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkRelation(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkRelation(CommonMessage msg) throws Exception {
    String lvl = msg.getReqStr("lvl");
    String ttl = msg.getReqStr("title");
    if (lvl.length() == 0 && ttl.length() == 0) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.setResMsg("title", "^Cg͕K{łB");
    }
    return super.checkRelation(msg);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new ConversationDto();
  }

  private final String MSG_UPT = "updatetype";
  private final String MSG_OK = "updatetOk";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String uptyp = msg.getReqStr(MSG_UPT).toLowerCase();
    ConversationDto cd = (ConversationDto)dii;
    if (uptyp.startsWith("n")) {
      _cp.add(cd);
    } else if (uptyp.startsWith("a")) {
      cd.setParLvl(msg.getReqStr("lvl"));
      cd.setParSeq(msg.getReqStr("sort"));
      _cp.add(cd);
    } else if (uptyp.startsWith("m")) {
      _cp.mod(cd);
    } else if (uptyp.startsWith("f")) {
      _cp.modFinish(cd);
    }
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
