package com.hamaf.hikyakucms.sample.sns.ui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.StandardDetailProcess;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerDto;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.process.RestrictionProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.EnqueteMap;

/**
 * <p>^CgFEnqueteDetail is .</p>
 * <p>FAP[g̏ڍ׉ʕ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteDetail extends StandardDetailProcess {

  private EnqueteProcess _ep = null;
  private AnswerProcess _ap = null;
  private RestrictionProcess _rp = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>EnqueteDetail.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteDetail() {
    _jim = new EnqueteMap();
    _ep = new EnqueteProcess();
    _ap = new AnswerProcess();
    _rp = new RestrictionProcess();
    _scu = new SecurityCheckUtils();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  private List<String[]> _svQue = null;
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    EnqueteDto ed = _ep.getDetail((EnqueteDto)dii);
    _svQue = ed.getQuestionList();
    return ed;
  }

  private final String MSG_AS = "answer";
  private final String MSG_PAS = "posibleAnswer";
  private final String MSG_UP = "updateFlg";
  private final String MSG_MD = "managerFlg";
  private final String MSG_MN = "managerName";
  private final String MSG_GNM = "groupName";
  private final String MSG_KBN = "docKbn";
  private final String MSG_SAY = "says";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#editItems(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    if (msg.getResMsg("dayTo").startsWith("9999")) msg.setResMsg("dayTo", "");

    msg.setResMsg(MSG_KBN, HATSUBAN2_KBN.ENRUETE.getKey());
    String uid = getUserID();
    String mgr = msg.getResMsg("manager");
    UserDto ud = _scu.getUserInf(mgr, uid);
    String mnm = ud.getItemValue(UserDto.ABBREV);
    if (mnm == null || mnm.length() == 0) mnm = ud.getItemValue(UserDto.NAME);
    msg.setResMsg(MSG_MN, mnm);

    if (_ap.isAnswer(msg.getResMsg("seqNo"), uid, sysId)) {
      msg.setResMsg(MSG_AS, "񓚍ς");
    } else {
      msg.setResMsg(MSG_AS, "");
    }
    String upd = "0";
    if (uid.equals(mgr)) {
      msg.setResMsg(MSG_MD, "1");
      upd = "1";
    } else {
      msg.setResMsg(MSG_MD, "0");
      if (uid.equals(msg.getResMsg(COMMFLD.UUSR.getVal()))) {
        upd = "1";
      }
    }
    if ("1".equals(upd)) {
      if (DateUtil.getDate().compareTo(msg.getResMsg("dayTo")) > 0) {
        upd = "2";
      } else {
        if (_ap.isAnswer(msg.getResMsg("seqNo"), null, sysId)) upd = "0";
      }
    }
    msg.setResMsg(MSG_UP, upd);
    msg = setGroupInf(msg);
    msg = setQuestion(msg);
    return super.editItems(msg);
  }
  private CommonMessage setGroupInf(CommonMessage msg) throws Exception {
    msg.setResMsg(MSG_PAS, "0");
    String uid = getUserID();
    String au = msg.getResMsg("allFlg");
    if ("1".equals(au)) {
      msg.setResMsg(MSG_GNM, "S");
      if (DateUtil.getDate().compareTo(msg.getResMsg("dayTo")) <= 0) {
        msg.setResMsg(MSG_PAS, "1");
      }
      return msg;
    }

    List<String[]> gdts = _rp.getGroups(HATSUBAN2_KBN.ENRUETE, msg.getResMsg("seqNo"), sysId, uid);
    StringBuilder idsb = new StringBuilder();
    StringBuilder nmsb = new StringBuilder();
    for (String[] gpdt : gdts) {
      idsb.append(gpdt[0]);
      idsb.append(",");
      nmsb.append(gpdt[1]);
      nmsb.append(",");
    }
    if (idsb.length() > 0) {
      idsb.setLength(idsb.length() - 1);
      nmsb.setLength(nmsb.length() - 1);
    }
    msg.setResMsg(CommunicationDetail.MSG_GID, idsb.toString());
    msg.setResMsg(MSG_GNM, nmsb.toString());
    if (DateUtil.getDate().compareTo(msg.getResMsg("dayTo")) <= 0) {
      if (_rp.checkIngroup(getUserID(), idsb.toString())) {
        msg.setResMsg(MSG_PAS, "1");
      }
    }

    return msg;
  }
  private CommonMessage setQuestion(CommonMessage msg) throws Exception {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, msg.getResMsg("seqNo"));
    asd.setRetrieveValue(AnswerSearchDto.USER_ID, getUserID());
    asd.setSysId(sysId);
    asd = _ap.find(asd);
    List<String> chk = new ArrayList<String>();
    for (List<String> keys : asd) {
      chk.add(keys.get(1));
    }
    boolean set = true;
    for (String[] qdts : _svQue) {
      Map<String, String> qdt = new HashMap<String, String>();
      qdt.put("qcontens", qdts[0]);
      qdt.put("qSeq", qdts[1]);
      if (chk.contains(qdts[1])) {
        qdt.put("qanswer", " CHECKED");
        if (set && "1".equals(msg.getResMsg("saysFlg"))) {
          set = false;
          AnswerDto ad = new AnswerDto();
          ad.setItemValue(AnswerDto.ENQUETE_SEQNO, msg.getResMsg("seqNo"));
          ad.setItemValue(AnswerDto.Q_SEQNO, qdts[1]);
          ad.setItemValue(AnswerDto.USER_ID, getUserID());
          ad.setRequestItem(AnswerDto.SAYS);
          ad.setSysId(sysId);
          ad = _ap.getDetail(ad);
          msg.setResMsg(MSG_SAY, ad.getItemValue(AnswerDto.SAYS));
        }
      } else {
        qdt.put("qanswer", "");
      }
      msg.addResList(qdt);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#setKeys(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String ps = msg.getReqStr("pos");
    String seq = msg.getReqStr("seqNo");
    if (ps.length() > 0) return false;
    dii.setItemValue(EnqueteDto.SEQNO, seq);
    return true;
  }

}
