package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.NoticeDto;
import com.hamaf.hikyakucms.sample.sns.process.NoticeProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.NoticeMap;

/**
 * <p>^CgFNoticeDel is .</p>
 * <p>Fm点̍폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/30</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NoticeDel extends StandardUpdateProcess {

  private NoticeProcess _np = null;
  /**
   * Creates a new <code>NoticeDel.java</code> instance.
   * <br>Default Constructor
   */
  public NoticeDel() {
    _jim = new NoticeMap();
    _np = new NoticeProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new NoticeDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String typ = msg.getReqStr("type");
    if ("all".equals(typ.toLowerCase())) {
      String fdate = msg.getReqStr("fdate");
      if (fdate == null || fdate.length() == 0) fdate = DateUtil.getDate();
      _np.delAll(getUserID(), fdate, sysId);
    } else {
      dii.setItemValue(NoticeDto.USER_ID, getUserID());
      _np.del((NoticeDto)dii);
    }
    return msg;
  }

}
