﻿package com.hamaf.hikyakucms.sample.wiki.access;

import java.sql.SQLException;

import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDiffDto;

/**
 * <p>タイトル：WikiDiffAccess is .</p>
 * <p>説明：M_WIKIDIFF(Wiki差分管理)アクセス用クラス</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/06</p>
 * @author @USR
 * @version 1.0
 */
public class WikiDiffAccess extends DefaultTableAccess {

  private final String TBLNM = "M_WIKIDIFF";
  private final String PARM = "hsmpl";

  /**
   *  Creates a new <code>WikiDiffAccess.java</code> instance.
   * <br>Default Constructor
   */
  public WikiDiffAccess() {
    tableName = TBLNM;
    connectionParameter = PARM;
//    super.setDebug();
  }

  @Override
  public void regist(DetailItemsInterface dii) throws SQLException {
    dii.setItemValue(WikiDiffDto.CHANGE_DATE, DateUtil.getDate());
    dii.setItemValue(WikiDiffDto.CHANGE_TIME, DateUtil.getTime());
    dii.setItemValue(WikiDiffDto.AUTHOR, dii.getCommFld(COMMFLD.UUSR));
    super.regist(dii);
  }

}
