package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDocDto;
import com.hamaf.hikyakucms.sample.wiki.process.WikiDocProcess;
import com.hamaf.hikyakucms.sample.wiki.ui.mapping.WikiDocMap;

/**
 * <p>^CgFWikiDetail is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/12</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiDetail extends WikiDetailProcess {

  public static final String DOCNO = "wno";
  public static final String CHAPTER = "cno";
  public static final String SECTION = "sno";
  public static final String CREATE_NAME = "cname";
  public static final String LAST_NAME = "lname";
  public static final String DIFFEXIST = "difchk";
  public static final String CONTENTS = "contents";
  public static final String HTML = "html";

  private WikiDocProcess _wdp = null;

  /**
   * Creates a new <code>WikiDetail</code> instance.
   * <br>Default Constructor
   */
  public WikiDetail() {
    _wdp = new WikiDocProcess();
    _jim = new WikiDocMap();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new WikiDocDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(
      DetailItemsInterface dii, CommonMessage msg) throws Exception {
    WikiDocDto wdd = (WikiDocDto)dii;
    wdd.setChapter(msg.getReqStr(CHAPTER));
    wdd.setSection(msg.getReqStr(SECTION));
    return _wdp.getDetailAll(wdd);
  }

  @Override
  protected CommonMessage editItems(CommonMessage msg,
      DetailItemsInterface dii) throws Exception {
    WikiDocDto wdd = (WikiDocDto)dii;
    boolean dif = _wdp.isExistDiff(wdd.getItemValue(WikiDocDto.WIKI_NO), sysId);
    if (dif) {
      msg.setResMsg(DIFFEXIST, "1");
    } else {
      msg.setResMsg(DIFFEXIST, "0");
    }
    boolean prev = false;
    if ("1".equals(msg.getReqStr("preview"))) prev = true;
    msg.setResMsg(HTML, wdd.getWikiDoc().getHtml(prev, dif));
    msg.setResMsg(CONTENTS, wdd.getWikiDoc().getOriginal());
    return msg;
  }

  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String wno = msg.getReqStr("wno");
    if (wno.length() > 0) {
      dii.setItemValue(WikiDocDto.WIKI_NO, wno);
      return true;
    }
    return false;
  }

}
