package com.hamaf.hikyakucms.sample.wiki.ui;

import java.util.List;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.JspItemsMapping;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFDetailProcess is .</p>
 * <p>FStandardDetailProcessWiki悤ɕύXNX</p>
 * <br>ύXӏ
 * <ol>
 *   <li>"callControl"\bhCommonMessagenB
 *   <li>"editItems"\bhDetaiItemInterfacenB
 * </ol>
 *
 * <p>쌠: Copyright (c) 2012/09/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public abstract class WikiDetailProcess extends ProcessBase {

  protected JspItemsMapping _jim= null;

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public final CommonMessage exec(CommonMessage msg) throws Exception {
    if (_jim == null) {
      _jim = setJspMapping();
      if (_jim == null) {
        _jim = new JspItemsMapping();
        setItems();
      }
    }

    DetailItemsInterface dii = newDataObj();
    if (!setKeys(dii, msg)) {
      setKey4KeyList(msg, dii);
    }
    setRequest2DTO(dii);
    dii.setSysId(sysId);
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      dii.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    dii = callControl(dii, msg);

    msg = setMessageFromDTO(msg, dii);
    return editItems(msg, dii);
  }

  protected abstract DetailItemsInterface newDataObj();

  private void setKey4KeyList(CommonMessage msg, DetailItemsInterface dii) {
    if (super.saveObj == null) {
      super.log.fine("primaryKey not set : saveObj is null");
      return;
    }
    String spos = msg.getReq("pos");
    if (spos == null || spos.length() == 0) {
      super.log.fine("primaryKey not set : 'pos' not in request");
      return;
    }

    KeyList kyl = (KeyList)super.saveObj;
    int ps = Integer.parseInt(spos);
    setPrimaryValue(dii, kyl.getKey(ps), kyl.getKeyFields());
  }

  private void setRequest2DTO(DetailItemsInterface dii) {
    for (String fld : _jim) {
      dii.setRequestItem(_jim.getDtoNo(fld));
    }
  }

  private CommonMessage setMessageFromDTO(CommonMessage msg, DetailItemsInterface dii) {
    for (String fld : _jim) {
      msg.setResMsg(fld, dii.getItemValue(_jim.getDtoNo(fld)));
    }

    for (COMMFLD fld : COMMFLD.values()) {
      msg.setResMsg(fld.getVal(), dii.getCommFld(fld));
    }

    return msg;
  }

  protected final void addItem(String jspnm, int pos) {
    _jim.addItem(jspnm, pos);
  }

  protected JspItemsMapping setJspMapping() {
    return null;
  }

  protected void setItems() { }

  protected abstract DetailItemsInterface callControl(DetailItemsInterface dii,
      CommonMessage msg)
     throws Exception;

  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    return false;
  }

  protected void setPrimaryValue(DetailItemsInterface dii, List<String> key, List<String> keyFld) {
    for (int i = 0; i < key.size(); i++) {
      dii.setFldValue(keyFld.get(i), key.get(i));
    }
  }

  protected CommonMessage editItems(CommonMessage msg, DetailItemsInterface dii) throws Exception {
    return msg;
  }
}
