package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDiffDto;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDiffSearchDto;
import com.hamaf.hikyakucms.sample.wiki.process.WikiDocProcess;
import com.hamaf.hikyakucms.sample.wiki.ui.mapping.WikiDiffMap;

/**
 * <p>^CgFWikiDiff is .</p>
 * <p>FWikiύX̕\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/13</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiDiff extends StandardListProcess {

  private WikiDocProcess _wdp = null;

  /**
   * Creates a new <code>WikiDiff</code> instance.
   * <br>Default Constructor
   */
  public WikiDiff() {
    _wdp = new WikiDocProcess();
    _jim = new WikiDiffMap();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _wdp.getDiff((WikiDiffDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _wdp.findDiff((WikiDiffSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new WikiDiffDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    WikiDiffSearchDto wdsd = new WikiDiffSearchDto();
    wdsd.setRetrieveValue(WikiDiffSearchDto.WIKI_NO, klst.getRetrieve("wno"));
    wdsd.setOrderItem(WikiDiffSearchDto.DIFF_NO, -1);
    return wdsd;
  }

}
