package com.hamaf.hikyakucms.sample.wiki.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Reader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>^CgFWikiDiff is .</p>
 * <p>FWiki̕ύXe𐶐</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiDiff {

  /**
   * Creates a new <code>WikiDiff</code> instance.
   *
   */
  public WikiDiff() {
  }

  public static final List<String[]> diff(String sndt, String sold) {
    StringReader nsrd = new StringReader(sndt);
    StringReader osrd = new StringReader(sold);
    List<String[]> ret = null;
    try {
      ret = diff(nsrd, osrd);
    } catch (Exception xe) {
      xe.printStackTrace();
      ret = new ArrayList<String[]>();
    }
    nsrd.close();
    osrd.close();
    return ret;
  }
  public static final String diffStr(String sndt, String sold) {
    List<String[]> df = diff(sndt, sold);
    StringBuilder sb = new StringBuilder();
    for (String[] dt : df) {
      sb.append(dt[0]);
      sb.append("\t");
      sb.append(dt[1]);
      sb.append("\n");
    }
    return sb.toString();
  }

  public static final List<String[]> diff(Reader rndt, Reader rold) throws Exception{
    BufferedReader brd = new BufferedReader(rndt);
    List<String> ndt = new ArrayList<String>();
    String buf = brd.readLine();
    while (buf != null) {
      ndt.add(buf);
      buf = brd.readLine();
    }
    brd = new BufferedReader(rold);
    List<String> old = new ArrayList<String>();
    buf = brd.readLine();
    while (buf != null) {
      old.add(buf);
      buf = brd.readLine();
    }
    return diff(ndt, old);
  }
  public static final List<String[]> diff(List<String> ndt, List<String> old) {
    List<String[]> ret = new ArrayList<String[]>();
    String[] sndt = (String[])ndt.toArray(new String[] {});
    String[] sold = (String[])old.toArray(new String[] {});
    Diff<String> dff = new Diff<String>(sold, sndt);
    int svp = 0;
    List<Difference> dfs = dff.diff();
    for (Difference df : dfs) {
      int pos;
      if (df.getAddedEnd() != Difference.NONE) {
        pos = df.getAddedEnd() + 1;
      } else {
        pos = df.getAddedStart();
      }
      while (svp < pos - 1) {
        ret.add(new String[]{"n", ndt.get(svp)});
        svp++;
      }
      if (df.getDeletedEnd() != Difference.NONE) {
        for (int i = df.getDeletedStart(); i <= df.getDeletedEnd() ; i++) {
          ret.add(new String[]{"d", old.get(i)});
        }
      }
      if (df.getAddedEnd() != Difference.NONE) {
        for (int i = df.getAddedStart(); i <= df.getAddedEnd() ; i++) {
          ret.add(new String[]{"a", ndt.get(i)});
          svp++;
        }
      }
    }
    return ret;
  }


  /**
   * Describe <code>main</code> method : .
   *
   * @param args a <code>String[]</code> :
   */
  public static void main(final String[] args) {
    try {
      FileReader nfr = new FileReader("DiffTestNew.txt");
      FileReader ofr = new FileReader("DiffTestold.txt");
      List<String[]> result = WikiDiff.diff(nfr, ofr);
      nfr.close();
      ofr.close();
      FileWriter fw = new FileWriter("DiffTestResult.txt");
      for (String[] dt : result) {
        fw.write(dt[0]);
        fw.write(",");
        fw.write(dt[1]);
        fw.write("\n");
      }
      fw.close();
    } catch (Exception xe) {
      xe.printStackTrace();
    }
  }

}
