package com.hamaf.business.generaldoc.ui;

import java.util.Map;

import com.hamaf.business.generaldoc.dto.GeneralDocDto;
import com.hamaf.business.generaldoc.dto.GeneralDocSearchDto;
import com.hamaf.business.generaldoc.process.GeneralDocProcess;
import com.hamaf.business.generaldoc.ui.mapping.GeneralDocMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFGeneralList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GeneralList extends StandardListProcess {

  private GeneralDocProcess _gdp = null;
  /**
   * Creates a new <code>GeneralList</code> instance.
   * <br>Default Constructor
   */
  public GeneralList() {
    _jim = new GeneralDocMapping();
    _gdp = new GeneralDocProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gdp.getDetaail((GeneralDocDto)dii);
  }

  private final String MSG_UPDATE = "updsp";
  private final String MSG_APPLOVAL = "apdsp";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> map) throws Exception {
    if ("S".equals(dii.getItemValue(GeneralDocDto.APPROVAL_RESULT).toUpperCase())) {
      map.put(MSG_UPDATE, "XV");
      map.put(MSG_APPLOVAL, "F˗");
    } else {
      map.put(MSG_UPDATE, "");
      map.put(MSG_APPLOVAL, "󋵎Q");
    }
    return map;
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (super.delCheck(dii)) {
      String[] ddt = {"contents", MSG_DEL};
      return ddt;
    }
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _gdp.find((GeneralDocSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GeneralDocDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    GeneralDocSearchDto gdsd = new GeneralDocSearchDto();
    gdsd.setRetrieveValue(GeneralDocSearchDto.ADD_USER, getUserID());
    gdsd.setRetrieveValue(GeneralDocSearchDto.DOCUMENT_ID, klst.getRetrieve("docId"));
    gdsd.setRetrieveValue(GeneralDocSearchDto.APPROVAL_RESULT,  klst.getRetrieve("sel").trim());
    String ttl = klst.getRetrieve("sttl");
    if (ttl != null && ttl.length() > 0) {
      gdsd.setRetrieveValue(GeneralDocSearchDto.TITLE, "%" + ttl + "%");
      gdsd.setCondition(GeneralDocSearchDto.TITLE, "LIKE");
    }
    gdsd.setOrderItem(GeneralDocSearchDto.ADD_DATE, -1);
    gdsd.setOrderItem(GeneralDocSearchDto.SEQNO, 2);
    return gdsd;
  }

}
