package com.hamaf.business.generaldoc.ui;

import com.hamaf.business.generaldoc.dto.GeneralDocDto;
import com.hamaf.business.generaldoc.process.GeneralDocProcess;
import com.hamaf.business.generaldoc.ui.mapping.GeneralDocMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFGeneralModify is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GeneralModify extends StandardCheckAndUpdate {

  private GeneralDocProcess _gdp = null;
  
  /**
   * Creates a new <code>GeneralModify</code> instance.
   * <br>Default Constructor
   */
  public GeneralModify() {
    _cfld = "GeneralDocAdd";
    _jim = new GeneralDocMapping();
    _gdp = new GeneralDocProcess();
  }

  private final String UPDATE_KBN = "upkbn";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String kbn = msg.getReqStr(UPDATE_KBN).toUpperCase();
    if (kbn.startsWith("A")) {
      String no = _gdp.addNew((GeneralDocDto)dii);
      msg.setResMsg("seqNo", no);
    } else if (kbn.startsWith("U")) {
      _gdp.update((GeneralDocDto)dii);
    } else if (kbn.startsWith("D")) {
      _gdp.delete((GeneralDocDto)dii);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GeneralDocDto();
  }

}
