package com.hamaf.business.workflow.process;

import java.util.ArrayList;
import java.util.List;

import com.hamaf.business.workflow.access.AgentAccess;
import com.hamaf.business.workflow.dto.AgentDto;
import com.hamaf.business.workflow.dto.AgentSearchDto;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;

/**
 * <p>^CgFAgentProcess is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/06</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AgentProcess {
  
  private AgentAccess _aa = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>AgentProcess</code> instance.
   * <br>Default Constructor
   */
  public AgentProcess() {
    _aa = new AgentAccess();
    _scu = new SecurityCheckUtils();
  }
  
  public AgentSearchDto find(AgentSearchDto asd) throws Exception {
    return (AgentSearchDto)_aa.find(asd);
  }
  
  public AgentDto getDetail(AgentDto ad) throws Exception {
    ad = (AgentDto)_aa.findByPrimaryKey(ad);
    return ad;
  }
  
  public List<String> findUsers(String agent, String sysid) throws Exception {
    AgentSearchDto asd = new AgentSearchDto();
    asd.setSysId(sysid);
    asd.setRetrieveValue(AgentSearchDto.AGENT, agent);
    asd.setOrderItem(AgentSearchDto.AUTHORIZER, 1);
    asd = (AgentSearchDto)_aa.find(asd);
    
    List<String> ret = new ArrayList<String>();
    for (List<String> keys : asd.getKeys()) {
      ret.add(keys.get(0));
    }
    return ret;
  }
  
  public List<String> findAgents(String user, String sysid) throws Exception {
    AgentSearchDto asd = new AgentSearchDto();
    asd.setSysId(sysid);
    asd.setRetrieveValue(AgentSearchDto.AUTHORIZER, user);
    asd.setOrderItem(AgentSearchDto.AGENT, 1);
    asd = (AgentSearchDto)_aa.find(asd);
    
    List<String> ret = new ArrayList<String>();
    for (List<String> keys : asd.getKeys()) {
      ret.add(keys.get(1));
    }
    return ret;
  }

  public void addNew(AgentDto ad) throws Exception {
    UserDto ud = _scu.getUserInf(ad.getItemValue(AgentDto.AUTHORIZER), ad.getCommFld(COMMFLD.UUSR));
    ad.setItemValue(AgentDto.AUTHORIZER_NAME, ud.getItemValue(UserDto.NAME));
    ud = _scu.getUserInf(ad.getItemValue(AgentDto.AGENT), ad.getCommFld(COMMFLD.UUSR));
    ad.setItemValue(AgentDto.AGENT_NAME, ud.getItemValue(UserDto.NAME));
    _aa.regist(ad);
  }
  
  public void delete(AgentDto ad) throws Exception {
    ad = getDetail(ad);
    _aa.delete(ad);
  }
}
