package com.hamaf.business.workflow.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.hamaf.business.workflow.WorkFlowUpdate;
import com.hamaf.business.workflow.access.BaseAuthorizerAccess;
import com.hamaf.business.workflow.access.BaseLevelAccess;
import com.hamaf.business.workflow.access.BaseFlowAccess.USER_KUBUN;
import com.hamaf.business.workflow.access.BaseLevelAccess.AUTHORIZER_KUBUN;
import com.hamaf.business.workflow.access.BaseLevelAccess.CHECK_TYPE;
import com.hamaf.business.workflow.access.DfAuthorizerAccess;
import com.hamaf.business.workflow.access.DfAuthorizerAccess.AUTHORIZER_STATUS;
import com.hamaf.business.workflow.access.DfAuthorizerAccess.NOTIFICATION;
import com.hamaf.business.workflow.access.DfLevelAccess;
import com.hamaf.business.workflow.access.DfLevelAccess.CHANGE_KUBUN;
import com.hamaf.business.workflow.access.DfLevelAccess.DFLEVEL_STATUS;
import com.hamaf.business.workflow.access.DfLevelAccess.LAST_FLAG;
import com.hamaf.business.workflow.access.DocumentFlowAccess.FLOW_RESULT;
import com.hamaf.business.workflow.access.DocumentFlowAccess;
import com.hamaf.business.workflow.access.DocumentInfAccess;
import com.hamaf.business.workflow.access.HatsubanAccess;
import com.hamaf.business.workflow.access.SqlExec;
import com.hamaf.business.workflow.access.HatsubanAccess.HATSUBAN_KBN;
import com.hamaf.business.workflow.access.VDfAuthorizerAccess;
import com.hamaf.business.workflow.access.VDocumentFlowAccess;
import com.hamaf.business.workflow.dto.BaseAuthorizerSearchDto;
import com.hamaf.business.workflow.dto.BaseLevelDto;
import com.hamaf.business.workflow.dto.DfAuthorizerDto;
import com.hamaf.business.workflow.dto.DfAuthorizerSearchDto;
import com.hamaf.business.workflow.dto.DfFlowAuthorizerMapping;
import com.hamaf.business.workflow.dto.DfFlowLevelMapping;
import com.hamaf.business.workflow.dto.DfLevelAuthorizerMapping;
import com.hamaf.business.workflow.dto.DfLevelDto;
import com.hamaf.business.workflow.dto.DocFlowInfMapping;
import com.hamaf.business.workflow.dto.DocumentFlowDto;
import com.hamaf.business.workflow.dto.DocumentInfDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.dto.VDocumentFlowDto;
import com.hamaf.business.workflow.dto.VDocumentFlowSearchDto;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyaku.dataobject.utils.CopyDtoUtil;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFDocumentFlowProcess is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/06</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DocumentFlowProcess {
  
  private DocumentFlowAccess _dfa = null;
  private DfLevelAccess _dla = null;
  private DfAuthorizerAccess _daa = null;
  private HatsubanAccess _ha = null;
  private BaseLevelAccess _bla = null;
  private BaseAuthorizerAccess _baa = null;
  private SecurityCheckUtils _scu = null;
  private DocumentInfAccess _dia = null;
  private VDocumentFlowAccess _vdfa = null;
  private VDfAuthorizerAccess _vdaa = null;
  private SqlExec _se = null;

  /**
   * Creates a new <code>DocumentFlowProcess</code> instance.
   * <br>Default Constructor
   */
  public DocumentFlowProcess() {
    _dfa = new DocumentFlowAccess();
    _dla = new DfLevelAccess();
    _daa = new DfAuthorizerAccess();
    _ha = new HatsubanAccess();
    _bla = new BaseLevelAccess();
    _baa = new BaseAuthorizerAccess();
    _scu = new SecurityCheckUtils();
    _dia = new DocumentInfAccess();
    _vdfa = new VDocumentFlowAccess();
    _vdaa = new VDfAuthorizerAccess();
    _se = new SqlExec(); 
  }

  public VDfAuthorizerSearchDto findAuthorize(VDfAuthorizerSearchDto vdasd) throws Exception {
    return (VDfAuthorizerSearchDto)_vdaa.find(vdasd);
  }
  
  public VDfAuthorizerDto getAuthorizerDetail(VDfAuthorizerDto vdad) throws Exception {
    vdad = (VDfAuthorizerDto)_vdaa.findByPrimaryKey(vdad);
    String uid = vdad.getItemValue(VDfAuthorizerDto.AGENT);
    if (uid == null || uid.length() == 0) uid = vdad.getItemValue(VDfAuthorizerDto.AUTHORIZER);
    UserDto ud = _scu.getUserInf(uid, vdad.getCommFld(COMMFLD.UUSR));
    vdad.setName(ud.getItemValue(UserDto.NAME));
    return vdad;
  }
  
  public VDocumentFlowSearchDto findDocFlow(VDocumentFlowSearchDto vdfsd) throws Exception {
    return (VDocumentFlowSearchDto)_vdfa.find(vdfsd);
  }
  
  public VDocumentFlowDto getDocInf(VDocumentFlowDto vdfd) throws Exception {
    return (VDocumentFlowDto)_vdfa.findByPrimaryKey(vdfd);
  }
  
  public void registVerified(DfAuthorizerDto dad) throws Exception {
    dad.setAllRequest();
    dad = (DfAuthorizerDto)_daa.findByPrimaryKey(dad);
    
    String ntf = dad.getItemValue(DfAuthorizerDto.NOTIFICATION);
    if (NOTIFICATION.NOTIFICATION_IN.getVal().equals(ntf)) {
      dad.setItemValue(DfAuthorizerDto.NOTIFICATION, NOTIFICATION.VERIFIED.getVal());
    } else {
      dad.setItemValue(DfAuthorizerDto.DATE_APPROVAL, DateUtil.getDate());
      dad.setItemValue(DfAuthorizerDto.TIME_APPROVAL, DateUtil.getTime());
      dad.setItemValue(DfAuthorizerDto.STATUS, AUTHORIZER_STATUS.APPROVED.getVal());
    }
    _daa.update(dad);
  }
  
  /**
   * Describe <code>addNew</code> method : .
   * <br>F˗̓o^B
   * <ul>
   *   <li>t[ւ̐VKǉ
   *   <li>ւ̓̕t[ԍ̓o^
   *   <li>Fҏ̓o^
   *   <ul>
   *     <li>ύX̏Fҏ̓o^
   *     <li>xP̊{Fҏ҂̓o^
   *     <li>xP̒ʒmҏ̓o^
   *   </ul>
   * </ul>
   *
   * @param dfd a <code>DocumentFlowDto</code>
   * @param group a <code>String</code> : FҕύX̏FO[v
   * @param users a <code>List&lt;String&gt;</code> : FҕύX̃[U[ꗗ
   * @param chkType a <code>String</code> : FҕύX̏F^Cv
   * @return a <code>String</code> : Ԃt[ԍ
   * @throws Exception
   */
  public String addNew(DocumentFlowDto dfd,
      String group, List<String> users, String chkType) throws Exception {
    
    String no = _ha.getNextNo(HATSUBAN_KBN.DOCUMENT, null, dfd.getSysId());
    dfd.setItemValue(DocumentFlowDto.DOCUMENT_NO, no);
    dfd.setItemValue(DocumentFlowDto.STATUS, "0");
    String uid = dfd.getCommFld(COMMFLD.UUSR);
    dfd.setItemValue(DocumentFlowDto.APPLICANT, uid);
    UserDto ud = _scu.getUserInf(uid, uid);
    dfd.setItemValue(DocumentFlowDto.APPLICANT_NAME, ud.getItemValue(UserDto.NAME));    
    dfd.setItemValue(DocumentFlowDto.APP_DATE, DateUtil.getDate());
    dfd.setItemValue(DocumentFlowDto.APP_TIME, DateUtil.getTime());
    _dfa.regist(dfd);
    
    updateOriginal(dfd, no);
    
    setNextLevel(dfd, group, users, chkType);
    return no;
  }
  
  /**
   * Describe <code>cansellationRequest</code> method : .
   * <br>F˗̎B
   * <br>F҂ȂiXe[^X'0'jꍇ̂ݎ\
   * <br>ւ̓̕t[ԍ̍폜
   * <br>Y̕ԍ̃f[^ׂč폜B
   * <br>t[͘_폜AȊO͕폜B
   *
   * @param dfd
   * @throws Exception
   */
  public void cansellationRequest(DocumentFlowDto dfd) throws Exception {
    dfd = (DocumentFlowDto)_dfa.findByPrimaryKey(dfd);
    updateOriginal(dfd, "");

    dfd.setCommFld(COMMFLD.DEL, USE_FLG.DEL.getVal());
    _dfa.update(dfd);
    deleteLevel(dfd);
  }
  
  /**
   * Describe <code>approval</code> method : .
   * <br>FBFҏyѕt[At[xXVB
   * <br>F̏ꍇőSFKvŁAŌłȂꍇ͈ȍ~̏ȂB
   * <br>FōŌ܂͉ꂩl݂̂̏ꍇ
   * <ul>
   *   <li>Ō̃xŕύXiǉj̏Fҏ񂪂Ȃꍇ
   *     <ol>
   *       <li>o^҂ʒm҂Ƃēo^B
   *       <li>{F̒ʒmҏo^
   *       <li>t[Fς݂ɐݒ肷
   *     </ol>
   *   <li>ŏIxłȂŌ̃xŕύXiǉj̏Fҏ񂪂ꍇ
   *     <ol>
   *       <li>ŏIx̏ꍇAt[MaxLevelJEgAbv
   *       <li>̃x̏Fҏo^
   *       <li>̃x̒ʒmҏo^
   *     </ol>
   *   <li>ꂩl݂̂̏ꍇ
   *     <ol>
   *       <li>mF̏F҂ɑ΂āAFsvݒ肷
   *     </ol>
   * </ul>
   * 񏳔F̏ꍇ
   * <ul>
   *   <li>mF̏F҂ɑ΂āAFsvݒ肷
   *   <li>˗ҁAFώ҂ɑ΂Ēʒmݒ肷
   *   <li>t[pɐݒ肷
   * </ul>
   *
   * @param dad a <code>DfAuthorizerDto</code>
   * @param group a <code>String</code> : FҕύX̏FO[v
   * @param users a <code>List&lt;String&gt;</code> : FҕύX̃[U[ꗗ
   * @param chkType a <code>String</code> : FҕύX̏F^Cv
   * @throws Exception
   */
  public void approval(DfAuthorizerDto dad,
      String group, List<String> users, String chkType) throws Exception {
    dad.setItemValue(DfAuthorizerDto.DATE_APPROVAL, DateUtil.getDate());
    dad.setItemValue(DfAuthorizerDto.TIME_APPROVAL, DateUtil.getTime());
    _daa.update(dad);
    
    DocumentFlowDto dfd = getDocFlow(dad);
    if (AUTHORIZER_STATUS.UNAPPROVED.getVal().equals(dad.getItemValue(DfAuthorizerDto.STATUS))) {
      unapproved(dad, dfd);
      setOriginalResult(dad, FLOW_RESULT.UNAPPROVED);
      return;
    }
    
    DfLevelDto dld = getLevel(dad);
    String cnt = addOne(dld.getItemValue(DfLevelDto.APPROVED_COUNT));
    dld.setItemValue(DfLevelDto.APPROVED_COUNT, cnt);
    if (CHECK_TYPE.ALL.getVal().equals(dld.getItemValue(DfLevelDto.CHECK_TYPE))) {
      if (cnt.compareTo(dld.getItemValue(DfLevelDto.USER_COUNT)) < 0) {
        _dla.update(dld);
        return;
      }
    } else {
      setPass(dad, true);
    }
    
    dld.setItemValue(DfLevelDto.STATUS, DFLEVEL_STATUS.APPROVED.getVal());
    _dla.update(dld);
    dfd.setItemValue(DocumentFlowDto.STATUS, dld.getItemValue(DfLevelDto.LEVEL));
    if (LAST_FLAG.LAST.getVal().equals(dld.getItemValue(DfLevelDto.LAST_FLAG))) {
      if (chkType == null || chkType.length() == 0) {
        dfd.setItemValue(DocumentFlowDto.RESULT, FLOW_RESULT.APPROVED.getVal());
        _dfa.update(dfd);
        addApplicant(dad, dfd);
        copyAuthorizer(dfd, AUTHORIZER_KUBUN.NOTIFICATION);
        setOriginalResult(dad, FLOW_RESULT.APPROVED);
        return;
      } else {
        String max = addOne(dfd.getItemValue(DocumentFlowDto.MAX_LEVEL));
        dfd.setItemValue(DocumentFlowDto.MAX_LEVEL, max);
      }
    }
    _dfa.update(dfd);
    
    setNextLevel(dfd, group, users, chkType);
  }
  
  /**
   * Describe <code>isLastAuthorizer</code> method : .
   * <br>F҂ŏIF҂`FbNB
   *
   * @param dad a <code>VDfAuthorizerDto</code>
   * @return ŏIF҂̏ꍇ true
   * @throws Exception
   */
  public boolean isLastAuthorizer(VDfAuthorizerDto vdad) throws Exception {
    String kbn = vdad.getItemValue(VDfAuthorizerDto.AUTHORIZER_KUBUN);
    if (!kbn.equals(AUTHORIZER_KUBUN.AUTHORIZE.getVal())) return false;
    
    DfLevelDto dld = new DfLevelDto();
    dld.setSysId(vdad.getSysId());
    dld.setItemValue(DfLevelDto.DOCUMENT_NO, vdad.getItemValue(VDfAuthorizerDto.DOCUMENT_NO));
    dld.setItemValue(DfLevelDto.LEVEL, vdad.getItemValue(VDfAuthorizerDto.LEVEL));
    dld.setAllRequest();
    dld = (DfLevelDto)_dla.findByPrimaryKey(dld);
    String cnt = addOne(dld.getItemValue(DfLevelDto.APPROVED_COUNT));
    if (CHECK_TYPE.ALL.getVal().equals(dld.getItemValue(DfLevelDto.CHECK_TYPE))) {
      if (cnt.compareTo(dld.getItemValue(DfLevelDto.USER_COUNT)) < 0) {
        return false;
      }
    }
    return true;
  }
  
  private DfLevelDto getLevel(DfAuthorizerDto dad) throws Exception {
    DfLevelDto dld = (DfLevelDto)CopyDtoUtil.newDto(new DfLevelAuthorizerMapping(), dad);
    dld.setAllRequest();
    return (DfLevelDto)_dla.findByPrimaryKey(dld);
  }
  private DocumentFlowDto getDocFlow(DfAuthorizerDto dad) throws Exception {
    DocumentFlowDto dfd = (DocumentFlowDto)CopyDtoUtil.newDto(new DfFlowAuthorizerMapping(), dad);
    dfd.setAllRequest();
    return (DocumentFlowDto)_dfa.findByPrimaryKey(dfd);
  }
  
  private void deleteLevel(DocumentFlowDto dfd) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(dfd.getSysId());
    Map<String, Object> prm = new HashMap<String, Object>();
    prm.put("documentNo", dfd.getItemValue(DocumentFlowDto.DOCUMENT_NO));
    pi.addParam(prm);
    _se.delDocLevel(pi);
    _se.delDocAuthorizer(pi);
  }

  /**
   * Describe <code>unapproved</code> method : .
   * <br>񏳔F̏B
   *
   * @param dad
   * @param dfd
   * @throws Exception
   */
  private void unapproved(DfAuthorizerDto dad, DocumentFlowDto dfd) throws Exception {
    setPass(dad, false);
    
    DfAuthorizerSearchDto dasd = new DfAuthorizerSearchDto();
    dasd.setSysId(dad.getSysId());
    dasd.setRetrieveValue(DfAuthorizerSearchDto.DOCUMENT_NO, dad.getItemValue(DfAuthorizerDto.DOCUMENT_NO));
    StringBuilder sb = new StringBuilder();
    sb.append("'");
    sb.append(AUTHORIZER_STATUS.APPROVED.getVal());
    sb.append("','");
    sb.append(AUTHORIZER_STATUS.CHECKING.getVal());
    sb.append("'");
    dasd.setRetrieveValue(DfAuthorizerSearchDto.STATUS, sb.toString());
    dasd.setCondition(DfAuthorizerSearchDto.STATUS, "in");
    dasd = (DfAuthorizerSearchDto)_daa.find(dasd);
    for (List<String> keys : dasd.getKeys()) {
      DfAuthorizerDto ndad = new DfAuthorizerDto();
      ndad.setSysId(dad.getSysId());
      ndad.setItemValue(DfAuthorizerDto.DOCUMENT_NO, keys.get(0));
      ndad.setItemValue(DfAuthorizerDto.AUTHORIZER, keys.get(1));
      ndad.setRequestItem(DfAuthorizerDto.STATUS);
      ndad = (DfAuthorizerDto)_daa.findByPrimaryKey(ndad);
      
      String sts = ndad.getItemValue(DfAuthorizerDto.STATUS);
      if (sts.equals(AUTHORIZER_STATUS.APPROVED.getVal())) {
        ndad.setItemValue(DfAuthorizerDto.NOTIFICATION, NOTIFICATION.NOTIFICATION_IN.getVal());
        ndad.setItemValue(DfAuthorizerDto.NOTIFICATION_DATE, DateUtil.getDate());
      } else {
        ndad.setItemValue(DfAuthorizerDto.STATUS, AUTHORIZER_STATUS.UNNECESSARY.getVal());
      }
      ndad.setCommFld(COMMFLD.UPGM, this.getClass().getName());
      ndad.setCommFld(COMMFLD.UUSR, dad.getCommFld(COMMFLD.UUSR));
      _daa.update(ndad);
    }
    addApplicant(dad, dfd);
    
    dfd.setItemValue(DocumentFlowDto.RESULT, FLOW_RESULT.UNAPPROVED.getVal());
    _dfa.update(dfd);
  }
  private void setPass(DfAuthorizerDto dad, boolean notAll) throws Exception {
    DfAuthorizerSearchDto dasd = new DfAuthorizerSearchDto();
    dasd.setSysId(dad.getSysId());
    dasd.setRetrieveValue(DfAuthorizerSearchDto.DOCUMENT_NO, dad.getItemValue(DfAuthorizerDto.DOCUMENT_NO));
    dasd.setRetrieveValue(DfAuthorizerSearchDto.STATUS, AUTHORIZER_STATUS.CHECKING.getVal());
    if (notAll) 
      dasd.setRetrieveValue(DfAuthorizerSearchDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.AUTHORIZE.getVal());
    dasd = (DfAuthorizerSearchDto)_daa.find(dasd);
    for (List<String> keys : dasd.getKeys()) {
      DfAuthorizerDto ndad = new DfAuthorizerDto();
      ndad.setSysId(dad.getSysId());
      ndad.setItemValue(DfAuthorizerDto.DOCUMENT_NO, keys.get(0));
      ndad.setItemValue(DfAuthorizerDto.AUTHORIZER, keys.get(1));
      ndad = (DfAuthorizerDto)_daa.findByPrimaryKey(ndad);
      
      ndad.setItemValue(DfAuthorizerDto.STATUS, AUTHORIZER_STATUS.UNNECESSARY.getVal());
      ndad.setCommFld(COMMFLD.UPGM, this.getClass().getName());
      ndad.setCommFld(COMMFLD.UUSR, dad.getCommFld(COMMFLD.UUSR));
      _daa.update(ndad);
    }
  }
  private void addApplicant(DfAuthorizerDto dad, DocumentFlowDto dfd) throws Exception {
    DfAuthorizerDto ndad = new DfAuthorizerDto();
    ndad.setSysId(dad.getSysId());
    ndad.setItemValue(DfAuthorizerDto.DOCUMENT_NO, dad.getItemValue(DfAuthorizerDto.DOCUMENT_NO));
    ndad.setItemValue(DfAuthorizerDto.AUTHORIZER, dfd.getItemValue(DocumentFlowDto.APPLICANT));
    ndad.setItemValue(DfAuthorizerDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.PLACER.getVal());
    ndad.setItemValue(DfAuthorizerDto.NOTIFICATION, NOTIFICATION.NOTIFICATION_IN.getVal());
    ndad.setItemValue(DfAuthorizerDto.STATUS, AUTHORIZER_STATUS.UNNECESSARY.getVal());
    ndad.setItemValue(DfAuthorizerDto.LEVEL, "0");
    ndad.setItemValue(DfAuthorizerDto.DATE_REQUEST, DateUtil.getDate());
    ndad.setItemValue(DfAuthorizerDto.TIME_REQUEST, DateUtil.getTime());
    ndad.setCommFld(COMMFLD.UPGM, this.getClass().getName());
    _daa.regist(ndad);
  }
  
  private void updateOriginal(DocumentFlowDto dfd, String no) throws Exception {
    WorkFlowUpdate wfu = getOriginalCls(dfd);
    if (wfu == null) return;
    wfu.registFlowNo(dfd.getItemValue(DocumentFlowDto.ORIGINAL_KEY), no);
  }
  private WorkFlowUpdate getOriginalCls(DocumentFlowDto dfd) throws Exception {
    DocumentInfDto did = (DocumentInfDto)CopyDtoUtil.newDto(new DocFlowInfMapping(), dfd);
    did.setAllRequest();
    did = (DocumentInfDto)_dia.findByPrimaryKey(did);
    if (did.isNotFound()) throw new IllegalArgumentException("hLgȂ");
    String cls = did.getItemValue(DocumentInfDto.UPDATE_CLASS);
    if (cls == null || cls.length() == 0) return null;
    Object upc = Class.forName(cls).newInstance();
    if (!(upc instanceof WorkFlowUpdate)) throw new IllegalArgumentException("wNXWorkFlowUpdatełȂ");
    return (WorkFlowUpdate)upc;
  }
  private void setOriginalResult(DfAuthorizerDto dad, FLOW_RESULT fr) throws Exception {
    DocumentFlowDto dfd = (DocumentFlowDto)CopyDtoUtil.newDto(new DfFlowAuthorizerMapping(), dad);
    dfd.setAllRequest();
    dfd = (DocumentFlowDto)_dfa.findByPrimaryKey(dfd);
    WorkFlowUpdate wfu = getOriginalCls(dfd);
    if (wfu == null) return;
    wfu.registResult(dfd.getItemValue(DocumentFlowDto.ORIGINAL_KEY), fr.getVal());
  }
  
  private void setNextLevel(DocumentFlowDto dfd,
      String group, List<String> users, String chkType) throws Exception {
    DfLevelDto dld = (DfLevelDto)CopyDtoUtil.newDto(new DfFlowLevelMapping(), dfd);
    
    String chktyp = CHECK_TYPE.ALL.getVal();
    String lvl= addOne(dfd.getItemValue(DocumentFlowDto.STATUS));
    dld.setItemValue(DfLevelDto.LEVEL, lvl);
    if (chkType == null || chkType.length() == 0) {
      String ct = getCheckType(dfd.getItemValue(DocumentFlowDto.FLOW_NO), lvl, dfd.getSysId());
      if (ct != null) chktyp = ct;
      dld.setItemValue(DfLevelDto.CHANGE_KUBUN, CHANGE_KUBUN.CHANGED.getVal());
      dld.setItemValue(DfLevelDto.CHANGE_USER, dfd.getCommFld(COMMFLD.UUSR));
    } else {
      chktyp = chkType;
      dld.setItemValue(DfLevelDto.CHANGE_KUBUN, CHANGE_KUBUN.UNCHANGED.getVal());
    }
    dld.setItemValue(DfLevelDto.CHECK_TYPE, chktyp);
    dld.setItemValue(DfLevelDto.STATUS, DFLEVEL_STATUS.REQUEST.getVal());
    if (lvl.equals(dfd.getItemValue(DocumentFlowDto.MAX_LEVEL))) {
      dld.setItemValue(DfLevelDto.LAST_FLAG, LAST_FLAG.LAST.getVal());
    } else {
      dld.setItemValue(DfLevelDto.LAST_FLAG, LAST_FLAG.NO.getVal());
    }
    int ucnt = addAuthorizer(dfd, group, users, chkType, dfd.getCommFld(COMMFLD.UUSR));
    dld.setItemValue(DfLevelDto.USER_COUNT, String.valueOf(ucnt));
    dld.setItemValue(DfLevelDto.APPROVED_COUNT, "0");
    _dla.regist(dld);

    copyAuthorizer(dfd, AUTHORIZER_KUBUN.NOTIFICATION);
  }
  private String getCheckType(String flowNo, String level, String sysid) throws Exception {
    BaseLevelDto blb = new BaseLevelDto();
    blb.setItemValue(BaseLevelDto.FLOW_NO, flowNo);
    blb.setItemValue(BaseLevelDto.LEVEL, level);
    blb.setItemValue(BaseLevelDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.AUTHORIZE.getVal());
    blb.setSysId(sysid);
    blb.setAllRequest();
    blb = (BaseLevelDto)_bla.findByPrimaryKey(blb);
    if (blb.isNotFound()) {
      return null;
    }
    return blb.getItemValue(BaseLevelDto.CHECK_TYPE);
  }
  private String addOne(String no) throws Exception {
    int ino = Integer.parseInt(no);
    ino++;
    return String.valueOf(ino);
  }
  
  private int addAuthorizer(DocumentFlowDto dfd,
      String group, List<String> users, String chkType, String userId) throws Exception {
    if (chkType == null || chkType.length() == 0) return copyAuthorizer(dfd, AUTHORIZER_KUBUN.AUTHORIZE);
    int dtc = 0;
    List<String> usr = new ArrayList<String>();
    if (group != null && group.length() > 0) usr.addAll(_scu.getUserInGP(group));
    if (users != null) usr.addAll(users);
    
    for (String uid : usr) {
      if (addNewDfAuthorizer(dfd, uid, AUTHORIZER_KUBUN.AUTHORIZE)) dtc++;
    }
    return dtc;
  }
  private boolean addNewDfAuthorizer(DocumentFlowDto dfd, String uid, AUTHORIZER_KUBUN kbn) throws Exception {
    DfAuthorizerDto dad = (DfAuthorizerDto)CopyDtoUtil.newDto(new DfFlowAuthorizerMapping(), dfd);
    dad.setItemValue(DfAuthorizerDto.AUTHORIZER, uid);
    dad.setItemValue(DfAuthorizerDto.AUTHORIZER_KUBUN, kbn.getVal());
    dad.setItemValue(DfAuthorizerDto.DATE_REQUEST, DateUtil.getDate());
    dad.setItemValue(DfAuthorizerDto.TIME_REQUEST, DateUtil.getTime());
    dad.setItemValue(DfAuthorizerDto.STATUS, AUTHORIZER_STATUS.CHECKING.getVal());
    dad.setItemValue(DfAuthorizerDto.LEVEL, addOne(dfd.getItemValue(DocumentFlowDto.STATUS)));
    dad.setItemValue(DfAuthorizerDto.NOTIFICATION, NOTIFICATION.INITIAL.getVal());
    try {
      _daa.regist(dad);
    } catch (Exception ex) {
      ex.printStackTrace();
      return false;
    }
    return true;
  }
  private int copyAuthorizer(DocumentFlowDto dfd, AUTHORIZER_KUBUN kbn) throws Exception {
    BaseAuthorizerSearchDto basd = new BaseAuthorizerSearchDto();
    basd.setSysId(dfd.getSysId());
    basd.setRetrieveValue(BaseAuthorizerSearchDto.FLOW_NO, dfd.getItemValue(DocumentFlowDto.FLOW_NO));
    basd.setRetrieveValue(BaseAuthorizerSearchDto.LEVEL, addOne(dfd.getItemValue(DocumentFlowDto.STATUS)));
    basd.setRetrieveValue(BaseAuthorizerSearchDto.AUTHORIZER_KUBUN, kbn.getVal());
    basd = (BaseAuthorizerSearchDto)_baa.find(basd);
    int dcnt = 0;
    for (List<String> keys : basd.getKeys()) {
      if (USER_KUBUN.GROUP.getVal().equals(keys.get(3))) {
        List<String> uids = _scu.getUserInGP(keys.get(4));
        for (String uid : uids) {
          if (addNewDfAuthorizer(dfd, uid, AUTHORIZER_KUBUN.AUTHORIZE)) dcnt++;
        }
      } else {
        if (addNewDfAuthorizer(dfd, keys.get(4), kbn)) dcnt++;
      }
    }
    return dcnt;
  }
  
}
