package com.hamaf.business.workflow.ui;

import java.util.Map;

import com.hamaf.business.workflow.access.DfAuthorizerAccess.AUTHORIZER_STATUS;
import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFApprovalList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ApprovalList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;

  /**
   * Creates a new <code>ApprovalList</code> instance.
   * <br>Default Constructor
   */
  public ApprovalList() {
    _jim = new VDfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dfp.getAuthorizerDetail((VDfAuthorizerDto)dii);
  }

  private final String REQ_STVAL = "stval";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    mp.put(REQ_STVAL, mxc.getTagValue("authorizerStatus",
        dii.getItemValue(VDfAuthorizerDto.STATUS), "authorizerStatusName"));
    return mp;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dfp.findAuthorize((VDfAuthorizerSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDfAuthorizerSearchDto vdasd = new VDfAuthorizerSearchDto();
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER, getUserID());
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER_KUBUN, "C");
    String kbn = klst.getRetrieve("skbn");
    if (kbn.equals("A")) {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, "'E','N','P'");
      vdasd.setCondition(VDfAuthorizerSearchDto.STATUS, "in");
      
    } else {
      if (kbn.length() == 0) kbn = AUTHORIZER_STATUS.CHECKING.getVal();
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, kbn);
    }
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.APPLICANT_NAME,
        klst.getRetrieve("sname"));
    vdasd.setCondition(VDfAuthorizerSearchDto.APPLICANT_NAME, "like");
    
    vdasd.setOrderItem(VDfAuthorizerSearchDto.STATUS, 1);
    if (kbn.equals(AUTHORIZER_STATUS.CHECKING.getVal())) {
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, 2);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, 3);
    } else {
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_APPROVAL, -2);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_APPROVAL, -3);
    }
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_ID, 4);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_NO, 5);
    return vdasd;
  }

}
