package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFApproveDetail is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ApproveDetail extends StandardDetailProcess {

  private DocumentFlowProcess _dfp = null;
  
  private String _kbn = null;
  private String _name = null;
  
  /**
   * Creates a new <code>ApproveDetail</code> instance.
   * <br>Default Constructor
   */
  public ApproveDetail() {
    _jim = new VDfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    VDfAuthorizerDto vdad = (VDfAuthorizerDto)dii;
    vdad = _dfp.getAuthorizerDetail(vdad);
    _name = vdad.getName();
    if (_dfp.isLastAuthorizer(vdad)) {
      _kbn = "1";
    } else {
      _kbn = "0";
    }
    return vdad;
  }

  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    dii.setItemValue(VDfAuthorizerDto.DOCUMENT_NO, msg.getReqStr("docNo"));
    dii.setItemValue(VDfAuthorizerDto.AUTHORIZER, msg.getReqStr("authorizer"));
    return true;
  }

  private final String MSG_NAME = "aName";
  private final String MSG_LAST = "isLast";
  @Override
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    msg.setResMsg(MSG_NAME, _name);
    msg.setResMsg(MSG_LAST, _kbn);
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

}
