package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.VDocumentFlowDto;
import com.hamaf.business.workflow.dto.VDocumentInfDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.process.DocumentInfProcesss;
import com.hamaf.business.workflow.ui.mapping.VDocInfMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.distribute.DistributeServlet.SVAL;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFDocInfDetail is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DocInfDetail extends StandardDetailProcess {

  private DocumentInfProcesss _dip = null;
  private DocumentFlowProcess _dfp = null;
  
  /**
   * Creates a new <code>DocInfDetail</code> instance.
   * <br>Default Constructor
   */
  public DocInfDetail() {
    _jim = new VDocInfMap();
    _dip = new DocumentInfProcesss();
    _dfp = new DocumentFlowProcess();
  }

  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String proc = msg.getReqStr(SVAL.ProcId.getValue());
    if (proc.equals("approval")) {
      String doc = msg.getReqStr("docId");
      if (doc.length() > 0) {
        dii.setItemValue(VDocumentInfDto.DOCUMENT_ID, doc);
      } else {
        msg.setErrorStatus(STATUS.WARNING);
        msg.addMessage("IDw肪Ă܂B");
      }
      return true;
    }
    return false;
  }

  @Override
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    String dno = msg.getReqStr("docNo");
    if (dno.length() == 0) return msg;
    VDocumentFlowDto vdfd = new VDocumentFlowDto();
    vdfd.setSysId(sysId);
    vdfd.setItemValue(VDocumentFlowDto.DOCUMENT_NO, dno);
    vdfd.setRequestItem(VDocumentFlowDto.STATUS);
    vdfd.setRequestItem(VDocumentFlowDto.RESULT);
    vdfd.setRequestItem(VDocumentFlowDto.COMMENT);
    vdfd = _dfp.getDocInf(vdfd);
    msg.setResMsg("sts", vdfd.getItemValue(VDocumentFlowDto.STATUS));
    msg.setResMsg("result", vdfd.getItemValue(VDocumentFlowDto.RESULT));
    msg.setResMsg("comment", vdfd.getItemValue(VDocumentFlowDto.COMMENT));
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    String doc = dii.getItemValue(VDocumentInfDto.DOCUMENT_ID);
    if (doc == null || doc.length() == 0) return dii;
    return _dip.getDetail((VDocumentInfDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDocumentInfDto();
  }

}
