package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.VDocumentInfDto;
import com.hamaf.business.workflow.dto.VDocumentInfSearchDto;
import com.hamaf.business.workflow.process.DocumentInfProcesss;
import com.hamaf.business.workflow.ui.mapping.VDocInfMap;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFDocInfList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DocInfList extends StandardListProcess {

  private DocumentInfProcesss _dip = null;
  
  /**
   * Creates a new <code>DocInfList</code> instance.
   * <br>Default Constructor
   */
  public DocInfList() {
    _jim = new VDocInfMap();
    _dip = new DocumentInfProcesss();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dip.getDetail((VDocumentInfDto)dii);
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ddt = {"docName", MSG_DEL};
      return ddt;
    }
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dip.find((VDocumentInfSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDocumentInfDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDocumentInfSearchDto disd = new VDocumentInfSearchDto();
    disd.setOrderItem(VDocumentInfSearchDto.DOCUMENT_ID, 1);
    disd.setRetrieveValue(VDocumentInfSearchDto.DOCUMENT_ID, klst.getRetrieve("sid"));
    disd.setCondition(VDocumentInfSearchDto.DOCUMENT_ID, "like");
    String val = klst.getRetrieve("sname");
    if (val != null && val.length() > 0) {
      disd.setRetrieveValue(VDocumentInfSearchDto.DOCUMENT_NAME, "%" + val + "%");
      disd.setCondition(VDocumentInfSearchDto.DOCUMENT_NAME, "like");
    }
    return disd;
  }

}
