package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.access.BaseLevelAccess.AUTHORIZER_KUBUN;
import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFNotificationList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/15</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NotificationList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;

  /**
   * Creates a new <code>NotificationList</code> instance.
   * <br>Default Constructor
   */
  public NotificationList() {
    _jim = new VDfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    VDfAuthorizerDto vdad = (VDfAuthorizerDto)dii;
    vdad = (VDfAuthorizerDto)_dfp.getAuthorizerDetail(vdad);
    if (vdad.getItemValue(VDfAuthorizerDto.NOTIFICATION_DATE).length() == 0) {
      vdad.setItemValue(VDfAuthorizerDto.NOTIFICATION_DATE,
          vdad.getItemValue(VDfAuthorizerDto.DATE_REQUEST));
    }
    return vdad;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dfp.findAuthorize((VDfAuthorizerSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDfAuthorizerSearchDto vdasd = new VDfAuthorizerSearchDto();
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER, getUserID());
    String kbn = klst.getRetrieve("snotif");
    if (kbn.equals("S")) {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.NOTIFICATION, "S");
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, -1);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, -2);
    } else if (kbn.equals("Q")) {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.NOTIFICATION.getVal());
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, "E");
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, 1);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, 2);
    } else if (kbn.equals("E")) {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.NOTIFICATION, "E");
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, -1);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, -2);
    } else {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.NOTIFICATION.getVal());
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, "C");
      vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, 1);
      vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, 2);
    }
    String val = klst.getRetrieve("sname");
    if (val != null && val.length() > 0) {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.DOCUMENT_NAME, "%" + val + "%");
      vdasd.setCondition(VDfAuthorizerSearchDto.DOCUMENT_NAME, "like");
    }
    
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_ID, 3);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_NO, 4);
    return vdasd;
  }

}
