package com.hamaf.business.workflow.ui;

import java.util.Map;

import com.hamaf.business.workflow.access.BaseLevelAccess.AUTHORIZER_KUBUN;
import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.dto.VDocumentFlowDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.business.workflow.ui.mapping.VDocumentFlowMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFStatusList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/24</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class StatusList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;
  private MasterXmlControl _mxc = null;
  
  /**
   * Creates a new <code>StatusList</code> instance.
   * <br>Default Constructor
   */
  public StatusList() {
    _jim = new VDfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dfp.getAuthorizerDetail((VDfAuthorizerDto)dii);
  }

  private final String MSG_NAME = "aName";
  private final String MSG_STATUS = "dspSts";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> ldt) throws Exception {
    ldt.put(MSG_NAME, ((VDfAuthorizerDto)dii).getName());
    _mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    ldt.put(MSG_STATUS,
        _mxc.getTagValue("authorizerStatus", dii.getItemValue(VDfAuthorizerDto.STATUS), "authorizerStatusName"));
    return ldt;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dfp.findAuthorize((VDfAuthorizerSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDfAuthorizerSearchDto vdasd = new VDfAuthorizerSearchDto();
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.DOCUMENT_NO, klst.getRetrieve("docNo"));
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.AUTHORIZE.getVal());
    vdasd.setOrderItem(VDfAuthorizerSearchDto.LEVEL, 1);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_APPROVAL, 2);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_APPROVAL, 3);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.AUTHORIZER, 4);
    return vdasd;
  }

  @Override
  protected CommonMessage supplementEdit(CommonMessage msg, KeyList klst,
      String pact) throws Exception {
    VDocumentFlowDto vdfd = new VDocumentFlowDto();
    vdfd.setSysId(sysId);
    vdfd.setItemValue(VDocumentFlowDto.DOCUMENT_NO, klst.getRetrieve("docNo"));
    vdfd.setAllRequest();
    vdfd = _dfp.getDocInf(vdfd);
    if (vdfd.isNotFound()) return msg;
    return setItems(msg, vdfd);
  }
  private CommonMessage setItems(CommonMessage msg, VDocumentFlowDto vdfd) {
    VDocumentFlowMapping vdfm = new VDocumentFlowMapping();
    for (String fld : vdfm) {
      msg.setResMsg(fld, vdfd.getItemValue(vdfm.getDtoNo(fld)));
    }

    for (COMMFLD fld : COMMFLD.values()) {
      msg.setResMsg(fld.getVal(), vdfd.getCommFld(fld));
    }
    return msg;
  }

}
